part of '../main.dart';

class MaterialDesignIcons {
  static final Map defaultIconsByDomains = {
    "light": "mdi:lightbulb",
    "switch": "mdi:flash",
    "binary_sensor": "mdi:checkbox-blank-circle-outline",
    "group": "mdi:google-circles-communities",
    "sensor": "mdi:eye",
    "automation": "mdi:robot",
    "script": "mdi:script-text",
    "input_boolean": "mdi:toggle-switch-outline",
    "input_datetime": "mdi:clock",
    "input_number": "mdi:ray-vertex",
    "input_select": "mdi:format-list-bulleted",
    "input_text": "mdi:textbox",
    "sun": "mdi:white-balance-sunny",
    "scene": "mdi:google-pages",
    "media_player": "mdi:cast",
    "climate": "mdi:thermostat",
    "cover.open": "mdi:window-open",
    "cover.closed": "mdi:window-closed",
    "cover.closing": "mdi:window-open",
    "cover.opening": "mdi:window-open",
    "camera": "mdi:cctv",
    "calendar": "mdi:calendar",
    "device_tracker": "mdi:account",
    "timer": "mdi:timer",
    "lock.locked": "mdi:lock",
    "lock.unlocked": "mdi:lock-open",
    "fan": "mdi:fan",
    "remote": "mdi:remote",
    "alarm_control_panel.disarmed" : "mdi:bell-outline",
    "alarm_control_panel.armed_home" : "mdi:bell-plus",
    "alarm_control_panel.armed_away" : "mdi:bell",
    "alarm_control_panel.armed_night" : "mdi:bell-sleep",
    "alarm_control_panel.armed_custom_bypass" : "mdi:bell",
    "alarm_control_panel.triggered" : "mdi:bell-ring",
    "alarm_control_panel" : "mdi:bell",
    "updater": "mdi:cloud-upload",
    "vacuum": "mdi:robot-vacuum"
  };

  static final Map defaultIconsByDeviceClass = {
    //"binary_sensor.battery": "mdi:", //TODO
    "binary_sensor.cold.on": "mdi:snowflake",
    "binary_sensor.cold.off": "mdi:thermometer",
    "binary_sensor.connectivity.on": "mdi:server-network",
    "binary_sensor.connectivity.off": "mdi:server-network-off",
    "binary_sensor.door.on": "mdi:door-open",
    "binary_sensor.door.off": "mdi:door-closed",
    //"binary_sensor.garage_door": "mdi:",
    //"binary_sensor.gas": "mdi:",
    "binary_sensor.heat.on": "mdi:fire",
    "binary_sensor.heat.off": "mdi:thermometer",
    "binary_sensor.light.on": "mdi:brightness-7",
    "binary_sensor.light.off": "mdi:brightness-5",
    "binary_sensor.lock.on": "mdi:lock-open",
    "binary_sensor.lock.off": "mdi:lock",
    "binary_sensor.moisture.on": "mdi:water",
    "binary_sensor.moisture.off": "mdi:water-off",
    "binary_sensor.motion.on": "mdi:run",
    "binary_sensor.motion.off": "mdi:walk",
    "binary_sensor.moving.on": "mdi:checkbox-marked-circle",
    "binary_sensor.moving.off": "mdi:checkbox-blank-circle-outline",
    "binary_sensor.occupancy.on": "mdi:home",
    "binary_sensor.occupancy.off": "mdi:home-outline",
    "binary_sensor.opening.on": "mdi:square-outline",
    "binary_sensor.opening.off": "mdi:square",
    "binary_sensor.plug.on": "mdi:power-plug",
    "binary_sensor.plug.off": "mdi:power-plug-off",
    "binary_sensor.power.on": "mdi:alert",
    "binary_sensor.power.off": "mdi:shield-check",
    //"binary_sensor.presence.on": "mdi:",
    //"binary_sensor.presence.off": "mdi:",
    "binary_sensor.problem.on": "mdi:alert-outline",
    "binary_sensor.problem.off": "mdi:check-outline",
    "binary_sensor.safety.on": "mdi:alert",
    "binary_sensor.safety.off": "mdi:shield-check",
    "binary_sensor.smoke.on": "mdi:alert",
    "binary_sensor.smoke.off": "mdi:shield-check",
    "binary_sensor.sound.on": "mdi:music-note",
    "binary_sensor.sound.off": "mdi:music-note-off",
    "binary_sensor.vibration.on": "mdi:vibrate",
    "binary_sensor.vibration.off": "mdi:mdi-crop-portrait",
    "binary_sensor.window.on": "mdi:window-open",
    "binary_sensor.window.off": "mdi:window-closed",
    "sensor.battery": "mdi:battery-80",
    "sensor.humidity": "mdi:water-percent",
    //"sensor.illuminance": "mdi:",
    "sensor.temperature": "mdi:thermometer",
    "cover.window": "mdi:mdi:window-closed",
    "cover.garage.closed": "mdi:garage",
    "cover.garage.open": "mdi:garage-open",
    "cover.garage.opening": "mdi:garage-open",
    "cover.garage.closing": "mdi:garage-open",
    "cover.window.open": "mdi:window-open",
    "cover.window.closed": "mdi:window-closed",
    "cover.window.closing": "mdi:window-open",
    "cover.window.opening": "mdi:window-open",
  };

  static final Map iconsDataMap = {
    "mdi:ab-testing": 0xF001C,
    "mdi:access-point": 0xF002,
    "mdi:access-point-network": 0xF003,
    "mdi:access-point-network-off": 0xFBBD,
    "mdi:account": 0xF004,
    "mdi:account-alert": 0xF005,
    "mdi:account-alert-outline": 0xFB2C,
    "mdi:account-arrow-left": 0xFB2D,
    "mdi:account-arrow-left-outline": 0xFB2E,
    "mdi:account-arrow-right": 0xFB2F,
    "mdi:account-arrow-right-outline": 0xFB30,
    "mdi:account-badge": 0xFD83,
    "mdi:account-badge-alert": 0xFD84,
    "mdi:account-badge-alert-outline": 0xFD85,
    "mdi:account-badge-horizontal": 0xFDF0,
    "mdi:account-badge-horizontal-outline": 0xFDF1,
    "mdi:account-badge-outline": 0xFD86,
    "mdi:account-box": 0xF006,
    "mdi:account-box-multiple": 0xF933,
    "mdi:account-box-multiple-outline": 0xF002C,
    "mdi:account-box-outline": 0xF007,
    "mdi:account-card-details": 0xF5D2,
    "mdi:account-card-details-outline": 0xFD87,
    "mdi:account-cash": 0xF00C2,
    "mdi:account-cash-outline": 0xF00C3,
    "mdi:account-check": 0xF008,
    "mdi:account-check-outline": 0xFBBE,
    "mdi:account-child": 0xFA88,
    "mdi:account-child-circle": 0xFA89,
    "mdi:account-child-outline": 0xF00F3,
    "mdi:account-circle": 0xF009,
    "mdi:account-circle-outline": 0xFB31,
    "mdi:account-clock": 0xFB32,
    "mdi:account-clock-outline": 0xFB33,
    "mdi:account-convert": 0xF00A,
    "mdi:account-details": 0xF631,
    "mdi:account-edit": 0xF6BB,
    "mdi:account-edit-outline": 0xF001D,
    "mdi:account-group": 0xF848,
    "mdi:account-group-outline": 0xFB34,
    "mdi:account-heart": 0xF898,
    "mdi:account-heart-outline": 0xFBBF,
    "mdi:account-key": 0xF00B,
    "mdi:account-key-outline": 0xFBC0,
    "mdi:account-lock": 0xF0189,
    "mdi:account-lock-outline": 0xF018A,
    "mdi:account-minus": 0xF00D,
    "mdi:account-minus-outline": 0xFAEB,
    "mdi:account-multiple": 0xF00E,
    "mdi:account-multiple-check": 0xF8C4,
    "mdi:account-multiple-minus": 0xF5D3,
    "mdi:account-multiple-minus-outline": 0xFBC1,
    "mdi:account-multiple-outline": 0xF00F,
    "mdi:account-multiple-plus": 0xF010,
    "mdi:account-multiple-plus-outline": 0xF7FF,
    "mdi:account-network": 0xF011,
    "mdi:account-network-outline": 0xFBC2,
    "mdi:account-off": 0xF012,
    "mdi:account-off-outline": 0xFBC3,
    "mdi:account-outline": 0xF013,
    "mdi:account-plus": 0xF014,
    "mdi:account-plus-outline": 0xF800,
    "mdi:account-question": 0xFB35,
    "mdi:account-question-outline": 0xFB36,
    "mdi:account-remove": 0xF015,
    "mdi:account-remove-outline": 0xFAEC,
    "mdi:account-search": 0xF016,
    "mdi:account-search-outline": 0xF934,
    "mdi:account-settings": 0xF630,
    "mdi:account-settings-outline": 0xF00F4,
    "mdi:account-star": 0xF017,
    "mdi:account-star-outline": 0xFBC4,
    "mdi:account-supervisor": 0xFA8A,
    "mdi:account-supervisor-circle": 0xFA8B,
    "mdi:account-supervisor-outline": 0xF0158,
    "mdi:account-switch": 0xF019,
    "mdi:account-tie": 0xFCBF,
    "mdi:account-tie-outline": 0xF00F5,
    "mdi:accusoft": 0xF849,
    "mdi:adchoices": 0xFD1E,
    "mdi:adjust": 0xF01A,
    "mdi:adobe": 0xF935,
    "mdi:adobe-acrobat": 0xFFBD,
    "mdi:air-conditioner": 0xF01B,
    "mdi:air-filter": 0xFD1F,
    "mdi:air-horn": 0xFD88,
    "mdi:air-humidifier": 0xF00C4,
    "mdi:air-purifier": 0xFD20,
    "mdi:airbag": 0xFBC5,
    "mdi:airballoon": 0xF01C,
    "mdi:airballoon-outline": 0xF002D,
    "mdi:airplane": 0xF01D,
    "mdi:airplane-landing": 0xF5D4,
    "mdi:airplane-off": 0xF01E,
    "mdi:airplane-takeoff": 0xF5D5,
    "mdi:airplay": 0xF01F,
    "mdi:airport": 0xF84A,
    "mdi:alarm": 0xF020,
    "mdi:alarm-bell": 0xF78D,
    "mdi:alarm-check": 0xF021,
    "mdi:alarm-light": 0xF78E,
    "mdi:alarm-light-outline": 0xFBC6,
    "mdi:alarm-multiple": 0xF022,
    "mdi:alarm-note": 0xFE8E,
    "mdi:alarm-note-off": 0xFE8F,
    "mdi:alarm-off": 0xF023,
    "mdi:alarm-plus": 0xF024,
    "mdi:alarm-snooze": 0xF68D,
    "mdi:album": 0xF025,
    "mdi:alert": 0xF026,
    "mdi:alert-box": 0xF027,
    "mdi:alert-box-outline": 0xFCC0,
    "mdi:alert-circle": 0xF028,
    "mdi:alert-circle-check": 0xF0218,
    "mdi:alert-circle-check-outline": 0xF0219,
    "mdi:alert-circle-outline": 0xF5D6,
    "mdi:alert-decagram": 0xF6BC,
    "mdi:alert-decagram-outline": 0xFCC1,
    "mdi:alert-octagon": 0xF029,
    "mdi:alert-octagon-outline": 0xFCC2,
    "mdi:alert-octagram": 0xF766,
    "mdi:alert-octagram-outline": 0xFCC3,
    "mdi:alert-outline": 0xF02A,
    "mdi:alert-rhombus": 0xF01F9,
    "mdi:alert-rhombus-outline": 0xF01FA,
    "mdi:alien": 0xF899,
    "mdi:alien-outline": 0xF00F6,
    "mdi:align-horizontal-center": 0xF01EE,
    "mdi:align-horizontal-left": 0xF01ED,
    "mdi:align-horizontal-right": 0xF01EF,
    "mdi:align-vertical-bottom": 0xF01F0,
    "mdi:align-vertical-center": 0xF01F1,
    "mdi:align-vertical-top": 0xF01F2,
    "mdi:all-inclusive": 0xF6BD,
    "mdi:alpha": 0xF02B,
    "mdi:alpha-a": 0x0041,
    "mdi:alpha-a-box": 0xFAED,
    "mdi:alpha-a-box-outline": 0xFBC7,
    "mdi:alpha-a-circle": 0xFBC8,
    "mdi:alpha-a-circle-outline": 0xFBC9,
    "mdi:alpha-b": 0x0042,
    "mdi:alpha-b-box": 0xFAEE,
    "mdi:alpha-b-box-outline": 0xFBCA,
    "mdi:alpha-b-circle": 0xFBCB,
    "mdi:alpha-b-circle-outline": 0xFBCC,
    "mdi:alpha-c": 0x0043,
    "mdi:alpha-c-box": 0xFAEF,
    "mdi:alpha-c-box-outline": 0xFBCD,
    "mdi:alpha-c-circle": 0xFBCE,
    "mdi:alpha-c-circle-outline": 0xFBCF,
    "mdi:alpha-d": 0x0044,
    "mdi:alpha-d-box": 0xFAF0,
    "mdi:alpha-d-box-outline": 0xFBD0,
    "mdi:alpha-d-circle": 0xFBD1,
    "mdi:alpha-d-circle-outline": 0xFBD2,
    "mdi:alpha-e": 0x0045,
    "mdi:alpha-e-box": 0xFAF1,
    "mdi:alpha-e-box-outline": 0xFBD3,
    "mdi:alpha-e-circle": 0xFBD4,
    "mdi:alpha-e-circle-outline": 0xFBD5,
    "mdi:alpha-f": 0x0046,
    "mdi:alpha-f-box": 0xFAF2,
    "mdi:alpha-f-box-outline": 0xFBD6,
    "mdi:alpha-f-circle": 0xFBD7,
    "mdi:alpha-f-circle-outline": 0xFBD8,
    "mdi:alpha-g": 0x0047,
    "mdi:alpha-g-box": 0xFAF3,
    "mdi:alpha-g-box-outline": 0xFBD9,
    "mdi:alpha-g-circle": 0xFBDA,
    "mdi:alpha-g-circle-outline": 0xFBDB,
    "mdi:alpha-h": 0x0048,
    "mdi:alpha-h-box": 0xFAF4,
    "mdi:alpha-h-box-outline": 0xFBDC,
    "mdi:alpha-h-circle": 0xFBDD,
    "mdi:alpha-h-circle-outline": 0xFBDE,
    "mdi:alpha-i": 0x0049,
    "mdi:alpha-i-box": 0xFAF5,
    "mdi:alpha-i-box-outline": 0xFBDF,
    "mdi:alpha-i-circle": 0xFBE0,
    "mdi:alpha-i-circle-outline": 0xFBE1,
    "mdi:alpha-j": 0x004A,
    "mdi:alpha-j-box": 0xFAF6,
    "mdi:alpha-j-box-outline": 0xFBE2,
    "mdi:alpha-j-circle": 0xFBE3,
    "mdi:alpha-j-circle-outline": 0xFBE4,
    "mdi:alpha-k": 0x004B,
    "mdi:alpha-k-box": 0xFAF7,
    "mdi:alpha-k-box-outline": 0xFBE5,
    "mdi:alpha-k-circle": 0xFBE6,
    "mdi:alpha-k-circle-outline": 0xFBE7,
    "mdi:alpha-l": 0x004C,
    "mdi:alpha-l-box": 0xFAF8,
    "mdi:alpha-l-box-outline": 0xFBE8,
    "mdi:alpha-l-circle": 0xFBE9,
    "mdi:alpha-l-circle-outline": 0xFBEA,
    "mdi:alpha-m": 0x004D,
    "mdi:alpha-m-box": 0xFAF9,
    "mdi:alpha-m-box-outline": 0xFBEB,
    "mdi:alpha-m-circle": 0xFBEC,
    "mdi:alpha-m-circle-outline": 0xFBED,
    "mdi:alpha-n": 0x004E,
    "mdi:alpha-n-box": 0xFAFA,
    "mdi:alpha-n-box-outline": 0xFBEE,
    "mdi:alpha-n-circle": 0xFBEF,
    "mdi:alpha-n-circle-outline": 0xFBF0,
    "mdi:alpha-o": 0x004F,
    "mdi:alpha-o-box": 0xFAFB,
    "mdi:alpha-o-box-outline": 0xFBF1,
    "mdi:alpha-o-circle": 0xFBF2,
    "mdi:alpha-o-circle-outline": 0xFBF3,
    "mdi:alpha-p": 0x0050,
    "mdi:alpha-p-box": 0xFAFC,
    "mdi:alpha-p-box-outline": 0xFBF4,
    "mdi:alpha-p-circle": 0xFBF5,
    "mdi:alpha-p-circle-outline": 0xFBF6,
    "mdi:alpha-q": 0x0051,
    "mdi:alpha-q-box": 0xFAFD,
    "mdi:alpha-q-box-outline": 0xFBF7,
    "mdi:alpha-q-circle": 0xFBF8,
    "mdi:alpha-q-circle-outline": 0xFBF9,
    "mdi:alpha-r": 0x0052,
    "mdi:alpha-r-box": 0xFAFE,
    "mdi:alpha-r-box-outline": 0xFBFA,
    "mdi:alpha-r-circle": 0xFBFB,
    "mdi:alpha-r-circle-outline": 0xFBFC,
    "mdi:alpha-s": 0x0053,
    "mdi:alpha-s-box": 0xFAFF,
    "mdi:alpha-s-box-outline": 0xFBFD,
    "mdi:alpha-s-circle": 0xFBFE,
    "mdi:alpha-s-circle-outline": 0xFBFF,
    "mdi:alpha-t": 0x0054,
    "mdi:alpha-t-box": 0xFB00,
    "mdi:alpha-t-box-outline": 0xFC00,
    "mdi:alpha-t-circle": 0xFC01,
    "mdi:alpha-t-circle-outline": 0xFC02,
    "mdi:alpha-u": 0x0055,
    "mdi:alpha-u-box": 0xFB01,
    "mdi:alpha-u-box-outline": 0xFC03,
    "mdi:alpha-u-circle": 0xFC04,
    "mdi:alpha-u-circle-outline": 0xFC05,
    "mdi:alpha-v": 0x0056,
    "mdi:alpha-v-box": 0xFB02,
    "mdi:alpha-v-box-outline": 0xFC06,
    "mdi:alpha-v-circle": 0xFC07,
    "mdi:alpha-v-circle-outline": 0xFC08,
    "mdi:alpha-w": 0x0057,
    "mdi:alpha-w-box": 0xFB03,
    "mdi:alpha-w-box-outline": 0xFC09,
    "mdi:alpha-w-circle": 0xFC0A,
    "mdi:alpha-w-circle-outline": 0xFC0B,
    "mdi:alpha-x": 0x0058,
    "mdi:alpha-x-box": 0xFB04,
    "mdi:alpha-x-box-outline": 0xFC0C,
    "mdi:alpha-x-circle": 0xFC0D,
    "mdi:alpha-x-circle-outline": 0xFC0E,
    "mdi:alpha-y": 0x0059,
    "mdi:alpha-y-box": 0xFB05,
    "mdi:alpha-y-box-outline": 0xFC0F,
    "mdi:alpha-y-circle": 0xFC10,
    "mdi:alpha-y-circle-outline": 0xFC11,
    "mdi:alpha-z": 0x005A,
    "mdi:alpha-z-box": 0xFB06,
    "mdi:alpha-z-box-outline": 0xFC12,
    "mdi:alpha-z-circle": 0xFC13,
    "mdi:alpha-z-circle-outline": 0xFC14,
    "mdi:alphabetical": 0xF02C,
    "mdi:alphabetical-off": 0xF002E,
    "mdi:alphabetical-variant": 0xF002F,
    "mdi:alphabetical-variant-off": 0xF0030,
    "mdi:altimeter": 0xF5D7,
    "mdi:amazon": 0xF02D,
    "mdi:amazon-alexa": 0xF8C5,
    "mdi:amazon-drive": 0xF02E,
    "mdi:ambulance": 0xF02F,
    "mdi:ammunition": 0xFCC4,
    "mdi:ampersand": 0xFA8C,
    "mdi:amplifier": 0xF030,
    "mdi:amplifier-off": 0xF01E0,
    "mdi:anchor": 0xF031,
    "mdi:android": 0xF032,
    "mdi:android-auto": 0xFA8D,
    "mdi:android-debug-bridge": 0xF033,
    "mdi:android-head": 0xF78F,
    "mdi:android-messages": 0xFD21,
    "mdi:android-studio": 0xF034,
    "mdi:angle-acute": 0xF936,
    "mdi:angle-obtuse": 0xF937,
    "mdi:angle-right": 0xF938,
    "mdi:angular": 0xF6B1,
    "mdi:angularjs": 0xF6BE,
    "mdi:animation": 0xF5D8,
    "mdi:animation-outline": 0xFA8E,
    "mdi:animation-play": 0xF939,
    "mdi:animation-play-outline": 0xFA8F,
    "mdi:ansible": 0xF00C5,
    "mdi:antenna": 0xF0144,
    "mdi:anvil": 0xF89A,
    "mdi:apache-kafka": 0xF0031,
    "mdi:api": 0xF00C6,
    "mdi:apple": 0xF035,
    "mdi:apple-finder": 0xF036,
    "mdi:apple-icloud": 0xF038,
    "mdi:apple-ios": 0xF037,
    "mdi:apple-keyboard-caps": 0xF632,
    "mdi:apple-keyboard-command": 0xF633,
    "mdi:apple-keyboard-control": 0xF634,
    "mdi:apple-keyboard-option": 0xF635,
    "mdi:apple-keyboard-shift": 0xF636,
    "mdi:apple-safari": 0xF039,
    "mdi:application": 0xF614,
    "mdi:application-export": 0xFD89,
    "mdi:application-import": 0xFD8A,
    "mdi:approximately-equal": 0xFFBE,
    "mdi:approximately-equal-box": 0xFFBF,
    "mdi:apps": 0xF03B,
    "mdi:apps-box": 0xFD22,
    "mdi:arch": 0xF8C6,
    "mdi:archive": 0xF03C,
    "mdi:arm-flex": 0xF008F,
    "mdi:arm-flex-outline": 0xF0090,
    "mdi:arrange-bring-forward": 0xF03D,
    "mdi:arrange-bring-to-front": 0xF03E,
    "mdi:arrange-send-backward": 0xF03F,
    "mdi:arrange-send-to-back": 0xF040,
    "mdi:arrow-all": 0xF041,
    "mdi:arrow-bottom-left": 0xF042,
    "mdi:arrow-bottom-left-bold-outline": 0xF9B6,
    "mdi:arrow-bottom-left-thick": 0xF9B7,
    "mdi:arrow-bottom-right": 0xF043,
    "mdi:arrow-bottom-right-bold-outline": 0xF9B8,
    "mdi:arrow-bottom-right-thick": 0xF9B9,
    "mdi:arrow-collapse": 0xF615,
    "mdi:arrow-collapse-all": 0xF044,
    "mdi:arrow-collapse-down": 0xF791,
    "mdi:arrow-collapse-horizontal": 0xF84B,
    "mdi:arrow-collapse-left": 0xF792,
    "mdi:arrow-collapse-right": 0xF793,
    "mdi:arrow-collapse-up": 0xF794,
    "mdi:arrow-collapse-vertical": 0xF84C,
    "mdi:arrow-decision": 0xF9BA,
    "mdi:arrow-decision-auto": 0xF9BB,
    "mdi:arrow-decision-auto-outline": 0xF9BC,
    "mdi:arrow-decision-outline": 0xF9BD,
    "mdi:arrow-down": 0xF045,
    "mdi:arrow-down-bold": 0xF72D,
    "mdi:arrow-down-bold-box": 0xF72E,
    "mdi:arrow-down-bold-box-outline": 0xF72F,
    "mdi:arrow-down-bold-circle": 0xF047,
    "mdi:arrow-down-bold-circle-outline": 0xF048,
    "mdi:arrow-down-bold-hexagon-outline": 0xF049,
    "mdi:arrow-down-bold-outline": 0xF9BE,
    "mdi:arrow-down-box": 0xF6BF,
    "mdi:arrow-down-circle": 0xFCB7,
    "mdi:arrow-down-circle-outline": 0xFCB8,
    "mdi:arrow-down-drop-circle": 0xF04A,
    "mdi:arrow-down-drop-circle-outline": 0xF04B,
    "mdi:arrow-down-thick": 0xF046,
    "mdi:arrow-expand": 0xF616,
    "mdi:arrow-expand-all": 0xF04C,
    "mdi:arrow-expand-down": 0xF795,
    "mdi:arrow-expand-horizontal": 0xF84D,
    "mdi:arrow-expand-left": 0xF796,
    "mdi:arrow-expand-right": 0xF797,
    "mdi:arrow-expand-up": 0xF798,
    "mdi:arrow-expand-vertical": 0xF84E,
    "mdi:arrow-horizontal-lock": 0xF0186,
    "mdi:arrow-left": 0xF04D,
    "mdi:arrow-left-bold": 0xF730,
    "mdi:arrow-left-bold-box": 0xF731,
    "mdi:arrow-left-bold-box-outline": 0xF732,
    "mdi:arrow-left-bold-circle": 0xF04F,
    "mdi:arrow-left-bold-circle-outline": 0xF050,
    "mdi:arrow-left-bold-hexagon-outline": 0xF051,
    "mdi:arrow-left-bold-outline": 0xF9BF,
    "mdi:arrow-left-box": 0xF6C0,
    "mdi:arrow-left-circle": 0xFCB9,
    "mdi:arrow-left-circle-outline": 0xFCBA,
    "mdi:arrow-left-drop-circle": 0xF052,
    "mdi:arrow-left-drop-circle-outline": 0xF053,
    "mdi:arrow-left-right": 0xFE90,
    "mdi:arrow-left-right-bold": 0xFE91,
    "mdi:arrow-left-right-bold-outline": 0xF9C0,
    "mdi:arrow-left-thick": 0xF04E,
    "mdi:arrow-right": 0xF054,
    "mdi:arrow-right-bold": 0xF733,
    "mdi:arrow-right-bold-box": 0xF734,
    "mdi:arrow-right-bold-box-outline": 0xF735,
    "mdi:arrow-right-bold-circle": 0xF056,
    "mdi:arrow-right-bold-circle-outline": 0xF057,
    "mdi:arrow-right-bold-hexagon-outline": 0xF058,
    "mdi:arrow-right-bold-outline": 0xF9C1,
    "mdi:arrow-right-box": 0xF6C1,
    "mdi:arrow-right-circle": 0xFCBB,
    "mdi:arrow-right-circle-outline": 0xFCBC,
    "mdi:arrow-right-drop-circle": 0xF059,
    "mdi:arrow-right-drop-circle-outline": 0xF05A,
    "mdi:arrow-right-thick": 0xF055,
    "mdi:arrow-split-horizontal": 0xF93A,
    "mdi:arrow-split-vertical": 0xF93B,
    "mdi:arrow-top-left": 0xF05B,
    "mdi:arrow-top-left-bold-outline": 0xF9C2,
    "mdi:arrow-top-left-bottom-right": 0xFE92,
    "mdi:arrow-top-left-bottom-right-bold": 0xFE93,
    "mdi:arrow-top-left-thick": 0xF9C3,
    "mdi:arrow-top-right": 0xF05C,
    "mdi:arrow-top-right-bold-outline": 0xF9C4,
    "mdi:arrow-top-right-bottom-left": 0xFE94,
    "mdi:arrow-top-right-bottom-left-bold": 0xFE95,
    "mdi:arrow-top-right-thick": 0xF9C5,
    "mdi:arrow-up": 0xF05D,
    "mdi:arrow-up-bold": 0xF736,
    "mdi:arrow-up-bold-box": 0xF737,
    "mdi:arrow-up-bold-box-outline": 0xF738,
    "mdi:arrow-up-bold-circle": 0xF05F,
    "mdi:arrow-up-bold-circle-outline": 0xF060,
    "mdi:arrow-up-bold-hexagon-outline": 0xF061,
    "mdi:arrow-up-bold-outline": 0xF9C6,
    "mdi:arrow-up-box": 0xF6C2,
    "mdi:arrow-up-circle": 0xFCBD,
    "mdi:arrow-up-circle-outline": 0xFCBE,
    "mdi:arrow-up-down": 0xFE96,
    "mdi:arrow-up-down-bold": 0xFE97,
    "mdi:arrow-up-down-bold-outline": 0xF9C7,
    "mdi:arrow-up-drop-circle": 0xF062,
    "mdi:arrow-up-drop-circle-outline": 0xF063,
    "mdi:arrow-up-thick": 0xF05E,
    "mdi:arrow-vertical-lock": 0xF0187,
    "mdi:artist": 0xF802,
    "mdi:artist-outline": 0xFCC5,
    "mdi:artstation": 0xFB37,
    "mdi:aspect-ratio": 0xFA23,
    "mdi:assistant": 0xF064,
    "mdi:asterisk": 0xF6C3,
    "mdi:at": 0xF065,
    "mdi:atlassian": 0xF803,
    "mdi:atm": 0xFD23,
    "mdi:atom": 0xF767,
    "mdi:atom-variant": 0xFE98,
    "mdi:attachment": 0xF066,
    "mdi:audio-video": 0xF93C,
    "mdi:audio-video-off": 0xF01E1,
    "mdi:audiobook": 0xF067,
    "mdi:augmented-reality": 0xF84F,
    "mdi:auto-fix": 0xF068,
    "mdi:auto-upload": 0xF069,
    "mdi:autorenew": 0xF06A,
    "mdi:av-timer": 0xF06B,
    "mdi:aws": 0xFDF2,
    "mdi:axe": 0xF8C7,
    "mdi:axis": 0xFD24,
    "mdi:axis-arrow": 0xFD25,
    "mdi:axis-arrow-lock": 0xFD26,
    "mdi:axis-lock": 0xFD27,
    "mdi:axis-x-arrow": 0xFD28,
    "mdi:axis-x-arrow-lock": 0xFD29,
    "mdi:axis-x-rotate-clockwise": 0xFD2A,
    "mdi:axis-x-rotate-counterclockwise": 0xFD2B,
    "mdi:axis-x-y-arrow-lock": 0xFD2C,
    "mdi:axis-y-arrow": 0xFD2D,
    "mdi:axis-y-arrow-lock": 0xFD2E,
    "mdi:axis-y-rotate-clockwise": 0xFD2F,
    "mdi:axis-y-rotate-counterclockwise": 0xFD30,
    "mdi:axis-z-arrow": 0xFD31,
    "mdi:axis-z-arrow-lock": 0xFD32,
    "mdi:axis-z-rotate-clockwise": 0xFD33,
    "mdi:axis-z-rotate-counterclockwise": 0xFD34,
    "mdi:azure": 0xF804,
    "mdi:azure-devops": 0xF0091,
    "mdi:babel": 0xFA24,
    "mdi:baby": 0xF06C,
    "mdi:baby-bottle": 0xFF56,
    "mdi:baby-bottle-outline": 0xFF57,
    "mdi:baby-carriage": 0xF68E,
    "mdi:baby-carriage-off": 0xFFC0,
    "mdi:baby-face": 0xFE99,
    "mdi:baby-face-outline": 0xFE9A,
    "mdi:backburger": 0xF06D,
    "mdi:backspace": 0xF06E,
    "mdi:backspace-outline": 0xFB38,
    "mdi:backspace-reverse": 0xFE9B,
    "mdi:backspace-reverse-outline": 0xFE9C,
    "mdi:backup-restore": 0xF06F,
    "mdi:bacteria": 0xFEF2,
    "mdi:bacteria-outline": 0xFEF3,
    "mdi:badminton": 0xF850,
    "mdi:bag-carry-on": 0xFF58,
    "mdi:bag-carry-on-check": 0xFD41,
    "mdi:bag-carry-on-off": 0xFF59,
    "mdi:bag-checked": 0xFF5A,
    "mdi:bag-personal": 0xFDF3,
    "mdi:bag-personal-off": 0xFDF4,
    "mdi:bag-personal-off-outline": 0xFDF5,
    "mdi:bag-personal-outline": 0xFDF6,
    "mdi:baguette": 0xFF5B,
    "mdi:balloon": 0xFA25,
    "mdi:ballot": 0xF9C8,
    "mdi:ballot-outline": 0xF9C9,
    "mdi:ballot-recount": 0xFC15,
    "mdi:ballot-recount-outline": 0xFC16,
    "mdi:bandage": 0xFD8B,
    "mdi:bandcamp": 0xF674,
    "mdi:bank": 0xF070,
    "mdi:bank-minus": 0xFD8C,
    "mdi:bank-outline": 0xFE9D,
    "mdi:bank-plus": 0xFD8D,
    "mdi:bank-remove": 0xFD8E,
    "mdi:bank-transfer": 0xFA26,
    "mdi:bank-transfer-in": 0xFA27,
    "mdi:bank-transfer-out": 0xFA28,
    "mdi:barcode": 0xF071,
    "mdi:barcode-scan": 0xF072,
    "mdi:barley": 0xF073,
    "mdi:barley-off": 0xFB39,
    "mdi:barn": 0xFB3A,
    "mdi:barrel": 0xF074,
    "mdi:baseball": 0xF851,
    "mdi:baseball-bat": 0xF852,
    "mdi:basecamp": 0xF075,
    "mdi:bash": 0xF01AE,
    "mdi:basket": 0xF076,
    "mdi:basket-fill": 0xF077,
    "mdi:basket-outline": 0xF01AC,
    "mdi:basket-unfill": 0xF078,
    "mdi:basketball": 0xF805,
    "mdi:basketball-hoop": 0xFC17,
    "mdi:basketball-hoop-outline": 0xFC18,
    "mdi:bat": 0xFB3B,
    "mdi:battery": 0xF079,
    "mdi:battery-10": 0xF07A,
    "mdi:battery-10-bluetooth": 0xF93D,
    "mdi:battery-20": 0xF07B,
    "mdi:battery-20-bluetooth": 0xF93E,
    "mdi:battery-30": 0xF07C,
    "mdi:battery-30-bluetooth": 0xF93F,
    "mdi:battery-40": 0xF07D,
    "mdi:battery-40-bluetooth": 0xF940,
    "mdi:battery-50": 0xF07E,
    "mdi:battery-50-bluetooth": 0xF941,
    "mdi:battery-60": 0xF07F,
    "mdi:battery-60-bluetooth": 0xF942,
    "mdi:battery-70": 0xF080,
    "mdi:battery-70-bluetooth": 0xF943,
    "mdi:battery-80": 0xF081,
    "mdi:battery-80-bluetooth": 0xF944,
    "mdi:battery-90": 0xF082,
    "mdi:battery-90-bluetooth": 0xF945,
    "mdi:battery-alert": 0xF083,
    "mdi:battery-alert-bluetooth": 0xF946,
    "mdi:battery-alert-variant": 0xF00F7,
    "mdi:battery-alert-variant-outline": 0xF00F8,
    "mdi:battery-bluetooth": 0xF947,
    "mdi:battery-bluetooth-variant": 0xF948,
    "mdi:battery-charging": 0xF084,
    "mdi:battery-charging-10": 0xF89B,
    "mdi:battery-charging-100": 0xF085,
    "mdi:battery-charging-20": 0xF086,
    "mdi:battery-charging-30": 0xF087,
    "mdi:battery-charging-40": 0xF088,
    "mdi:battery-charging-50": 0xF89C,
    "mdi:battery-charging-60": 0xF089,
    "mdi:battery-charging-70": 0xF89D,
    "mdi:battery-charging-80": 0xF08A,
    "mdi:battery-charging-90": 0xF08B,
    "mdi:battery-charging-outline": 0xF89E,
    "mdi:battery-charging-wireless": 0xF806,
    "mdi:battery-charging-wireless-10": 0xF807,
    "mdi:battery-charging-wireless-20": 0xF808,
    "mdi:battery-charging-wireless-30": 0xF809,
    "mdi:battery-charging-wireless-40": 0xF80A,
    "mdi:battery-charging-wireless-50": 0xF80B,
    "mdi:battery-charging-wireless-60": 0xF80C,
    "mdi:battery-charging-wireless-70": 0xF80D,
    "mdi:battery-charging-wireless-80": 0xF80E,
    "mdi:battery-charging-wireless-90": 0xF80F,
    "mdi:battery-charging-wireless-alert": 0xF810,
    "mdi:battery-charging-wireless-outline": 0xF811,
    "mdi:battery-minus": 0xF08C,
    "mdi:battery-negative": 0xF08D,
    "mdi:battery-outline": 0xF08E,
    "mdi:battery-plus": 0xF08F,
    "mdi:battery-positive": 0xF090,
    "mdi:battery-unknown": 0xF091,
    "mdi:battery-unknown-bluetooth": 0xF949,
    "mdi:battlenet": 0xFB3C,
    "mdi:beach": 0xF092,
    "mdi:beaker": 0xFCC6,
    "mdi:beaker-outline": 0xF68F,
    "mdi:beats": 0xF097,
    "mdi:bed-double": 0xF0092,
    "mdi:bed-double-outline": 0xF0093,
    "mdi:bed-empty": 0xF89F,
    "mdi:bed-king": 0xF0094,
    "mdi:bed-king-outline": 0xF0095,
    "mdi:bed-queen": 0xF0096,
    "mdi:bed-queen-outline": 0xF0097,
    "mdi:bed-single": 0xF0098,
    "mdi:bed-single-outline": 0xF0099,
    "mdi:bee": 0xFFC1,
    "mdi:bee-flower": 0xFFC2,
    "mdi:beehive-outline": 0xF00F9,
    "mdi:beer": 0xF098,
    "mdi:behance": 0xF099,
    "mdi:bell": 0xF09A,
    "mdi:bell-alert": 0xFD35,
    "mdi:bell-alert-outline": 0xFE9E,
    "mdi:bell-check": 0xF0210,
    "mdi:bell-check-outline": 0xF0211,
    "mdi:bell-circle": 0xFD36,
    "mdi:bell-circle-outline": 0xFD37,
    "mdi:bell-off": 0xF09B,
    "mdi:bell-off-outline": 0xFA90,
    "mdi:bell-outline": 0xF09C,
    "mdi:bell-plus": 0xF09D,
    "mdi:bell-plus-outline": 0xFA91,
    "mdi:bell-ring": 0xF09E,
    "mdi:bell-ring-outline": 0xF09F,
    "mdi:bell-sleep": 0xF0A0,
    "mdi:bell-sleep-outline": 0xFA92,
    "mdi:beta": 0xF0A1,
    "mdi:betamax": 0xF9CA,
    "mdi:biathlon": 0xFDF7,
    "mdi:bible": 0xF0A2,
    "mdi:bicycle": 0xF00C7,
    "mdi:bike": 0xF0A3,
    "mdi:bike-fast": 0xF014A,
    "mdi:billboard": 0xF0032,
    "mdi:billiards": 0xFB3D,
    "mdi:billiards-rack": 0xFB3E,
    "mdi:bing": 0xF0A4,
    "mdi:binoculars": 0xF0A5,
    "mdi:bio": 0xF0A6,
    "mdi:biohazard": 0xF0A7,
    "mdi:bitbucket": 0xF0A8,
    "mdi:bitcoin": 0xF812,
    "mdi:black-mesa": 0xF0A9,
    "mdi:blackberry": 0xF0AA,
    "mdi:blender": 0xFCC7,
    "mdi:blender-software": 0xF0AB,
    "mdi:blinds": 0xF0AC,
    "mdi:blinds-open": 0xF0033,
    "mdi:block-helper": 0xF0AD,
    "mdi:blogger": 0xF0AE,
    "mdi:blood-bag": 0xFCC8,
    "mdi:bluetooth": 0xF0AF,
    "mdi:bluetooth-audio": 0xF0B0,
    "mdi:bluetooth-connect": 0xF0B1,
    "mdi:bluetooth-off": 0xF0B2,
    "mdi:bluetooth-settings": 0xF0B3,
    "mdi:bluetooth-transfer": 0xF0B4,
    "mdi:blur": 0xF0B5,
    "mdi:blur-linear": 0xF0B6,
    "mdi:blur-off": 0xF0B7,
    "mdi:blur-radial": 0xF0B8,
    "mdi:bolnisi-cross": 0xFCC9,
    "mdi:bolt": 0xFD8F,
    "mdi:bomb": 0xF690,
    "mdi:bomb-off": 0xF6C4,
    "mdi:bone": 0xF0B9,
    "mdi:book": 0xF0BA,
    "mdi:book-information-variant": 0xF009A,
    "mdi:book-lock": 0xF799,
    "mdi:book-lock-open": 0xF79A,
    "mdi:book-minus": 0xF5D9,
    "mdi:book-minus-multiple": 0xFA93,
    "mdi:book-multiple": 0xF0BB,
    "mdi:book-open": 0xF0BD,
    "mdi:book-open-outline": 0xFB3F,
    "mdi:book-open-page-variant": 0xF5DA,
    "mdi:book-open-variant": 0xF0BE,
    "mdi:book-outline": 0xFB40,
    "mdi:book-play": 0xFE9F,
    "mdi:book-play-outline": 0xFEA0,
    "mdi:book-plus": 0xF5DB,
    "mdi:book-plus-multiple": 0xFA94,
    "mdi:book-remove": 0xFA96,
    "mdi:book-remove-multiple": 0xFA95,
    "mdi:book-search": 0xFEA1,
    "mdi:book-search-outline": 0xFEA2,
    "mdi:book-variant": 0xF0BF,
    "mdi:book-variant-multiple": 0xF0BC,
    "mdi:bookmark": 0xF0C0,
    "mdi:bookmark-check": 0xF0C1,
    "mdi:bookmark-minus": 0xF9CB,
    "mdi:bookmark-minus-outline": 0xF9CC,
    "mdi:bookmark-multiple": 0xFDF8,
    "mdi:bookmark-multiple-outline": 0xFDF9,
    "mdi:bookmark-music": 0xF0C2,
    "mdi:bookmark-off": 0xF9CD,
    "mdi:bookmark-off-outline": 0xF9CE,
    "mdi:bookmark-outline": 0xF0C3,
    "mdi:bookmark-plus": 0xF0C5,
    "mdi:bookmark-plus-outline": 0xF0C4,
    "mdi:bookmark-remove": 0xF0C6,
    "mdi:boom-gate": 0xFEA3,
    "mdi:boom-gate-alert": 0xFEA4,
    "mdi:boom-gate-alert-outline": 0xFEA5,
    "mdi:boom-gate-down": 0xFEA6,
    "mdi:boom-gate-down-outline": 0xFEA7,
    "mdi:boom-gate-outline": 0xFEA8,
    "mdi:boom-gate-up": 0xFEA9,
    "mdi:boom-gate-up-outline": 0xFEAA,
    "mdi:boombox": 0xF5DC,
    "mdi:boomerang": 0xF00FA,
    "mdi:bootstrap": 0xF6C5,
    "mdi:border-all": 0xF0C7,
    "mdi:border-all-variant": 0xF8A0,
    "mdi:border-bottom": 0xF0C8,
    "mdi:border-bottom-variant": 0xF8A1,
    "mdi:border-color": 0xF0C9,
    "mdi:border-horizontal": 0xF0CA,
    "mdi:border-inside": 0xF0CB,
    "mdi:border-left": 0xF0CC,
    "mdi:border-left-variant": 0xF8A2,
    "mdi:border-none": 0xF0CD,
    "mdi:border-none-variant": 0xF8A3,
    "mdi:border-outside": 0xF0CE,
    "mdi:border-right": 0xF0CF,
    "mdi:border-right-variant": 0xF8A4,
    "mdi:border-style": 0xF0D0,
    "mdi:border-top": 0xF0D1,
    "mdi:border-top-variant": 0xF8A5,
    "mdi:border-vertical": 0xF0D2,
    "mdi:bottle-soda": 0xF009B,
    "mdi:bottle-soda-classic": 0xF009C,
    "mdi:bottle-soda-outline": 0xF009D,
    "mdi:bottle-tonic": 0xF0159,
    "mdi:bottle-tonic-outline": 0xF015A,
    "mdi:bottle-tonic-plus": 0xF015B,
    "mdi:bottle-tonic-plus-outline": 0xF015C,
    "mdi:bottle-tonic-skull": 0xF015D,
    "mdi:bottle-tonic-skull-outline": 0xF015E,
    "mdi:bottle-wine": 0xF853,
    "mdi:bow-tie": 0xF677,
    "mdi:bowl": 0xF617,
    "mdi:bowling": 0xF0D3,
    "mdi:box": 0xF0D4,
    "mdi:box-cutter": 0xF0D5,
    "mdi:box-shadow": 0xF637,
    "mdi:boxing-glove": 0xFB41,
    "mdi:braille": 0xF9CF,
    "mdi:brain": 0xF9D0,
    "mdi:bread-slice": 0xFCCA,
    "mdi:bread-slice-outline": 0xFCCB,
    "mdi:bridge": 0xF618,
    "mdi:briefcase": 0xF0D6,
    "mdi:briefcase-account": 0xFCCC,
    "mdi:briefcase-account-outline": 0xFCCD,
    "mdi:briefcase-check": 0xF0D7,
    "mdi:briefcase-clock": 0xF00FB,
    "mdi:briefcase-clock-outline": 0xF00FC,
    "mdi:briefcase-download": 0xF0D8,
    "mdi:briefcase-download-outline": 0xFC19,
    "mdi:briefcase-edit": 0xFA97,
    "mdi:briefcase-edit-outline": 0xFC1A,
    "mdi:briefcase-minus": 0xFA29,
    "mdi:briefcase-minus-outline": 0xFC1B,
    "mdi:briefcase-outline": 0xF813,
    "mdi:briefcase-plus": 0xFA2A,
    "mdi:briefcase-plus-outline": 0xFC1C,
    "mdi:briefcase-remove": 0xFA2B,
    "mdi:briefcase-remove-outline": 0xFC1D,
    "mdi:briefcase-search": 0xFA2C,
    "mdi:briefcase-search-outline": 0xFC1E,
    "mdi:briefcase-upload": 0xF0D9,
    "mdi:briefcase-upload-outline": 0xFC1F,
    "mdi:brightness-1": 0xF0DA,
    "mdi:brightness-2": 0xF0DB,
    "mdi:brightness-3": 0xF0DC,
    "mdi:brightness-4": 0xF0DD,
    "mdi:brightness-5": 0xF0DE,
    "mdi:brightness-6": 0xF0DF,
    "mdi:brightness-7": 0xF0E0,
    "mdi:brightness-auto": 0xF0E1,
    "mdi:brightness-percent": 0xFCCE,
    "mdi:broom": 0xF0E2,
    "mdi:brush": 0xF0E3,
    "mdi:buddhism": 0xF94A,
    "mdi:buffer": 0xF619,
    "mdi:bug": 0xF0E4,
    "mdi:bug-check": 0xFA2D,
    "mdi:bug-check-outline": 0xFA2E,
    "mdi:bug-outline": 0xFA2F,
    "mdi:bugle": 0xFD90,
    "mdi:bulldozer": 0xFB07,
    "mdi:bullet": 0xFCCF,
    "mdi:bulletin-board": 0xF0E5,
    "mdi:bullhorn": 0xF0E6,
    "mdi:bullhorn-outline": 0xFB08,
    "mdi:bullseye": 0xF5DD,
    "mdi:bullseye-arrow": 0xF8C8,
    "mdi:bus": 0xF0E7,
    "mdi:bus-alert": 0xFA98,
    "mdi:bus-articulated-end": 0xF79B,
    "mdi:bus-articulated-front": 0xF79C,
    "mdi:bus-clock": 0xF8C9,
    "mdi:bus-double-decker": 0xF79D,
    "mdi:bus-multiple": 0xFF5C,
    "mdi:bus-school": 0xF79E,
    "mdi:bus-side": 0xF79F,
    "mdi:bus-stop": 0xF0034,
    "mdi:bus-stop-covered": 0xF0035,
    "mdi:bus-stop-uncovered": 0xF0036,
    "mdi:cached": 0xF0E8,
    "mdi:cactus": 0xFD91,
    "mdi:cake": 0xF0E9,
    "mdi:cake-layered": 0xF0EA,
    "mdi:cake-variant": 0xF0EB,
    "mdi:calculator": 0xF0EC,
    "mdi:calculator-variant": 0xFA99,
    "mdi:calendar": 0xF0ED,
    "mdi:calendar-account": 0xFEF4,
    "mdi:calendar-account-outline": 0xFEF5,
    "mdi:calendar-alert": 0xFA30,
    "mdi:calendar-arrow-left": 0xF015F,
    "mdi:calendar-arrow-right": 0xF0160,
    "mdi:calendar-blank": 0xF0EE,
    "mdi:calendar-blank-multiple": 0xF009E,
    "mdi:calendar-blank-outline": 0xFB42,
    "mdi:calendar-check": 0xF0EF,
    "mdi:calendar-check-outline": 0xFC20,
    "mdi:calendar-clock": 0xF0F0,
    "mdi:calendar-edit": 0xF8A6,
    "mdi:calendar-export": 0xFB09,
    "mdi:calendar-heart": 0xF9D1,
    "mdi:calendar-import": 0xFB0A,
    "mdi:calendar-minus": 0xFD38,
    "mdi:calendar-month": 0xFDFA,
    "mdi:calendar-month-outline": 0xFDFB,
    "mdi:calendar-multiple": 0xF0F1,
    "mdi:calendar-multiple-check": 0xF0F2,
    "mdi:calendar-multiselect": 0xFA31,
    "mdi:calendar-outline": 0xFB43,
    "mdi:calendar-plus": 0xF0F3,
    "mdi:calendar-question": 0xF691,
    "mdi:calendar-range": 0xF678,
    "mdi:calendar-range-outline": 0xFB44,
    "mdi:calendar-remove": 0xF0F4,
    "mdi:calendar-remove-outline": 0xFC21,
    "mdi:calendar-repeat": 0xFEAB,
    "mdi:calendar-repeat-outline": 0xFEAC,
    "mdi:calendar-search": 0xF94B,
    "mdi:calendar-star": 0xF9D2,
    "mdi:calendar-text": 0xF0F5,
    "mdi:calendar-text-outline": 0xFC22,
    "mdi:calendar-today": 0xF0F6,
    "mdi:calendar-week": 0xFA32,
    "mdi:calendar-week-begin": 0xFA33,
    "mdi:calendar-weekend": 0xFEF6,
    "mdi:calendar-weekend-outline": 0xFEF7,
    "mdi:call-made": 0xF0F7,
    "mdi:call-merge": 0xF0F8,
    "mdi:call-missed": 0xF0F9,
    "mdi:call-received": 0xF0FA,
    "mdi:call-split": 0xF0FB,
    "mdi:camcorder": 0xF0FC,
    "mdi:camcorder-box": 0xF0FD,
    "mdi:camcorder-box-off": 0xF0FE,
    "mdi:camcorder-off": 0xF0FF,
    "mdi:camera": 0xF100,
    "mdi:camera-account": 0xF8CA,
    "mdi:camera-burst": 0xF692,
    "mdi:camera-control": 0xFB45,
    "mdi:camera-enhance": 0xF101,
    "mdi:camera-enhance-outline": 0xFB46,
    "mdi:camera-front": 0xF102,
    "mdi:camera-front-variant": 0xF103,
    "mdi:camera-gopro": 0xF7A0,
    "mdi:camera-image": 0xF8CB,
    "mdi:camera-iris": 0xF104,
    "mdi:camera-metering-center": 0xF7A1,
    "mdi:camera-metering-matrix": 0xF7A2,
    "mdi:camera-metering-partial": 0xF7A3,
    "mdi:camera-metering-spot": 0xF7A4,
    "mdi:camera-off": 0xF5DF,
    "mdi:camera-outline": 0xFD39,
    "mdi:camera-party-mode": 0xF105,
    "mdi:camera-plus": 0xFEF8,
    "mdi:camera-plus-outline": 0xFEF9,
    "mdi:camera-rear": 0xF106,
    "mdi:camera-rear-variant": 0xF107,
    "mdi:camera-retake": 0xFDFC,
    "mdi:camera-retake-outline": 0xFDFD,
    "mdi:camera-switch": 0xF108,
    "mdi:camera-timer": 0xF109,
    "mdi:camera-wireless": 0xFD92,
    "mdi:camera-wireless-outline": 0xFD93,
    "mdi:campfire": 0xFEFA,
    "mdi:cancel": 0xF739,
    "mdi:candle": 0xF5E2,
    "mdi:candycane": 0xF10A,
    "mdi:cannabis": 0xF7A5,
    "mdi:caps-lock": 0xFA9A,
    "mdi:car": 0xF10B,
    "mdi:car-2-plus": 0xF0037,
    "mdi:car-3-plus": 0xF0038,
    "mdi:car-back": 0xFDFE,
    "mdi:car-battery": 0xF10C,
    "mdi:car-brake-abs": 0xFC23,
    "mdi:car-brake-alert": 0xFC24,
    "mdi:car-brake-hold": 0xFD3A,
    "mdi:car-brake-parking": 0xFD3B,
    "mdi:car-brake-retarder": 0xF0039,
    "mdi:car-child-seat": 0xFFC3,
    "mdi:car-clutch": 0xF003A,
    "mdi:car-connected": 0xF10D,
    "mdi:car-convertible": 0xF7A6,
    "mdi:car-coolant-level": 0xF003B,
    "mdi:car-cruise-control": 0xFD3C,
    "mdi:car-defrost-front": 0xFD3D,
    "mdi:car-defrost-rear": 0xFD3E,
    "mdi:car-door": 0xFB47,
    "mdi:car-door-lock": 0xF00C8,
    "mdi:car-electric": 0xFB48,
    "mdi:car-esp": 0xFC25,
    "mdi:car-estate": 0xF7A7,
    "mdi:car-hatchback": 0xF7A8,
    "mdi:car-info": 0xF01E9,
    "mdi:car-key": 0xFB49,
    "mdi:car-light-dimmed": 0xFC26,
    "mdi:car-light-fog": 0xFC27,
    "mdi:car-light-high": 0xFC28,
    "mdi:car-limousine": 0xF8CC,
    "mdi:car-multiple": 0xFB4A,
    "mdi:car-off": 0xFDFF,
    "mdi:car-parking-lights": 0xFD3F,
    "mdi:car-pickup": 0xF7A9,
    "mdi:car-seat": 0xFFC4,
    "mdi:car-seat-cooler": 0xFFC5,
    "mdi:car-seat-heater": 0xFFC6,
    "mdi:car-shift-pattern": 0xFF5D,
    "mdi:car-side": 0xF7AA,
    "mdi:car-sports": 0xF7AB,
    "mdi:car-tire-alert": 0xFC29,
    "mdi:car-traction-control": 0xFD40,
    "mdi:car-turbocharger": 0xF003C,
    "mdi:car-wash": 0xF10E,
    "mdi:car-windshield": 0xF003D,
    "mdi:car-windshield-outline": 0xF003E,
    "mdi:caravan": 0xF7AC,
    "mdi:card": 0xFB4B,
    "mdi:card-bulleted": 0xFB4C,
    "mdi:card-bulleted-off": 0xFB4D,
    "mdi:card-bulleted-off-outline": 0xFB4E,
    "mdi:card-bulleted-outline": 0xFB4F,
    "mdi:card-bulleted-settings": 0xFB50,
    "mdi:card-bulleted-settings-outline": 0xFB51,
    "mdi:card-outline": 0xFB52,
    "mdi:card-search": 0xF009F,
    "mdi:card-search-outline": 0xF00A0,
    "mdi:card-text": 0xFB53,
    "mdi:card-text-outline": 0xFB54,
    "mdi:cards": 0xF638,
    "mdi:cards-club": 0xF8CD,
    "mdi:cards-diamond": 0xF8CE,
    "mdi:cards-diamond-outline": 0xF003F,
    "mdi:cards-heart": 0xF8CF,
    "mdi:cards-outline": 0xF639,
    "mdi:cards-playing-outline": 0xF63A,
    "mdi:cards-spade": 0xF8D0,
    "mdi:cards-variant": 0xF6C6,
    "mdi:carrot": 0xF10F,
    "mdi:cart": 0xF110,
    "mdi:cart-arrow-down": 0xFD42,
    "mdi:cart-arrow-right": 0xFC2A,
    "mdi:cart-arrow-up": 0xFD43,
    "mdi:cart-minus": 0xFD44,
    "mdi:cart-off": 0xF66B,
    "mdi:cart-outline": 0xF111,
    "mdi:cart-plus": 0xF112,
    "mdi:cart-remove": 0xFD45,
    "mdi:case-sensitive-alt": 0xF113,
    "mdi:cash": 0xF114,
    "mdi:cash-100": 0xF115,
    "mdi:cash-marker": 0xFD94,
    "mdi:cash-multiple": 0xF116,
    "mdi:cash-refund": 0xFA9B,
    "mdi:cash-register": 0xFCD0,
    "mdi:cash-usd": 0xF01A1,
    "mdi:cash-usd-outline": 0xF117,
    "mdi:cassette": 0xF9D3,
    "mdi:cast": 0xF118,
    "mdi:cast-audio": 0xF0040,
    "mdi:cast-connected": 0xF119,
    "mdi:cast-education": 0xFE6D,
    "mdi:cast-off": 0xF789,
    "mdi:castle": 0xF11A,
    "mdi:cat": 0xF11B,
    "mdi:cctv": 0xF7AD,
    "mdi:ceiling-light": 0xF768,
    "mdi:cellphone": 0xF11C,
    "mdi:cellphone-android": 0xF11D,
    "mdi:cellphone-arrow-down": 0xF9D4,
    "mdi:cellphone-basic": 0xF11E,
    "mdi:cellphone-dock": 0xF11F,
    "mdi:cellphone-erase": 0xF94C,
    "mdi:cellphone-information": 0xFF5E,
    "mdi:cellphone-iphone": 0xF120,
    "mdi:cellphone-key": 0xF94D,
    "mdi:cellphone-link": 0xF121,
    "mdi:cellphone-link-off": 0xF122,
    "mdi:cellphone-lock": 0xF94E,
    "mdi:cellphone-message": 0xF8D2,
    "mdi:cellphone-message-off": 0xF00FD,
    "mdi:cellphone-nfc": 0xFEAD,
    "mdi:cellphone-off": 0xF94F,
    "mdi:cellphone-play": 0xF0041,
    "mdi:cellphone-screenshot": 0xFA34,
    "mdi:cellphone-settings": 0xF123,
    "mdi:cellphone-settings-variant": 0xF950,
    "mdi:cellphone-sound": 0xF951,
    "mdi:cellphone-text": 0xF8D1,
    "mdi:cellphone-wireless": 0xF814,
    "mdi:celtic-cross": 0xFCD1,
    "mdi:centos": 0xF0145,
    "mdi:certificate": 0xF124,
    "mdi:certificate-outline": 0xF01B3,
    "mdi:chair-rolling": 0xFFBA,
    "mdi:chair-school": 0xF125,
    "mdi:charity": 0xFC2B,
    "mdi:chart-arc": 0xF126,
    "mdi:chart-areaspline": 0xF127,
    "mdi:chart-areaspline-variant": 0xFEAE,
    "mdi:chart-bar": 0xF128,
    "mdi:chart-bar-stacked": 0xF769,
    "mdi:chart-bell-curve": 0xFC2C,
    "mdi:chart-bell-curve-cumulative": 0xFFC7,
    "mdi:chart-bubble": 0xF5E3,
    "mdi:chart-donut": 0xF7AE,
    "mdi:chart-donut-variant": 0xF7AF,
    "mdi:chart-gantt": 0xF66C,
    "mdi:chart-histogram": 0xF129,
    "mdi:chart-line": 0xF12A,
    "mdi:chart-line-stacked": 0xF76A,
    "mdi:chart-line-variant": 0xF7B0,
    "mdi:chart-multiline": 0xF8D3,
    "mdi:chart-pie": 0xF12B,
    "mdi:chart-scatter-plot": 0xFEAF,
    "mdi:chart-scatter-plot-hexbin": 0xF66D,
    "mdi:chart-snakey": 0xF020A,
    "mdi:chart-snakey-variant": 0xF020B,
    "mdi:chart-timeline": 0xF66E,
    "mdi:chart-timeline-variant": 0xFEB0,
    "mdi:chart-tree": 0xFEB1,
    "mdi:chat": 0xFB55,
    "mdi:chat-alert": 0xFB56,
    "mdi:chat-outline": 0xFEFB,
    "mdi:chat-processing": 0xFB57,
    "mdi:check": 0xF12C,
    "mdi:check-all": 0xF12D,
    "mdi:check-bold": 0xFE6E,
    "mdi:check-box-multiple-outline": 0xFC2D,
    "mdi:check-box-outline": 0xFC2E,
    "mdi:check-circle": 0xF5E0,
    "mdi:check-circle-outline": 0xF5E1,
    "mdi:check-decagram": 0xF790,
    "mdi:check-network": 0xFC2F,
    "mdi:check-network-outline": 0xFC30,
    "mdi:check-outline": 0xF854,
    "mdi:check-underline": 0xFE70,
    "mdi:check-underline-circle": 0xFE71,
    "mdi:check-underline-circle-outline": 0xFE72,
    "mdi:checkbook": 0xFA9C,
    "mdi:checkbox-blank": 0xF12E,
    "mdi:checkbox-blank-circle": 0xF12F,
    "mdi:checkbox-blank-circle-outline": 0xF130,
    "mdi:checkbox-blank-outline": 0xF131,
    "mdi:checkbox-intermediate": 0xF855,
    "mdi:checkbox-marked": 0xF132,
    "mdi:checkbox-marked-circle": 0xF133,
    "mdi:checkbox-marked-circle-outline": 0xF134,
    "mdi:checkbox-marked-outline": 0xF135,
    "mdi:checkbox-multiple-blank": 0xF136,
    "mdi:checkbox-multiple-blank-circle": 0xF63B,
    "mdi:checkbox-multiple-blank-circle-outline": 0xF63C,
    "mdi:checkbox-multiple-blank-outline": 0xF137,
    "mdi:checkbox-multiple-marked": 0xF138,
    "mdi:checkbox-multiple-marked-circle": 0xF63D,
    "mdi:checkbox-multiple-marked-circle-outline": 0xF63E,
    "mdi:checkbox-multiple-marked-outline": 0xF139,
    "mdi:checkerboard": 0xF13A,
    "mdi:chef-hat": 0xFB58,
    "mdi:chemical-weapon": 0xF13B,
    "mdi:chess-bishop": 0xF85B,
    "mdi:chess-king": 0xF856,
    "mdi:chess-knight": 0xF857,
    "mdi:chess-pawn": 0xF858,
    "mdi:chess-queen": 0xF859,
    "mdi:chess-rook": 0xF85A,
    "mdi:chevron-double-down": 0xF13C,
    "mdi:chevron-double-left": 0xF13D,
    "mdi:chevron-double-right": 0xF13E,
    "mdi:chevron-double-up": 0xF13F,
    "mdi:chevron-down": 0xF140,
    "mdi:chevron-down-box": 0xF9D5,
    "mdi:chevron-down-box-outline": 0xF9D6,
    "mdi:chevron-down-circle": 0xFB0B,
    "mdi:chevron-down-circle-outline": 0xFB0C,
    "mdi:chevron-left": 0xF141,
    "mdi:chevron-left-box": 0xF9D7,
    "mdi:chevron-left-box-outline": 0xF9D8,
    "mdi:chevron-left-circle": 0xFB0D,
    "mdi:chevron-left-circle-outline": 0xFB0E,
    "mdi:chevron-right": 0xF142,
    "mdi:chevron-right-box": 0xF9D9,
    "mdi:chevron-right-box-outline": 0xF9DA,
    "mdi:chevron-right-circle": 0xFB0F,
    "mdi:chevron-right-circle-outline": 0xFB10,
    "mdi:chevron-triple-down": 0xFD95,
    "mdi:chevron-triple-left": 0xFD96,
    "mdi:chevron-triple-right": 0xFD97,
    "mdi:chevron-triple-up": 0xFD98,
    "mdi:chevron-up": 0xF143,
    "mdi:chevron-up-box": 0xF9DB,
    "mdi:chevron-up-box-outline": 0xF9DC,
    "mdi:chevron-up-circle": 0xFB11,
    "mdi:chevron-up-circle-outline": 0xFB12,
    "mdi:chili-hot": 0xF7B1,
    "mdi:chili-medium": 0xF7B2,
    "mdi:chili-mild": 0xF7B3,
    "mdi:chip": 0xF61A,
    "mdi:christianity": 0xF952,
    "mdi:christianity-outline": 0xFCD2,
    "mdi:church": 0xF144,
    "mdi:cigar": 0xF01B4,
    "mdi:circle": 0xF764,
    "mdi:circle-double": 0xFEB2,
    "mdi:circle-edit-outline": 0xF8D4,
    "mdi:circle-expand": 0xFEB3,
    "mdi:circle-medium": 0xF9DD,
    "mdi:circle-off-outline": 0xF00FE,
    "mdi:circle-outline": 0xF765,
    "mdi:circle-slice-1": 0xFA9D,
    "mdi:circle-slice-2": 0xFA9E,
    "mdi:circle-slice-3": 0xFA9F,
    "mdi:circle-slice-4": 0xFAA0,
    "mdi:circle-slice-5": 0xFAA1,
    "mdi:circle-slice-6": 0xFAA2,
    "mdi:circle-slice-7": 0xFAA3,
    "mdi:circle-slice-8": 0xFAA4,
    "mdi:circle-small": 0xF9DE,
    "mdi:circular-saw": 0xFE73,
    "mdi:cisco-webex": 0xF145,
    "mdi:city": 0xF146,
    "mdi:city-variant": 0xFA35,
    "mdi:city-variant-outline": 0xFA36,
    "mdi:clipboard": 0xF147,
    "mdi:clipboard-account": 0xF148,
    "mdi:clipboard-account-outline": 0xFC31,
    "mdi:clipboard-alert": 0xF149,
    "mdi:clipboard-alert-outline": 0xFCD3,
    "mdi:clipboard-arrow-down": 0xF14A,
    "mdi:clipboard-arrow-down-outline": 0xFC32,
    "mdi:clipboard-arrow-left": 0xF14B,
    "mdi:clipboard-arrow-left-outline": 0xFCD4,
    "mdi:clipboard-arrow-right": 0xFCD5,
    "mdi:clipboard-arrow-right-outline": 0xFCD6,
    "mdi:clipboard-arrow-up": 0xFC33,
    "mdi:clipboard-arrow-up-outline": 0xFC34,
    "mdi:clipboard-check": 0xF14C,
    "mdi:clipboard-check-outline": 0xF8A7,
    "mdi:clipboard-flow": 0xF6C7,
    "mdi:clipboard-flow-outline": 0xF0142,
    "mdi:clipboard-list": 0xF00FF,
    "mdi:clipboard-list-outline": 0xF0100,
    "mdi:clipboard-outline": 0xF14D,
    "mdi:clipboard-play": 0xFC35,
    "mdi:clipboard-play-outline": 0xFC36,
    "mdi:clipboard-plus": 0xF750,
    "mdi:clipboard-pulse": 0xF85C,
    "mdi:clipboard-pulse-outline": 0xF85D,
    "mdi:clipboard-text": 0xF14E,
    "mdi:clipboard-text-outline": 0xFA37,
    "mdi:clipboard-text-play": 0xFC37,
    "mdi:clipboard-text-play-outline": 0xFC38,
    "mdi:clippy": 0xF14F,
    "mdi:clock": 0xF953,
    "mdi:clock-alert": 0xF954,
    "mdi:clock-alert-outline": 0xF5CE,
    "mdi:clock-check": 0xFFC8,
    "mdi:clock-check-outline": 0xFFC9,
    "mdi:clock-digital": 0xFEB4,
    "mdi:clock-end": 0xF151,
    "mdi:clock-fast": 0xF152,
    "mdi:clock-in": 0xF153,
    "mdi:clock-out": 0xF154,
    "mdi:clock-outline": 0xF150,
    "mdi:clock-start": 0xF155,
    "mdi:close": 0xF156,
    "mdi:close-box": 0xF157,
    "mdi:close-box-multiple": 0xFC39,
    "mdi:close-box-multiple-outline": 0xFC3A,
    "mdi:close-box-outline": 0xF158,
    "mdi:close-circle": 0xF159,
    "mdi:close-circle-outline": 0xF15A,
    "mdi:close-network": 0xF15B,
    "mdi:close-network-outline": 0xFC3B,
    "mdi:close-octagon": 0xF15C,
    "mdi:close-octagon-outline": 0xF15D,
    "mdi:close-outline": 0xF6C8,
    "mdi:closed-caption": 0xF15E,
    "mdi:closed-caption-outline": 0xFD99,
    "mdi:cloud": 0xF15F,
    "mdi:cloud-alert": 0xF9DF,
    "mdi:cloud-braces": 0xF7B4,
    "mdi:cloud-check": 0xF160,
    "mdi:cloud-circle": 0xF161,
    "mdi:cloud-download": 0xF162,
    "mdi:cloud-download-outline": 0xFB59,
    "mdi:cloud-lock": 0xF021C,
    "mdi:cloud-lock-outline": 0xF021D,
    "mdi:cloud-off-outline": 0xF164,
    "mdi:cloud-outline": 0xF163,
    "mdi:cloud-print": 0xF165,
    "mdi:cloud-print-outline": 0xF166,
    "mdi:cloud-question": 0xFA38,
    "mdi:cloud-search": 0xF955,
    "mdi:cloud-search-outline": 0xF956,
    "mdi:cloud-sync": 0xF63F,
    "mdi:cloud-tags": 0xF7B5,
    "mdi:cloud-upload": 0xF167,
    "mdi:cloud-upload-outline": 0xFB5A,
    "mdi:clover": 0xF815,
    "mdi:coach-lamp": 0xF0042,
    "mdi:coat-rack": 0xF00C9,
    "mdi:code-array": 0xF168,
    "mdi:code-braces": 0xF169,
    "mdi:code-braces-box": 0xF0101,
    "mdi:code-brackets": 0xF16A,
    "mdi:code-equal": 0xF16B,
    "mdi:code-greater-than": 0xF16C,
    "mdi:code-greater-than-or-equal": 0xF16D,
    "mdi:code-less-than": 0xF16E,
    "mdi:code-less-than-or-equal": 0xF16F,
    "mdi:code-not-equal": 0xF170,
    "mdi:code-not-equal-variant": 0xF171,
    "mdi:code-parentheses": 0xF172,
    "mdi:code-parentheses-box": 0xF0102,
    "mdi:code-string": 0xF173,
    "mdi:code-tags": 0xF174,
    "mdi:code-tags-check": 0xF693,
    "mdi:codepen": 0xF175,
    "mdi:coffee": 0xF176,
    "mdi:coffee-maker": 0xF00CA,
    "mdi:coffee-off": 0xFFCA,
    "mdi:coffee-off-outline": 0xFFCB,
    "mdi:coffee-outline": 0xF6C9,
    "mdi:coffee-to-go": 0xF177,
    "mdi:coffin": 0xFB5B,
    "mdi:cog-clockwise": 0xF0208,
    "mdi:cog-counterclockwise": 0xF0209,
    "mdi:cogs": 0xF8D5,
    "mdi:coin": 0xF0196,
    "mdi:coin-outline": 0xF178,
    "mdi:coins": 0xF694,
    "mdi:collage": 0xF640,
    "mdi:collapse-all": 0xFAA5,
    "mdi:collapse-all-outline": 0xFAA6,
    "mdi:color-helper": 0xF179,
    "mdi:comma": 0xFE74,
    "mdi:comma-box": 0xFE75,
    "mdi:comma-box-outline": 0xFE76,
    "mdi:comma-circle": 0xFE77,
    "mdi:comma-circle-outline": 0xFE78,
    "mdi:comment": 0xF17A,
    "mdi:comment-account": 0xF17B,
    "mdi:comment-account-outline": 0xF17C,
    "mdi:comment-alert": 0xF17D,
    "mdi:comment-alert-outline": 0xF17E,
    "mdi:comment-arrow-left": 0xF9E0,
    "mdi:comment-arrow-left-outline": 0xF9E1,
    "mdi:comment-arrow-right": 0xF9E2,
    "mdi:comment-arrow-right-outline": 0xF9E3,
    "mdi:comment-check": 0xF17F,
    "mdi:comment-check-outline": 0xF180,
    "mdi:comment-edit": 0xF01EA,
    "mdi:comment-eye": 0xFA39,
    "mdi:comment-eye-outline": 0xFA3A,
    "mdi:comment-multiple": 0xF85E,
    "mdi:comment-multiple-outline": 0xF181,
    "mdi:comment-outline": 0xF182,
    "mdi:comment-plus": 0xF9E4,
    "mdi:comment-plus-outline": 0xF183,
    "mdi:comment-processing": 0xF184,
    "mdi:comment-processing-outline": 0xF185,
    "mdi:comment-question": 0xF816,
    "mdi:comment-question-outline": 0xF186,
    "mdi:comment-quote": 0xF0043,
    "mdi:comment-quote-outline": 0xF0044,
    "mdi:comment-remove": 0xF5DE,
    "mdi:comment-remove-outline": 0xF187,
    "mdi:comment-search": 0xFA3B,
    "mdi:comment-search-outline": 0xFA3C,
    "mdi:comment-text": 0xF188,
    "mdi:comment-text-multiple": 0xF85F,
    "mdi:comment-text-multiple-outline": 0xF860,
    "mdi:comment-text-outline": 0xF189,
    "mdi:compare": 0xF18A,
    "mdi:compass": 0xF18B,
    "mdi:compass-off": 0xFB5C,
    "mdi:compass-off-outline": 0xFB5D,
    "mdi:compass-outline": 0xF18C,
    "mdi:concourse-ci": 0xF00CB,
    "mdi:console": 0xF18D,
    "mdi:console-line": 0xF7B6,
    "mdi:console-network": 0xF8A8,
    "mdi:console-network-outline": 0xFC3C,
    "mdi:consolidate": 0xF0103,
    "mdi:contact-mail": 0xF18E,
    "mdi:contact-mail-outline": 0xFEB5,
    "mdi:contact-phone": 0xFEB6,
    "mdi:contact-phone-outline": 0xFEB7,
    "mdi:contactless-payment": 0xFD46,
    "mdi:contacts": 0xF6CA,
    "mdi:contain": 0xFA3D,
    "mdi:contain-end": 0xFA3E,
    "mdi:contain-start": 0xFA3F,
    "mdi:content-copy": 0xF18F,
    "mdi:content-cut": 0xF190,
    "mdi:content-duplicate": 0xF191,
    "mdi:content-paste": 0xF192,
    "mdi:content-save": 0xF193,
    "mdi:content-save-alert": 0xFF5F,
    "mdi:content-save-alert-outline": 0xFF60,
    "mdi:content-save-all": 0xF194,
    "mdi:content-save-all-outline": 0xFF61,
    "mdi:content-save-edit": 0xFCD7,
    "mdi:content-save-edit-outline": 0xFCD8,
    "mdi:content-save-move": 0xFE79,
    "mdi:content-save-move-outline": 0xFE7A,
    "mdi:content-save-outline": 0xF817,
    "mdi:content-save-settings": 0xF61B,
    "mdi:content-save-settings-outline": 0xFB13,
    "mdi:contrast": 0xF195,
    "mdi:contrast-box": 0xF196,
    "mdi:contrast-circle": 0xF197,
    "mdi:controller-classic": 0xFB5E,
    "mdi:controller-classic-outline": 0xFB5F,
    "mdi:cookie": 0xF198,
    "mdi:coolant-temperature": 0xF3C8,
    "mdi:copyright": 0xF5E6,
    "mdi:cordova": 0xF957,
    "mdi:corn": 0xF7B7,
    "mdi:counter": 0xF199,
    "mdi:cow": 0xF19A,
    "mdi:cowboy": 0xFEB8,
    "mdi:cpu-32-bit": 0xFEFC,
    "mdi:cpu-64-bit": 0xFEFD,
    "mdi:crane": 0xF861,
    "mdi:creation": 0xF1C9,
    "mdi:creative-commons": 0xFD47,
    "mdi:credit-card": 0xF0010,
    "mdi:credit-card-clock": 0xFEFE,
    "mdi:credit-card-clock-outline": 0xFFBC,
    "mdi:credit-card-marker": 0xF6A7,
    "mdi:credit-card-marker-outline": 0xFD9A,
    "mdi:credit-card-minus": 0xFFCC,
    "mdi:credit-card-minus-outline": 0xFFCD,
    "mdi:credit-card-multiple": 0xF0011,
    "mdi:credit-card-multiple-outline": 0xF19C,
    "mdi:credit-card-off": 0xF0012,
    "mdi:credit-card-off-outline": 0xF5E4,
    "mdi:credit-card-outline": 0xF19B,
    "mdi:credit-card-plus": 0xF0013,
    "mdi:credit-card-plus-outline": 0xF675,
    "mdi:credit-card-refund": 0xF0014,
    "mdi:credit-card-refund-outline": 0xFAA7,
    "mdi:credit-card-remove": 0xFFCE,
    "mdi:credit-card-remove-outline": 0xFFCF,
    "mdi:credit-card-scan": 0xF0015,
    "mdi:credit-card-scan-outline": 0xF19D,
    "mdi:credit-card-settings": 0xF0016,
    "mdi:credit-card-settings-outline": 0xF8D6,
    "mdi:credit-card-wireless": 0xF801,
    "mdi:credit-card-wireless-outline": 0xFD48,
    "mdi:cricket": 0xFD49,
    "mdi:crop": 0xF19E,
    "mdi:crop-free": 0xF19F,
    "mdi:crop-landscape": 0xF1A0,
    "mdi:crop-portrait": 0xF1A1,
    "mdi:crop-rotate": 0xF695,
    "mdi:crop-square": 0xF1A2,
    "mdi:crosshairs": 0xF1A3,
    "mdi:crosshairs-gps": 0xF1A4,
    "mdi:crosshairs-off": 0xFF62,
    "mdi:crosshairs-question": 0xF0161,
    "mdi:crown": 0xF1A5,
    "mdi:crown-outline": 0xF01FB,
    "mdi:cryengine": 0xF958,
    "mdi:crystal-ball": 0xFB14,
    "mdi:cube": 0xF1A6,
    "mdi:cube-outline": 0xF1A7,
    "mdi:cube-scan": 0xFB60,
    "mdi:cube-send": 0xF1A8,
    "mdi:cube-unfolded": 0xF1A9,
    "mdi:cup": 0xF1AA,
    "mdi:cup-off": 0xF5E5,
    "mdi:cup-water": 0xF1AB,
    "mdi:cupboard": 0xFF63,
    "mdi:cupboard-outline": 0xFF64,
    "mdi:cupcake": 0xF959,
    "mdi:curling": 0xF862,
    "mdi:currency-bdt": 0xF863,
    "mdi:currency-brl": 0xFB61,
    "mdi:currency-btc": 0xF1AC,
    "mdi:currency-cny": 0xF7B9,
    "mdi:currency-eth": 0xF7BA,
    "mdi:currency-eur": 0xF1AD,
    "mdi:currency-gbp": 0xF1AE,
    "mdi:currency-ils": 0xFC3D,
    "mdi:currency-inr": 0xF1AF,
    "mdi:currency-jpy": 0xF7BB,
    "mdi:currency-krw": 0xF7BC,
    "mdi:currency-kzt": 0xF864,
    "mdi:currency-ngn": 0xF1B0,
    "mdi:currency-php": 0xF9E5,
    "mdi:currency-rial": 0xFEB9,
    "mdi:currency-rub": 0xF1B1,
    "mdi:currency-sign": 0xF7BD,
    "mdi:currency-try": 0xF1B2,
    "mdi:currency-twd": 0xF7BE,
    "mdi:currency-usd": 0xF1B3,
    "mdi:currency-usd-off": 0xF679,
    "mdi:current-ac": 0xF95A,
    "mdi:current-dc": 0xF95B,
    "mdi:cursor-default": 0xF1B4,
    "mdi:cursor-default-click": 0xFCD9,
    "mdi:cursor-default-click-outline": 0xFCDA,
    "mdi:cursor-default-gesture": 0xF0152,
    "mdi:cursor-default-gesture-outline": 0xF0153,
    "mdi:cursor-default-outline": 0xF1B5,
    "mdi:cursor-move": 0xF1B6,
    "mdi:cursor-pointer": 0xF1B7,
    "mdi:cursor-text": 0xF5E7,
    "mdi:database": 0xF1B8,
    "mdi:database-check": 0xFAA8,
    "mdi:database-edit": 0xFB62,
    "mdi:database-export": 0xF95D,
    "mdi:database-import": 0xF95C,
    "mdi:database-lock": 0xFAA9,
    "mdi:database-minus": 0xF1B9,
    "mdi:database-plus": 0xF1BA,
    "mdi:database-refresh": 0xFCDB,
    "mdi:database-remove": 0xFCDC,
    "mdi:database-search": 0xF865,
    "mdi:database-settings": 0xFCDD,
    "mdi:death-star": 0xF8D7,
    "mdi:death-star-variant": 0xF8D8,
    "mdi:deathly-hallows": 0xFB63,
    "mdi:debian": 0xF8D9,
    "mdi:debug-step-into": 0xF1BB,
    "mdi:debug-step-out": 0xF1BC,
    "mdi:debug-step-over": 0xF1BD,
    "mdi:decagram": 0xF76B,
    "mdi:decagram-outline": 0xF76C,
    "mdi:decimal": 0xF00CC,
    "mdi:decimal-comma": 0xF00CD,
    "mdi:decimal-comma-decrease": 0xF00CE,
    "mdi:decimal-comma-increase": 0xF00CF,
    "mdi:decimal-decrease": 0xF1BE,
    "mdi:decimal-increase": 0xF1BF,
    "mdi:delete": 0xF1C0,
    "mdi:delete-alert": 0xF00D0,
    "mdi:delete-alert-outline": 0xF00D1,
    "mdi:delete-circle": 0xF682,
    "mdi:delete-circle-outline": 0xFB64,
    "mdi:delete-empty": 0xF6CB,
    "mdi:delete-empty-outline": 0xFEBA,
    "mdi:delete-forever": 0xF5E8,
    "mdi:delete-forever-outline": 0xFB65,
    "mdi:delete-off": 0xF00D2,
    "mdi:delete-off-outline": 0xF00D3,
    "mdi:delete-outline": 0xF9E6,
    "mdi:delete-restore": 0xF818,
    "mdi:delete-sweep": 0xF5E9,
    "mdi:delete-sweep-outline": 0xFC3E,
    "mdi:delete-variant": 0xF1C1,
    "mdi:delta": 0xF1C2,
    "mdi:desk-lamp": 0xF95E,
    "mdi:deskphone": 0xF1C3,
    "mdi:desktop-classic": 0xF7BF,
    "mdi:desktop-mac": 0xF1C4,
    "mdi:desktop-mac-dashboard": 0xF9E7,
    "mdi:desktop-tower": 0xF1C5,
    "mdi:desktop-tower-monitor": 0xFAAA,
    "mdi:details": 0xF1C6,
    "mdi:dev-to": 0xFD4A,
    "mdi:developer-board": 0xF696,
    "mdi:deviantart": 0xF1C7,
    "mdi:devices": 0xFFD0,
    "mdi:diabetes": 0xF0151,
    "mdi:dialpad": 0xF61C,
    "mdi:diameter": 0xFC3F,
    "mdi:diameter-outline": 0xFC40,
    "mdi:diameter-variant": 0xFC41,
    "mdi:diamond": 0xFB66,
    "mdi:diamond-outline": 0xFB67,
    "mdi:diamond-stone": 0xF1C8,
    "mdi:dice-1": 0xF1CA,
    "mdi:dice-1-outline": 0xF0175,
    "mdi:dice-2": 0xF1CB,
    "mdi:dice-2-outline": 0xF0176,
    "mdi:dice-3": 0xF1CC,
    "mdi:dice-3-outline": 0xF0177,
    "mdi:dice-4": 0xF1CD,
    "mdi:dice-4-outline": 0xF0178,
    "mdi:dice-5": 0xF1CE,
    "mdi:dice-5-outline": 0xF0179,
    "mdi:dice-6": 0xF1CF,
    "mdi:dice-6-outline": 0xF017A,
    "mdi:dice-d10": 0xF017E,
    "mdi:dice-d10-outline": 0xF76E,
    "mdi:dice-d12": 0xF017F,
    "mdi:dice-d12-outline": 0xF866,
    "mdi:dice-d20": 0xF0180,
    "mdi:dice-d20-outline": 0xF5EA,
    "mdi:dice-d4": 0xF017B,
    "mdi:dice-d4-outline": 0xF5EB,
    "mdi:dice-d6": 0xF017C,
    "mdi:dice-d6-outline": 0xF5EC,
    "mdi:dice-d8": 0xF017D,
    "mdi:dice-d8-outline": 0xF5ED,
    "mdi:dice-multiple": 0xF76D,
    "mdi:dice-multiple-outline": 0xF0181,
    "mdi:dictionary": 0xF61D,
    "mdi:dip-switch": 0xF7C0,
    "mdi:directions": 0xF1D0,
    "mdi:directions-fork": 0xF641,
    "mdi:disc": 0xF5EE,
    "mdi:disc-alert": 0xF1D1,
    "mdi:disc-player": 0xF95F,
    "mdi:discord": 0xF66F,
    "mdi:dishwasher": 0xFAAB,
    "mdi:dishwasher-alert": 0xF01E3,
    "mdi:dishwasher-off": 0xF01E4,
    "mdi:disqus": 0xF1D2,
    "mdi:disqus-outline": 0xF1D3,
    "mdi:distribute-horizontal-center": 0xF01F4,
    "mdi:distribute-horizontal-left": 0xF01F3,
    "mdi:distribute-horizontal-right": 0xF01F5,
    "mdi:distribute-vertical-bottom": 0xF01F6,
    "mdi:distribute-vertical-center": 0xF01F7,
    "mdi:distribute-vertical-top": 0xF01F8,
    "mdi:diving-flippers": 0xFD9B,
    "mdi:diving-helmet": 0xFD9C,
    "mdi:diving-scuba": 0xFD9D,
    "mdi:diving-scuba-flag": 0xFD9E,
    "mdi:diving-scuba-tank": 0xFD9F,
    "mdi:diving-scuba-tank-multiple": 0xFDA0,
    "mdi:diving-snorkel": 0xFDA1,
    "mdi:division": 0xF1D4,
    "mdi:division-box": 0xF1D5,
    "mdi:dlna": 0xFA40,
    "mdi:dna": 0xF683,
    "mdi:dns": 0xF1D6,
    "mdi:dns-outline": 0xFB68,
    "mdi:do-not-disturb": 0xF697,
    "mdi:do-not-disturb-off": 0xF698,
    "mdi:dock-bottom": 0xF00D4,
    "mdi:dock-left": 0xF00D5,
    "mdi:dock-right": 0xF00D6,
    "mdi:dock-window": 0xF00D7,
    "mdi:docker": 0xF867,
    "mdi:doctor": 0xFA41,
    "mdi:dog": 0xFA42,
    "mdi:dog-service": 0xFAAC,
    "mdi:dog-side": 0xFA43,
    "mdi:dolby": 0xF6B2,
    "mdi:dolly": 0xFEBB,
    "mdi:domain": 0xF1D7,
    "mdi:domain-off": 0xFD4B,
    "mdi:domain-plus": 0xF00D8,
    "mdi:domain-remove": 0xF00D9,
    "mdi:domino-mask": 0xF0045,
    "mdi:donkey": 0xF7C1,
    "mdi:door": 0xF819,
    "mdi:door-closed": 0xF81A,
    "mdi:door-closed-lock": 0xF00DA,
    "mdi:door-open": 0xF81B,
    "mdi:doorbell-video": 0xF868,
    "mdi:dot-net": 0xFAAD,
    "mdi:dots-horizontal": 0xF1D8,
    "mdi:dots-horizontal-circle": 0xF7C2,
    "mdi:dots-horizontal-circle-outline": 0xFB69,
    "mdi:dots-vertical": 0xF1D9,
    "mdi:dots-vertical-circle": 0xF7C3,
    "mdi:dots-vertical-circle-outline": 0xFB6A,
    "mdi:douban": 0xF699,
    "mdi:download": 0xF1DA,
    "mdi:download-multiple": 0xF9E8,
    "mdi:download-network": 0xF6F3,
    "mdi:download-network-outline": 0xFC42,
    "mdi:download-off": 0xF00DB,
    "mdi:download-off-outline": 0xF00DC,
    "mdi:download-outline": 0xFB6B,
    "mdi:drag": 0xF1DB,
    "mdi:drag-horizontal": 0xF1DC,
    "mdi:drag-variant": 0xFB6C,
    "mdi:drag-vertical": 0xF1DD,
    "mdi:drama-masks": 0xFCDE,
    "mdi:draw": 0xFF66,
    "mdi:drawing": 0xF1DE,
    "mdi:drawing-box": 0xF1DF,
    "mdi:dresser": 0xFF67,
    "mdi:dresser-outline": 0xFF68,
    "mdi:dribbble": 0xF1E0,
    "mdi:dribbble-box": 0xF1E1,
    "mdi:drone": 0xF1E2,
    "mdi:dropbox": 0xF1E3,
    "mdi:drupal": 0xF1E4,
    "mdi:duck": 0xF1E5,
    "mdi:dumbbell": 0xF1E6,
    "mdi:dump-truck": 0xFC43,
    "mdi:ear-hearing": 0xF7C4,
    "mdi:ear-hearing-off": 0xFA44,
    "mdi:earth": 0xF1E7,
    "mdi:earth-box": 0xF6CC,
    "mdi:earth-box-off": 0xF6CD,
    "mdi:earth-off": 0xF1E8,
    "mdi:edge": 0xF1E9,
    "mdi:egg": 0xFAAE,
    "mdi:egg-easter": 0xFAAF,
    "mdi:eight-track": 0xF9E9,
    "mdi:eject": 0xF1EA,
    "mdi:eject-outline": 0xFB6D,
    "mdi:electric-switch": 0xFEBC,
    "mdi:electric-switch-closed": 0xF0104,
    "mdi:electron-framework": 0xF0046,
    "mdi:elephant": 0xF7C5,
    "mdi:elevation-decline": 0xF1EB,
    "mdi:elevation-rise": 0xF1EC,
    "mdi:elevator": 0xF1ED,
    "mdi:ellipse": 0xFEBD,
    "mdi:ellipse-outline": 0xFEBE,
    "mdi:email": 0xF1EE,
    "mdi:email-alert": 0xF6CE,
    "mdi:email-box": 0xFCDF,
    "mdi:email-check": 0xFAB0,
    "mdi:email-check-outline": 0xFAB1,
    "mdi:email-edit": 0xFF00,
    "mdi:email-edit-outline": 0xFF01,
    "mdi:email-lock": 0xF1F1,
    "mdi:email-mark-as-unread": 0xFB6E,
    "mdi:email-minus": 0xFF02,
    "mdi:email-minus-outline": 0xFF03,
    "mdi:email-multiple": 0xFF04,
    "mdi:email-multiple-outline": 0xFF05,
    "mdi:email-newsletter": 0xFFD1,
    "mdi:email-open": 0xF1EF,
    "mdi:email-open-multiple": 0xFF06,
    "mdi:email-open-multiple-outline": 0xFF07,
    "mdi:email-open-outline": 0xF5EF,
    "mdi:email-outline": 0xF1F0,
    "mdi:email-plus": 0xF9EA,
    "mdi:email-plus-outline": 0xF9EB,
    "mdi:email-receive": 0xF0105,
    "mdi:email-receive-outline": 0xF0106,
    "mdi:email-search": 0xF960,
    "mdi:email-search-outline": 0xF961,
    "mdi:email-send": 0xF0107,
    "mdi:email-send-outline": 0xF0108,
    "mdi:email-variant": 0xF5F0,
    "mdi:ember": 0xFB15,
    "mdi:emby": 0xF6B3,
    "mdi:emoticon": 0xFC44,
    "mdi:emoticon-angry": 0xFC45,
    "mdi:emoticon-angry-outline": 0xFC46,
    "mdi:emoticon-confused": 0xF0109,
    "mdi:emoticon-confused-outline": 0xF010A,
    "mdi:emoticon-cool": 0xFC47,
    "mdi:emoticon-cool-outline": 0xF1F3,
    "mdi:emoticon-cry": 0xFC48,
    "mdi:emoticon-cry-outline": 0xFC49,
    "mdi:emoticon-dead": 0xFC4A,
    "mdi:emoticon-dead-outline": 0xF69A,
    "mdi:emoticon-devil": 0xFC4B,
    "mdi:emoticon-devil-outline": 0xF1F4,
    "mdi:emoticon-excited": 0xFC4C,
    "mdi:emoticon-excited-outline": 0xF69B,
    "mdi:emoticon-frown": 0xFF69,
    "mdi:emoticon-frown-outline": 0xFF6A,
    "mdi:emoticon-happy": 0xFC4D,
    "mdi:emoticon-happy-outline": 0xF1F5,
    "mdi:emoticon-kiss": 0xFC4E,
    "mdi:emoticon-kiss-outline": 0xFC4F,
    "mdi:emoticon-neutral": 0xFC50,
    "mdi:emoticon-neutral-outline": 0xF1F6,
    "mdi:emoticon-outline": 0xF1F2,
    "mdi:emoticon-poop": 0xF1F7,
    "mdi:emoticon-poop-outline": 0xFC51,
    "mdi:emoticon-sad": 0xFC52,
    "mdi:emoticon-sad-outline": 0xF1F8,
    "mdi:emoticon-tongue": 0xF1F9,
    "mdi:emoticon-tongue-outline": 0xFC53,
    "mdi:emoticon-wink": 0xFC54,
    "mdi:emoticon-wink-outline": 0xFC55,
    "mdi:engine": 0xF1FA,
    "mdi:engine-off": 0xFA45,
    "mdi:engine-off-outline": 0xFA46,
    "mdi:engine-outline": 0xF1FB,
    "mdi:epsilon": 0xF010B,
    "mdi:equal": 0xF1FC,
    "mdi:equal-box": 0xF1FD,
    "mdi:equalizer": 0xFEBF,
    "mdi:equalizer-outline": 0xFEC0,
    "mdi:eraser": 0xF1FE,
    "mdi:eraser-variant": 0xF642,
    "mdi:escalator": 0xF1FF,
    "mdi:eslint": 0xFC56,
    "mdi:et": 0xFAB2,
    "mdi:ethereum": 0xF869,
    "mdi:ethernet": 0xF200,
    "mdi:ethernet-cable": 0xF201,
    "mdi:ethernet-cable-off": 0xF202,
    "mdi:etsy": 0xF203,
    "mdi:ev-station": 0xF5F1,
    "mdi:eventbrite": 0xF7C6,
    "mdi:evernote": 0xF204,
    "mdi:excavator": 0xF0047,
    "mdi:exclamation": 0xF205,
    "mdi:exit-run": 0xFA47,
    "mdi:exit-to-app": 0xF206,
    "mdi:expand-all": 0xFAB3,
    "mdi:expand-all-outline": 0xFAB4,
    "mdi:expansion-card": 0xF8AD,
    "mdi:expansion-card-variant": 0xFFD2,
    "mdi:exponent": 0xF962,
    "mdi:exponent-box": 0xF963,
    "mdi:export": 0xF207,
    "mdi:export-variant": 0xFB6F,
    "mdi:eye": 0xF208,
    "mdi:eye-check": 0xFCE0,
    "mdi:eye-check-outline": 0xFCE1,
    "mdi:eye-circle": 0xFB70,
    "mdi:eye-circle-outline": 0xFB71,
    "mdi:eye-minus": 0xF0048,
    "mdi:eye-minus-outline": 0xF0049,
    "mdi:eye-off": 0xF209,
    "mdi:eye-off-outline": 0xF6D0,
    "mdi:eye-outline": 0xF6CF,
    "mdi:eye-plus": 0xF86A,
    "mdi:eye-plus-outline": 0xF86B,
    "mdi:eye-settings": 0xF86C,
    "mdi:eye-settings-outline": 0xF86D,
    "mdi:eyedropper": 0xF20A,
    "mdi:eyedropper-variant": 0xF20B,
    "mdi:face": 0xF643,
    "mdi:face-agent": 0xFD4C,
    "mdi:face-outline": 0xFB72,
    "mdi:face-profile": 0xF644,
    "mdi:face-profile-woman": 0xF00A1,
    "mdi:face-recognition": 0xFC57,
    "mdi:face-woman": 0xF00A2,
    "mdi:face-woman-outline": 0xF00A3,
    "mdi:facebook": 0xF20C,
    "mdi:facebook-box": 0xF20D,
    "mdi:facebook-messenger": 0xF20E,
    "mdi:facebook-workplace": 0xFB16,
    "mdi:factory": 0xF20F,
    "mdi:fan": 0xF210,
    "mdi:fan-off": 0xF81C,
    "mdi:fast-forward": 0xF211,
    "mdi:fast-forward-10": 0xFD4D,
    "mdi:fast-forward-30": 0xFCE2,
    "mdi:fast-forward-outline": 0xF6D1,
    "mdi:fax": 0xF212,
    "mdi:feather": 0xF6D2,
    "mdi:feature-search": 0xFA48,
    "mdi:feature-search-outline": 0xFA49,
    "mdi:fedora": 0xF8DA,
    "mdi:ferris-wheel": 0xFEC1,
    "mdi:ferry": 0xF213,
    "mdi:file": 0xF214,
    "mdi:file-account": 0xF73A,
    "mdi:file-account-outline": 0xF004A,
    "mdi:file-alert": 0xFA4A,
    "mdi:file-alert-outline": 0xFA4B,
    "mdi:file-cabinet": 0xFAB5,
    "mdi:file-cad": 0xFF08,
    "mdi:file-cad-box": 0xFF09,
    "mdi:file-cancel": 0xFDA2,
    "mdi:file-cancel-outline": 0xFDA3,
    "mdi:file-certificate": 0xF01B1,
    "mdi:file-certificate-outline": 0xF01B2,
    "mdi:file-chart": 0xF215,
    "mdi:file-chart-outline": 0xF004B,
    "mdi:file-check": 0xF216,
    "mdi:file-check-outline": 0xFE7B,
    "mdi:file-cloud": 0xF217,
    "mdi:file-cloud-outline": 0xF004C,
    "mdi:file-code": 0xF22E,
    "mdi:file-code-outline": 0xF004D,
    "mdi:file-compare": 0xF8A9,
    "mdi:file-delimited": 0xF218,
    "mdi:file-delimited-outline": 0xFEC2,
    "mdi:file-document": 0xF219,
    "mdi:file-document-box": 0xF21A,
    "mdi:file-document-box-check": 0xFEC3,
    "mdi:file-document-box-check-outline": 0xFEC4,
    "mdi:file-document-box-minus": 0xFEC5,
    "mdi:file-document-box-minus-outline": 0xFEC6,
    "mdi:file-document-box-multiple": 0xFAB6,
    "mdi:file-document-box-multiple-outline": 0xFAB7,
    "mdi:file-document-box-outline": 0xF9EC,
    "mdi:file-document-box-plus": 0xFEC7,
    "mdi:file-document-box-plus-outline": 0xFEC8,
    "mdi:file-document-box-remove": 0xFEC9,
    "mdi:file-document-box-remove-outline": 0xFECA,
    "mdi:file-document-box-search": 0xFECB,
    "mdi:file-document-box-search-outline": 0xFECC,
    "mdi:file-document-edit": 0xFDA4,
    "mdi:file-document-edit-outline": 0xFDA5,
    "mdi:file-document-outline": 0xF9ED,
    "mdi:file-download": 0xF964,
    "mdi:file-download-outline": 0xF965,
    "mdi:file-edit": 0xF0212,
    "mdi:file-edit-outline": 0xF0213,
    "mdi:file-excel": 0xF21B,
    "mdi:file-excel-box": 0xF21C,
    "mdi:file-excel-box-outline": 0xF004E,
    "mdi:file-excel-outline": 0xF004F,
    "mdi:file-export": 0xF21D,
    "mdi:file-export-outline": 0xF0050,
    "mdi:file-eye": 0xFDA6,
    "mdi:file-eye-outline": 0xFDA7,
    "mdi:file-find": 0xF21E,
    "mdi:file-find-outline": 0xFB73,
    "mdi:file-hidden": 0xF613,
    "mdi:file-image": 0xF21F,
    "mdi:file-image-outline": 0xFECD,
    "mdi:file-import": 0xF220,
    "mdi:file-import-outline": 0xF0051,
    "mdi:file-key": 0xF01AF,
    "mdi:file-key-outline": 0xF01B0,
    "mdi:file-link": 0xF01A2,
    "mdi:file-link-outline": 0xF01A3,
    "mdi:file-lock": 0xF221,
    "mdi:file-lock-outline": 0xF0052,
    "mdi:file-move": 0xFAB8,
    "mdi:file-move-outline": 0xF0053,
    "mdi:file-multiple": 0xF222,
    "mdi:file-multiple-outline": 0xF0054,
    "mdi:file-music": 0xF223,
    "mdi:file-music-outline": 0xFE7C,
    "mdi:file-outline": 0xF224,
    "mdi:file-pdf": 0xF225,
    "mdi:file-pdf-box": 0xF226,
    "mdi:file-pdf-box-outline": 0xFFD3,
    "mdi:file-pdf-outline": 0xFE7D,
    "mdi:file-percent": 0xF81D,
    "mdi:file-percent-outline": 0xF0055,
    "mdi:file-phone": 0xF01A4,
    "mdi:file-phone-outline": 0xF01A5,
    "mdi:file-plus": 0xF751,
    "mdi:file-plus-outline": 0xFF0A,
    "mdi:file-powerpoint": 0xF227,
    "mdi:file-powerpoint-box": 0xF228,
    "mdi:file-powerpoint-box-outline": 0xF0056,
    "mdi:file-powerpoint-outline": 0xF0057,
    "mdi:file-presentation-box": 0xF229,
    "mdi:file-question": 0xF86E,
    "mdi:file-question-outline": 0xF0058,
    "mdi:file-remove": 0xFB74,
    "mdi:file-remove-outline": 0xF0059,
    "mdi:file-replace": 0xFB17,
    "mdi:file-replace-outline": 0xFB18,
    "mdi:file-restore": 0xF670,
    "mdi:file-restore-outline": 0xF005A,
    "mdi:file-search": 0xFC58,
    "mdi:file-search-outline": 0xFC59,
    "mdi:file-send": 0xF22A,
    "mdi:file-send-outline": 0xF005B,
    "mdi:file-settings": 0xF00A4,
    "mdi:file-settings-outline": 0xF00A5,
    "mdi:file-settings-variant": 0xF00A6,
    "mdi:file-settings-variant-outline": 0xF00A7,
    "mdi:file-star": 0xF005C,
    "mdi:file-star-outline": 0xF005D,
    "mdi:file-swap": 0xFFD4,
    "mdi:file-swap-outline": 0xFFD5,
    "mdi:file-table": 0xFC5A,
    "mdi:file-table-box": 0xF010C,
    "mdi:file-table-box-multiple": 0xF010D,
    "mdi:file-table-box-multiple-outline": 0xF010E,
    "mdi:file-table-box-outline": 0xF010F,
    "mdi:file-table-outline": 0xFC5B,
    "mdi:file-tree": 0xF645,
    "mdi:file-undo": 0xF8DB,
    "mdi:file-undo-outline": 0xF005E,
    "mdi:file-upload": 0xFA4C,
    "mdi:file-upload-outline": 0xFA4D,
    "mdi:file-video": 0xF22B,
    "mdi:file-video-outline": 0xFE10,
    "mdi:file-word": 0xF22C,
    "mdi:file-word-box": 0xF22D,
    "mdi:file-word-box-outline": 0xF005F,
    "mdi:file-word-outline": 0xF0060,
    "mdi:film": 0xF22F,
    "mdi:filmstrip": 0xF230,
    "mdi:filmstrip-off": 0xF231,
    "mdi:filter": 0xF232,
    "mdi:filter-menu": 0xF0110,
    "mdi:filter-menu-outline": 0xF0111,
    "mdi:filter-minus": 0xFF0B,
    "mdi:filter-minus-outline": 0xFF0C,
    "mdi:filter-outline": 0xF233,
    "mdi:filter-plus": 0xFF0D,
    "mdi:filter-plus-outline": 0xFF0E,
    "mdi:filter-remove": 0xF234,
    "mdi:filter-remove-outline": 0xF235,
    "mdi:filter-variant": 0xF236,
    "mdi:filter-variant-minus": 0xF013D,
    "mdi:filter-variant-plus": 0xF013E,
    "mdi:filter-variant-remove": 0xF0061,
    "mdi:finance": 0xF81E,
    "mdi:find-replace": 0xF6D3,
    "mdi:fingerprint": 0xF237,
    "mdi:fingerprint-off": 0xFECE,
    "mdi:fire": 0xF238,
    "mdi:fire-extinguisher": 0xFF0F,
    "mdi:fire-hydrant": 0xF0162,
    "mdi:fire-hydrant-alert": 0xF0163,
    "mdi:fire-hydrant-off": 0xF0164,
    "mdi:fire-truck": 0xF8AA,
    "mdi:firebase": 0xF966,
    "mdi:firefox": 0xF239,
    "mdi:fireplace": 0xFE11,
    "mdi:fireplace-off": 0xFE12,
    "mdi:firework": 0xFE13,
    "mdi:fish": 0xF23A,
    "mdi:fishbowl": 0xFF10,
    "mdi:fishbowl-outline": 0xFF11,
    "mdi:fit-to-page": 0xFF12,
    "mdi:fit-to-page-outline": 0xFF13,
    "mdi:flag": 0xF23B,
    "mdi:flag-checkered": 0xF23C,
    "mdi:flag-minus": 0xFB75,
    "mdi:flag-minus-outline": 0xF00DD,
    "mdi:flag-outline": 0xF23D,
    "mdi:flag-plus": 0xFB76,
    "mdi:flag-plus-outline": 0xF00DE,
    "mdi:flag-remove": 0xFB77,
    "mdi:flag-remove-outline": 0xF00DF,
    "mdi:flag-triangle": 0xF23F,
    "mdi:flag-variant": 0xF240,
    "mdi:flag-variant-outline": 0xF23E,
    "mdi:flare": 0xFD4E,
    "mdi:flash": 0xF241,
    "mdi:flash-alert": 0xFF14,
    "mdi:flash-alert-outline": 0xFF15,
    "mdi:flash-auto": 0xF242,
    "mdi:flash-circle": 0xF81F,
    "mdi:flash-off": 0xF243,
    "mdi:flash-outline": 0xF6D4,
    "mdi:flash-red-eye": 0xF67A,
    "mdi:flashlight": 0xF244,
    "mdi:flashlight-off": 0xF245,
    "mdi:flask": 0xF093,
    "mdi:flask-empty": 0xF094,
    "mdi:flask-empty-outline": 0xF095,
    "mdi:flask-outline": 0xF096,
    "mdi:flattr": 0xF246,
    "mdi:flickr": 0xFCE3,
    "mdi:flip-horizontal": 0xF0112,
    "mdi:flip-to-back": 0xF247,
    "mdi:flip-to-front": 0xF248,
    "mdi:flip-vertical": 0xF0113,
    "mdi:floor-lamp": 0xF8DC,
    "mdi:floor-lamp-dual": 0xF0062,
    "mdi:floor-lamp-variant": 0xF0063,
    "mdi:floor-plan": 0xF820,
    "mdi:floppy": 0xF249,
    "mdi:floppy-variant": 0xF9EE,
    "mdi:flower": 0xF24A,
    "mdi:flower-outline": 0xF9EF,
    "mdi:flower-poppy": 0xFCE4,
    "mdi:flower-tulip": 0xF9F0,
    "mdi:flower-tulip-outline": 0xF9F1,
    "mdi:focus-auto": 0xFF6B,
    "mdi:focus-field": 0xFF6C,
    "mdi:focus-field-horizontal": 0xFF6D,
    "mdi:focus-field-vertical": 0xFF6E,
    "mdi:folder": 0xF24B,
    "mdi:folder-account": 0xF24C,
    "mdi:folder-account-outline": 0xFB78,
    "mdi:folder-alert": 0xFDA8,
    "mdi:folder-alert-outline": 0xFDA9,
    "mdi:folder-clock": 0xFAB9,
    "mdi:folder-clock-outline": 0xFABA,
    "mdi:folder-download": 0xF24D,
    "mdi:folder-download-outline": 0xF0114,
    "mdi:folder-edit": 0xF8DD,
    "mdi:folder-edit-outline": 0xFDAA,
    "mdi:folder-google-drive": 0xF24E,
    "mdi:folder-heart": 0xF0115,
    "mdi:folder-heart-outline": 0xF0116,
    "mdi:folder-home": 0xF00E0,
    "mdi:folder-home-outline": 0xF00E1,
    "mdi:folder-image": 0xF24F,
    "mdi:folder-information": 0xF00E2,
    "mdi:folder-information-outline": 0xF00E3,
    "mdi:folder-key": 0xF8AB,
    "mdi:folder-key-network": 0xF8AC,
    "mdi:folder-key-network-outline": 0xFC5C,
    "mdi:folder-key-outline": 0xF0117,
    "mdi:folder-lock": 0xF250,
    "mdi:folder-lock-open": 0xF251,
    "mdi:folder-move": 0xF252,
    "mdi:folder-multiple": 0xF253,
    "mdi:folder-multiple-image": 0xF254,
    "mdi:folder-multiple-outline": 0xF255,
    "mdi:folder-network": 0xF86F,
    "mdi:folder-network-outline": 0xFC5D,
    "mdi:folder-open": 0xF76F,
    "mdi:folder-open-outline": 0xFDAB,
    "mdi:folder-outline": 0xF256,
    "mdi:folder-plus": 0xF257,
    "mdi:folder-plus-outline": 0xFB79,
    "mdi:folder-pound": 0xFCE5,
    "mdi:folder-pound-outline": 0xFCE6,
    "mdi:folder-remove": 0xF258,
    "mdi:folder-remove-outline": 0xFB7A,
    "mdi:folder-search": 0xF967,
    "mdi:folder-search-outline": 0xF968,
    "mdi:folder-settings": 0xF00A8,
    "mdi:folder-settings-outline": 0xF00A9,
    "mdi:folder-settings-variant": 0xF00AA,
    "mdi:folder-settings-variant-outline": 0xF00AB,
    "mdi:folder-star": 0xF69C,
    "mdi:folder-star-outline": 0xFB7B,
    "mdi:folder-swap": 0xFFD6,
    "mdi:folder-swap-outline": 0xFFD7,
    "mdi:folder-sync": 0xFCE7,
    "mdi:folder-sync-outline": 0xFCE8,
    "mdi:folder-text": 0xFC5E,
    "mdi:folder-text-outline": 0xFC5F,
    "mdi:folder-upload": 0xF259,
    "mdi:folder-upload-outline": 0xF0118,
    "mdi:folder-zip": 0xF6EA,
    "mdi:folder-zip-outline": 0xF7B8,
    "mdi:font-awesome": 0xF03A,
    "mdi:food": 0xF25A,
    "mdi:food-apple": 0xF25B,
    "mdi:food-apple-outline": 0xFC60,
    "mdi:food-croissant": 0xF7C7,
    "mdi:food-fork-drink": 0xF5F2,
    "mdi:food-off": 0xF5F3,
    "mdi:food-variant": 0xF25C,
    "mdi:foot-print": 0xFF6F,
    "mdi:football": 0xF25D,
    "mdi:football-australian": 0xF25E,
    "mdi:football-helmet": 0xF25F,
    "mdi:forklift": 0xF7C8,
    "mdi:format-align-bottom": 0xF752,
    "mdi:format-align-center": 0xF260,
    "mdi:format-align-justify": 0xF261,
    "mdi:format-align-left": 0xF262,
    "mdi:format-align-middle": 0xF753,
    "mdi:format-align-right": 0xF263,
    "mdi:format-align-top": 0xF754,
    "mdi:format-annotation-minus": 0xFABB,
    "mdi:format-annotation-plus": 0xF646,
    "mdi:format-bold": 0xF264,
    "mdi:format-clear": 0xF265,
    "mdi:format-color-fill": 0xF266,
    "mdi:format-color-highlight": 0xFE14,
    "mdi:format-color-text": 0xF69D,
    "mdi:format-columns": 0xF8DE,
    "mdi:format-float-center": 0xF267,
    "mdi:format-float-left": 0xF268,
    "mdi:format-float-none": 0xF269,
    "mdi:format-float-right": 0xF26A,
    "mdi:format-font": 0xF6D5,
    "mdi:format-font-size-decrease": 0xF9F2,
    "mdi:format-font-size-increase": 0xF9F3,
    "mdi:format-header-1": 0xF26B,
    "mdi:format-header-2": 0xF26C,
    "mdi:format-header-3": 0xF26D,
    "mdi:format-header-4": 0xF26E,
    "mdi:format-header-5": 0xF26F,
    "mdi:format-header-6": 0xF270,
    "mdi:format-header-decrease": 0xF271,
    "mdi:format-header-equal": 0xF272,
    "mdi:format-header-increase": 0xF273,
    "mdi:format-header-pound": 0xF274,
    "mdi:format-horizontal-align-center": 0xF61E,
    "mdi:format-horizontal-align-left": 0xF61F,
    "mdi:format-horizontal-align-right": 0xF620,
    "mdi:format-indent-decrease": 0xF275,
    "mdi:format-indent-increase": 0xF276,
    "mdi:format-italic": 0xF277,
    "mdi:format-letter-case": 0xFB19,
    "mdi:format-letter-case-lower": 0xFB1A,
    "mdi:format-letter-case-upper": 0xFB1B,
    "mdi:format-letter-ends-with": 0xFFD8,
    "mdi:format-letter-matches": 0xFFD9,
    "mdi:format-letter-starts-with": 0xFFDA,
    "mdi:format-line-spacing": 0xF278,
    "mdi:format-line-style": 0xF5C8,
    "mdi:format-line-weight": 0xF5C9,
    "mdi:format-list-bulleted": 0xF279,
    "mdi:format-list-bulleted-square": 0xFDAC,
    "mdi:format-list-bulleted-triangle": 0xFECF,
    "mdi:format-list-bulleted-type": 0xF27A,
    "mdi:format-list-checkbox": 0xF969,
    "mdi:format-list-checks": 0xF755,
    "mdi:format-list-numbered": 0xF27B,
    "mdi:format-list-numbered-rtl": 0xFCE9,
    "mdi:format-overline": 0xFED0,
    "mdi:format-page-break": 0xF6D6,
    "mdi:format-paint": 0xF27C,
    "mdi:format-paragraph": 0xF27D,
    "mdi:format-pilcrow": 0xF6D7,
    "mdi:format-quote-close": 0xF27E,
    "mdi:format-quote-close-outline": 0xF01D3,
    "mdi:format-quote-open": 0xF756,
    "mdi:format-quote-open-outline": 0xF01D2,
    "mdi:format-rotate-90": 0xF6A9,
    "mdi:format-section": 0xF69E,
    "mdi:format-size": 0xF27F,
    "mdi:format-strikethrough": 0xF280,
    "mdi:format-strikethrough-variant": 0xF281,
    "mdi:format-subscript": 0xF282,
    "mdi:format-superscript": 0xF283,
    "mdi:format-text": 0xF284,
    "mdi:format-text-rotation-angle-down": 0xFFDB,
    "mdi:format-text-rotation-angle-up": 0xFFDC,
    "mdi:format-text-rotation-down": 0xFD4F,
    "mdi:format-text-rotation-down-vertical": 0xFFDD,
    "mdi:format-text-rotation-none": 0xFD50,
    "mdi:format-text-rotation-up": 0xFFDE,
    "mdi:format-text-rotation-vertical": 0xFFDF,
    "mdi:format-text-variant": 0xFE15,
    "mdi:format-text-wrapping-clip": 0xFCEA,
    "mdi:format-text-wrapping-overflow": 0xFCEB,
    "mdi:format-text-wrapping-wrap": 0xFCEC,
    "mdi:format-textbox": 0xFCED,
    "mdi:format-textdirection-l-to-r": 0xF285,
    "mdi:format-textdirection-r-to-l": 0xF286,
    "mdi:format-title": 0xF5F4,
    "mdi:format-underline": 0xF287,
    "mdi:format-vertical-align-bottom": 0xF621,
    "mdi:format-vertical-align-center": 0xF622,
    "mdi:format-vertical-align-top": 0xF623,
    "mdi:format-wrap-inline": 0xF288,
    "mdi:format-wrap-square": 0xF289,
    "mdi:format-wrap-tight": 0xF28A,
    "mdi:format-wrap-top-bottom": 0xF28B,
    "mdi:forum": 0xF28C,
    "mdi:forum-outline": 0xF821,
    "mdi:forward": 0xF28D,
    "mdi:forwardburger": 0xFD51,
    "mdi:fountain": 0xF96A,
    "mdi:fountain-pen": 0xFCEE,
    "mdi:fountain-pen-tip": 0xFCEF,
    "mdi:foursquare": 0xF28E,
    "mdi:freebsd": 0xF8DF,
    "mdi:frequently-asked-questions": 0xFED1,
    "mdi:fridge": 0xF290,
    "mdi:fridge-alert": 0xF01DC,
    "mdi:fridge-alert-outline": 0xF01DD,
    "mdi:fridge-bottom": 0xF292,
    "mdi:fridge-off": 0xF01DA,
    "mdi:fridge-off-outline": 0xF01DB,
    "mdi:fridge-outline": 0xF28F,
    "mdi:fridge-top": 0xF291,
    "mdi:fruit-cherries": 0xF0064,
    "mdi:fruit-citrus": 0xF0065,
    "mdi:fruit-grapes": 0xF0066,
    "mdi:fruit-grapes-outline": 0xF0067,
    "mdi:fruit-pineapple": 0xF0068,
    "mdi:fruit-watermelon": 0xF0069,
    "mdi:fuel": 0xF7C9,
    "mdi:fullscreen": 0xF293,
    "mdi:fullscreen-exit": 0xF294,
    "mdi:function": 0xF295,
    "mdi:function-variant": 0xF870,
    "mdi:furigana-horizontal": 0xF00AC,
    "mdi:furigana-vertical": 0xF00AD,
    "mdi:fuse": 0xFC61,
    "mdi:fuse-blade": 0xFC62,
    "mdi:gamepad": 0xF296,
    "mdi:gamepad-circle": 0xFE16,
    "mdi:gamepad-circle-down": 0xFE17,
    "mdi:gamepad-circle-left": 0xFE18,
    "mdi:gamepad-circle-outline": 0xFE19,
    "mdi:gamepad-circle-right": 0xFE1A,
    "mdi:gamepad-circle-up": 0xFE1B,
    "mdi:gamepad-down": 0xFE1C,
    "mdi:gamepad-left": 0xFE1D,
    "mdi:gamepad-right": 0xFE1E,
    "mdi:gamepad-round": 0xFE1F,
    "mdi:gamepad-round-down": 0xFE7E,
    "mdi:gamepad-round-left": 0xFE7F,
    "mdi:gamepad-round-outline": 0xFE80,
    "mdi:gamepad-round-right": 0xFE81,
    "mdi:gamepad-round-up": 0xFE82,
    "mdi:gamepad-square": 0xFED2,
    "mdi:gamepad-square-outline": 0xFED3,
    "mdi:gamepad-up": 0xFE83,
    "mdi:gamepad-variant": 0xF297,
    "mdi:gamepad-variant-outline": 0xFED4,
    "mdi:gamma": 0xF0119,
    "mdi:gantry-crane": 0xFDAD,
    "mdi:garage": 0xF6D8,
    "mdi:garage-alert": 0xF871,
    "mdi:garage-open": 0xF6D9,
    "mdi:gas-cylinder": 0xF647,
    "mdi:gas-station": 0xF298,
    "mdi:gas-station-outline": 0xFED5,
    "mdi:gate": 0xF299,
    "mdi:gate-and": 0xF8E0,
    "mdi:gate-arrow-right": 0xF0194,
    "mdi:gate-nand": 0xF8E1,
    "mdi:gate-nor": 0xF8E2,
    "mdi:gate-not": 0xF8E3,
    "mdi:gate-open": 0xF0195,
    "mdi:gate-or": 0xF8E4,
    "mdi:gate-xnor": 0xF8E5,
    "mdi:gate-xor": 0xF8E6,
    "mdi:gatsby": 0xFE84,
    "mdi:gauge": 0xF29A,
    "mdi:gauge-empty": 0xF872,
    "mdi:gauge-full": 0xF873,
    "mdi:gauge-low": 0xF874,
    "mdi:gavel": 0xF29B,
    "mdi:gender-female": 0xF29C,
    "mdi:gender-male": 0xF29D,
    "mdi:gender-male-female": 0xF29E,
    "mdi:gender-male-female-variant": 0xF016A,
    "mdi:gender-non-binary": 0xF016B,
    "mdi:gender-transgender": 0xF29F,
    "mdi:gentoo": 0xF8E7,
    "mdi:gesture": 0xF7CA,
    "mdi:gesture-double-tap": 0xF73B,
    "mdi:gesture-pinch": 0xFABC,
    "mdi:gesture-spread": 0xFABD,
    "mdi:gesture-swipe": 0xFD52,
    "mdi:gesture-swipe-down": 0xF73C,
    "mdi:gesture-swipe-horizontal": 0xFABE,
    "mdi:gesture-swipe-left": 0xF73D,
    "mdi:gesture-swipe-right": 0xF73E,
    "mdi:gesture-swipe-up": 0xF73F,
    "mdi:gesture-swipe-vertical": 0xFABF,
    "mdi:gesture-tap": 0xF740,
    "mdi:gesture-tap-hold": 0xFD53,
    "mdi:gesture-two-double-tap": 0xF741,
    "mdi:gesture-two-tap": 0xF742,
    "mdi:ghost": 0xF2A0,
    "mdi:ghost-off": 0xF9F4,
    "mdi:gif": 0xFD54,
    "mdi:gift": 0xFE85,
    "mdi:gift-outline": 0xF2A1,
    "mdi:git": 0xF2A2,
    "mdi:github-box": 0xF2A3,
    "mdi:github-circle": 0xF2A4,
    "mdi:github-face": 0xF6DA,
    "mdi:gitlab": 0xFB7C,
    "mdi:glass-cocktail": 0xF356,
    "mdi:glass-flute": 0xF2A5,
    "mdi:glass-mug": 0xF2A6,
    "mdi:glass-mug-variant": 0xF0141,
    "mdi:glass-stange": 0xF2A7,
    "mdi:glass-tulip": 0xF2A8,
    "mdi:glass-wine": 0xF875,
    "mdi:glassdoor": 0xF2A9,
    "mdi:glasses": 0xF2AA,
    "mdi:globe-model": 0xF8E8,
    "mdi:gmail": 0xF2AB,
    "mdi:gnome": 0xF2AC,
    "mdi:go-kart": 0xFD55,
    "mdi:go-kart-track": 0xFD56,
    "mdi:gog": 0xFB7D,
    "mdi:golf": 0xF822,
    "mdi:golf-cart": 0xF01CF,
    "mdi:golf-tee": 0xF00AE,
    "mdi:gondola": 0xF685,
    "mdi:goodreads": 0xFD57,
    "mdi:google": 0xF2AD,
    "mdi:google-adwords": 0xFC63,
    "mdi:google-analytics": 0xF7CB,
    "mdi:google-assistant": 0xF7CC,
    "mdi:google-cardboard": 0xF2AE,
    "mdi:google-chrome": 0xF2AF,
    "mdi:google-circles": 0xF2B0,
    "mdi:google-circles-communities": 0xF2B1,
    "mdi:google-circles-extended": 0xF2B2,
    "mdi:google-circles-group": 0xF2B3,
    "mdi:google-classroom": 0xF2C0,
    "mdi:google-controller": 0xF2B4,
    "mdi:google-controller-off": 0xF2B5,
    "mdi:google-drive": 0xF2B6,
    "mdi:google-earth": 0xF2B7,
    "mdi:google-fit": 0xF96B,
    "mdi:google-glass": 0xF2B8,
    "mdi:google-hangouts": 0xF2C9,
    "mdi:google-home": 0xF823,
    "mdi:google-keep": 0xF6DB,
    "mdi:google-lens": 0xF9F5,
    "mdi:google-maps": 0xF5F5,
    "mdi:google-my-business": 0xF006A,
    "mdi:google-nearby": 0xF2B9,
    "mdi:google-pages": 0xF2BA,
    "mdi:google-photos": 0xF6DC,
    "mdi:google-physical-web": 0xF2BB,
    "mdi:google-play": 0xF2BC,
    "mdi:google-plus": 0xF2BD,
    "mdi:google-plus-box": 0xF2BE,
    "mdi:google-podcast": 0xFED6,
    "mdi:google-spreadsheet": 0xF9F6,
    "mdi:google-street-view": 0xFC64,
    "mdi:google-translate": 0xF2BF,
    "mdi:gradient": 0xF69F,
    "mdi:grain": 0xFD58,
    "mdi:graph": 0xF006B,
    "mdi:graph-outline": 0xF006C,
    "mdi:graphql": 0xF876,
    "mdi:grave-stone": 0xFB7E,
    "mdi:grease-pencil": 0xF648,
    "mdi:greater-than": 0xF96C,
    "mdi:greater-than-or-equal": 0xF96D,
    "mdi:grid": 0xF2C1,
    "mdi:grid-large": 0xF757,
    "mdi:grid-off": 0xF2C2,
    "mdi:grill": 0xFE86,
    "mdi:grill-outline": 0xF01B5,
    "mdi:group": 0xF2C3,
    "mdi:guitar-acoustic": 0xF770,
    "mdi:guitar-electric": 0xF2C4,
    "mdi:guitar-pick": 0xF2C5,
    "mdi:guitar-pick-outline": 0xF2C6,
    "mdi:guy-fawkes-mask": 0xF824,
    "mdi:hackernews": 0xF624,
    "mdi:hail": 0xFAC0,
    "mdi:hair-dryer": 0xF011A,
    "mdi:hair-dryer-outline": 0xF011B,
    "mdi:halloween": 0xFB7F,
    "mdi:hamburger": 0xF684,
    "mdi:hammer": 0xF8E9,
    "mdi:hand": 0xFA4E,
    "mdi:hand-heart": 0xF011C,
    "mdi:hand-left": 0xFE87,
    "mdi:hand-okay": 0xFA4F,
    "mdi:hand-peace": 0xFA50,
    "mdi:hand-peace-variant": 0xFA51,
    "mdi:hand-pointing-down": 0xFA52,
    "mdi:hand-pointing-left": 0xFA53,
    "mdi:hand-pointing-right": 0xF2C7,
    "mdi:hand-pointing-up": 0xFA54,
    "mdi:hand-right": 0xFE88,
    "mdi:hand-saw": 0xFE89,
    "mdi:handball": 0xFF70,
    "mdi:handcuffs": 0xF0169,
    "mdi:hanger": 0xF2C8,
    "mdi:hard-hat": 0xF96E,
    "mdi:harddisk": 0xF2CA,
    "mdi:harddisk-plus": 0xF006D,
    "mdi:harddisk-remove": 0xF006E,
    "mdi:hat-fedora": 0xFB80,
    "mdi:hazard-lights": 0xFC65,
    "mdi:hdr": 0xFD59,
    "mdi:hdr-off": 0xFD5A,
    "mdi:headphones": 0xF2CB,
    "mdi:headphones-bluetooth": 0xF96F,
    "mdi:headphones-box": 0xF2CC,
    "mdi:headphones-off": 0xF7CD,
    "mdi:headphones-settings": 0xF2CD,
    "mdi:headset": 0xF2CE,
    "mdi:headset-dock": 0xF2CF,
    "mdi:headset-off": 0xF2D0,
    "mdi:heart": 0xF2D1,
    "mdi:heart-box": 0xF2D2,
    "mdi:heart-box-outline": 0xF2D3,
    "mdi:heart-broken": 0xF2D4,
    "mdi:heart-broken-outline": 0xFCF0,
    "mdi:heart-circle": 0xF970,
    "mdi:heart-circle-outline": 0xF971,
    "mdi:heart-flash": 0xFF16,
    "mdi:heart-half": 0xF6DE,
    "mdi:heart-half-full": 0xF6DD,
    "mdi:heart-half-outline": 0xF6DF,
    "mdi:heart-multiple": 0xFA55,
    "mdi:heart-multiple-outline": 0xFA56,
    "mdi:heart-off": 0xF758,
    "mdi:heart-outline": 0xF2D5,
    "mdi:heart-pulse": 0xF5F6,
    "mdi:helicopter": 0xFAC1,
    "mdi:help": 0xF2D6,
    "mdi:help-box": 0xF78A,
    "mdi:help-circle": 0xF2D7,
    "mdi:help-circle-outline": 0xF625,
    "mdi:help-network": 0xF6F4,
    "mdi:help-network-outline": 0xFC66,
    "mdi:help-rhombus": 0xFB81,
    "mdi:help-rhombus-outline": 0xFB82,
    "mdi:hexagon": 0xF2D8,
    "mdi:hexagon-multiple": 0xF6E0,
    "mdi:hexagon-multiple-outline": 0xF011D,
    "mdi:hexagon-outline": 0xF2D9,
    "mdi:hexagon-slice-1": 0xFAC2,
    "mdi:hexagon-slice-2": 0xFAC3,
    "mdi:hexagon-slice-3": 0xFAC4,
    "mdi:hexagon-slice-4": 0xFAC5,
    "mdi:hexagon-slice-5": 0xFAC6,
    "mdi:hexagon-slice-6": 0xFAC7,
    "mdi:hexagram": 0xFAC8,
    "mdi:hexagram-outline": 0xFAC9,
    "mdi:high-definition": 0xF7CE,
    "mdi:high-definition-box": 0xF877,
    "mdi:highway": 0xF5F7,
    "mdi:hiking": 0xFD5B,
    "mdi:hinduism": 0xF972,
    "mdi:history": 0xF2DA,
    "mdi:hockey-puck": 0xF878,
    "mdi:hockey-sticks": 0xF879,
    "mdi:hololens": 0xF2DB,
    "mdi:home": 0xF2DC,
    "mdi:home-account": 0xF825,
    "mdi:home-alert": 0xF87A,
    "mdi:home-analytics": 0xFED7,
    "mdi:home-assistant": 0xF7CF,
    "mdi:home-automation": 0xF7D0,
    "mdi:home-circle": 0xF7D1,
    "mdi:home-circle-outline": 0xF006F,
    "mdi:home-city": 0xFCF1,
    "mdi:home-city-outline": 0xFCF2,
    "mdi:home-currency-usd": 0xF8AE,
    "mdi:home-edit": 0xF0184,
    "mdi:home-edit-outline": 0xF0185,
    "mdi:home-export-outline": 0xFFB8,
    "mdi:home-flood": 0xFF17,
    "mdi:home-floor-0": 0xFDAE,
    "mdi:home-floor-1": 0xFD5C,
    "mdi:home-floor-2": 0xFD5D,
    "mdi:home-floor-3": 0xFD5E,
    "mdi:home-floor-a": 0xFD5F,
    "mdi:home-floor-b": 0xFD60,
    "mdi:home-floor-g": 0xFD61,
    "mdi:home-floor-l": 0xFD62,
    "mdi:home-floor-negative-1": 0xFDAF,
    "mdi:home-group": 0xFDB0,
    "mdi:home-heart": 0xF826,
    "mdi:home-import-outline": 0xFFB9,
    "mdi:home-lock": 0xF8EA,
    "mdi:home-lock-open": 0xF8EB,
    "mdi:home-map-marker": 0xF5F8,
    "mdi:home-minus": 0xF973,
    "mdi:home-modern": 0xF2DD,
    "mdi:home-outline": 0xF6A0,
    "mdi:home-plus": 0xF974,
    "mdi:home-roof": 0xF0156,
    "mdi:home-thermometer": 0xFF71,
    "mdi:home-thermometer-outline": 0xFF72,
    "mdi:home-variant": 0xF2DE,
    "mdi:home-variant-outline": 0xFB83,
    "mdi:hook": 0xF6E1,
    "mdi:hook-off": 0xF6E2,
    "mdi:hops": 0xF2DF,
    "mdi:horizontal-rotate-clockwise": 0xF011E,
    "mdi:horizontal-rotate-counterclockwise": 0xF011F,
    "mdi:horseshoe": 0xFA57,
    "mdi:hospital": 0xF0017,
    "mdi:hospital-box": 0xF2E0,
    "mdi:hospital-box-outline": 0xF0018,
    "mdi:hospital-building": 0xF2E1,
    "mdi:hospital-marker": 0xF2E2,
    "mdi:hot-tub": 0xF827,
    "mdi:hotel": 0xF2E3,
    "mdi:houzz": 0xF2E4,
    "mdi:houzz-box": 0xF2E5,
    "mdi:hubspot": 0xFCF3,
    "mdi:hulu": 0xF828,
    "mdi:human": 0xF2E6,
    "mdi:human-child": 0xF2E7,
    "mdi:human-female": 0xF649,
    "mdi:human-female-boy": 0xFA58,
    "mdi:human-female-female": 0xFA59,
    "mdi:human-female-girl": 0xFA5A,
    "mdi:human-greeting": 0xF64A,
    "mdi:human-handsdown": 0xF64B,
    "mdi:human-handsup": 0xF64C,
    "mdi:human-male": 0xF64D,
    "mdi:human-male-boy": 0xFA5B,
    "mdi:human-male-female": 0xF2E8,
    "mdi:human-male-girl": 0xFA5C,
    "mdi:human-male-height": 0xFF18,
    "mdi:human-male-height-variant": 0xFF19,
    "mdi:human-male-male": 0xFA5D,
    "mdi:human-pregnant": 0xF5CF,
    "mdi:humble-bundle": 0xF743,
    "mdi:ice-cream": 0xF829,
    "mdi:ice-pop": 0xFF1A,
    "mdi:id-card": 0xFFE0,
    "mdi:identifier": 0xFF1B,
    "mdi:iframe": 0xFC67,
    "mdi:iframe-array": 0xF0120,
    "mdi:iframe-array-outline": 0xF0121,
    "mdi:iframe-braces": 0xF0122,
    "mdi:iframe-braces-outline": 0xF0123,
    "mdi:iframe-outline": 0xFC68,
    "mdi:iframe-parentheses": 0xF0124,
    "mdi:iframe-parentheses-outline": 0xF0125,
    "mdi:iframe-variable": 0xF0126,
    "mdi:iframe-variable-outline": 0xF0127,
    "mdi:image": 0xF2E9,
    "mdi:image-album": 0xF2EA,
    "mdi:image-area": 0xF2EB,
    "mdi:image-area-close": 0xF2EC,
    "mdi:image-auto-adjust": 0xFFE1,
    "mdi:image-broken": 0xF2ED,
    "mdi:image-broken-variant": 0xF2EE,
    "mdi:image-edit": 0xF020E,
    "mdi:image-edit-outline": 0xF020F,
    "mdi:image-filter": 0xF2EF,
    "mdi:image-filter-black-white": 0xF2F0,
    "mdi:image-filter-center-focus": 0xF2F1,
    "mdi:image-filter-center-focus-strong": 0xFF1C,
    "mdi:image-filter-center-focus-strong-outline": 0xFF1D,
    "mdi:image-filter-center-focus-weak": 0xF2F2,
    "mdi:image-filter-drama": 0xF2F3,
    "mdi:image-filter-frames": 0xF2F4,
    "mdi:image-filter-hdr": 0xF2F5,
    "mdi:image-filter-none": 0xF2F6,
    "mdi:image-filter-tilt-shift": 0xF2F7,
    "mdi:image-filter-vintage": 0xF2F8,
    "mdi:image-frame": 0xFE8A,
    "mdi:image-move": 0xF9F7,
    "mdi:image-multiple": 0xF2F9,
    "mdi:image-off": 0xF82A,
    "mdi:image-off-outline": 0xF01FC,
    "mdi:image-outline": 0xF975,
    "mdi:image-plus": 0xF87B,
    "mdi:image-search": 0xF976,
    "mdi:image-search-outline": 0xF977,
    "mdi:image-size-select-actual": 0xFC69,
    "mdi:image-size-select-large": 0xFC6A,
    "mdi:image-size-select-small": 0xFC6B,
    "mdi:import": 0xF2FA,
    "mdi:inbox": 0xF686,
    "mdi:inbox-arrow-down": 0xF2FB,
    "mdi:inbox-arrow-up": 0xF3D1,
    "mdi:inbox-multiple": 0xF8AF,
    "mdi:inbox-multiple-outline": 0xFB84,
    "mdi:incognito": 0xF5F9,
    "mdi:infinity": 0xF6E3,
    "mdi:information": 0xF2FC,
    "mdi:information-outline": 0xF2FD,
    "mdi:information-variant": 0xF64E,
    "mdi:instagram": 0xF2FE,
    "mdi:instapaper": 0xF2FF,
    "mdi:instrument-triangle": 0xF0070,
    "mdi:internet-explorer": 0xF300,
    "mdi:invert-colors": 0xF301,
    "mdi:invert-colors-off": 0xFE8B,
    "mdi:ip": 0xFA5E,
    "mdi:ip-network": 0xFA5F,
    "mdi:ip-network-outline": 0xFC6C,
    "mdi:ipod": 0xFC6D,
    "mdi:islam": 0xF978,
    "mdi:island": 0xF0071,
    "mdi:itunes": 0xF676,
    "mdi:iv-bag": 0xF00E4,
    "mdi:jabber": 0xFDB1,
    "mdi:jeepney": 0xF302,
    "mdi:jellyfish": 0xFF1E,
    "mdi:jellyfish-outline": 0xFF1F,
    "mdi:jira": 0xF303,
    "mdi:jquery": 0xF87C,
    "mdi:jsfiddle": 0xF304,
    "mdi:json": 0xF626,
    "mdi:judaism": 0xF979,
    "mdi:kabaddi": 0xFD63,
    "mdi:karate": 0xF82B,
    "mdi:keg": 0xF305,
    "mdi:kettle": 0xF5FA,
    "mdi:kettle-outline": 0xFF73,
    "mdi:key": 0xF306,
    "mdi:key-change": 0xF307,
    "mdi:key-link": 0xF01CA,
    "mdi:key-minus": 0xF308,
    "mdi:key-outline": 0xFDB2,
    "mdi:key-plus": 0xF309,
    "mdi:key-remove": 0xF30A,
    "mdi:key-star": 0xF01C9,
    "mdi:key-variant": 0xF30B,
    "mdi:key-wireless": 0xFFE2,
    "mdi:keyboard": 0xF30C,
    "mdi:keyboard-backspace": 0xF30D,
    "mdi:keyboard-caps": 0xF30E,
    "mdi:keyboard-close": 0xF30F,
    "mdi:keyboard-off": 0xF310,
    "mdi:keyboard-off-outline": 0xFE8C,
    "mdi:keyboard-outline": 0xF97A,
    "mdi:keyboard-return": 0xF311,
    "mdi:keyboard-settings": 0xF9F8,
    "mdi:keyboard-settings-outline": 0xF9F9,
    "mdi:keyboard-space": 0xF0072,
    "mdi:keyboard-tab": 0xF312,
    "mdi:keyboard-variant": 0xF313,
    "mdi:khanda": 0xF0128,
    "mdi:kickstarter": 0xF744,
    "mdi:knife": 0xF9FA,
    "mdi:knife-military": 0xF9FB,
    "mdi:kodi": 0xF314,
    "mdi:kubernetes": 0xF0129,
    "mdi:label": 0xF315,
    "mdi:label-off": 0xFACA,
    "mdi:label-off-outline": 0xFACB,
    "mdi:label-outline": 0xF316,
    "mdi:label-variant": 0xFACC,
    "mdi:label-variant-outline": 0xFACD,
    "mdi:ladybug": 0xF82C,
    "mdi:lambda": 0xF627,
    "mdi:lamp": 0xF6B4,
    "mdi:lan": 0xF317,
    "mdi:lan-connect": 0xF318,
    "mdi:lan-disconnect": 0xF319,
    "mdi:lan-pending": 0xF31A,
    "mdi:language-c": 0xF671,
    "mdi:language-cpp": 0xF672,
    "mdi:language-csharp": 0xF31B,
    "mdi:language-css3": 0xF31C,
    "mdi:language-go": 0xF7D2,
    "mdi:language-haskell": 0xFC6E,
    "mdi:language-html5": 0xF31D,
    "mdi:language-java": 0xFB1C,
    "mdi:language-javascript": 0xF31E,
    "mdi:language-lua": 0xF8B0,
    "mdi:language-php": 0xF31F,
    "mdi:language-python": 0xF320,
    "mdi:language-python-text": 0xF321,
    "mdi:language-r": 0xF7D3,
    "mdi:language-ruby-on-rails": 0xFACE,
    "mdi:language-swift": 0xF6E4,
    "mdi:language-typescript": 0xF6E5,
    "mdi:laptop": 0xF322,
    "mdi:laptop-chromebook": 0xF323,
    "mdi:laptop-mac": 0xF324,
    "mdi:laptop-off": 0xF6E6,
    "mdi:laptop-windows": 0xF325,
    "mdi:laravel": 0xFACF,
    "mdi:lasso": 0xFF20,
    "mdi:lastfm": 0xF326,
    "mdi:lastpass": 0xF446,
    "mdi:latitude": 0xFF74,
    "mdi:launch": 0xF327,
    "mdi:lava-lamp": 0xF7D4,
    "mdi:layers": 0xF328,
    "mdi:layers-minus": 0xFE8D,
    "mdi:layers-off": 0xF329,
    "mdi:layers-off-outline": 0xF9FC,
    "mdi:layers-outline": 0xF9FD,
    "mdi:layers-plus": 0xFE30,
    "mdi:layers-remove": 0xFE31,
    "mdi:layers-triple": 0xFF75,
    "mdi:layers-triple-outline": 0xFF76,
    "mdi:lead-pencil": 0xF64F,
    "mdi:leaf": 0xF32A,
    "mdi:leaf-maple": 0xFC6F,
    "mdi:leak": 0xFDB3,
    "mdi:leak-off": 0xFDB4,
    "mdi:led-off": 0xF32B,
    "mdi:led-on": 0xF32C,
    "mdi:led-outline": 0xF32D,
    "mdi:led-strip": 0xF7D5,
    "mdi:led-strip-variant": 0xF0073,
    "mdi:led-variant-off": 0xF32E,
    "mdi:led-variant-on": 0xF32F,
    "mdi:led-variant-outline": 0xF330,
    "mdi:leek": 0xF01A8,
    "mdi:less-than": 0xF97B,
    "mdi:less-than-or-equal": 0xF97C,
    "mdi:library": 0xF331,
    "mdi:library-books": 0xF332,
    "mdi:library-movie": 0xFCF4,
    "mdi:library-music": 0xF333,
    "mdi:library-music-outline": 0xFF21,
    "mdi:library-shelves": 0xFB85,
    "mdi:library-video": 0xFCF5,
    "mdi:license": 0xFFE3,
    "mdi:lifebuoy": 0xF87D,
    "mdi:light-switch": 0xF97D,
    "mdi:lightbulb": 0xF335,
    "mdi:lightbulb-off": 0xFE32,
    "mdi:lightbulb-off-outline": 0xFE33,
    "mdi:lightbulb-on": 0xF6E7,
    "mdi:lightbulb-on-outline": 0xF6E8,
    "mdi:lightbulb-outline": 0xF336,
    "mdi:lighthouse": 0xF9FE,
    "mdi:lighthouse-on": 0xF9FF,
    "mdi:link": 0xF337,
    "mdi:link-box": 0xFCF6,
    "mdi:link-box-outline": 0xFCF7,
    "mdi:link-box-variant": 0xFCF8,
    "mdi:link-box-variant-outline": 0xFCF9,
    "mdi:link-lock": 0xF00E5,
    "mdi:link-off": 0xF338,
    "mdi:link-plus": 0xFC70,
    "mdi:link-variant": 0xF339,
    "mdi:link-variant-minus": 0xF012A,
    "mdi:link-variant-off": 0xF33A,
    "mdi:link-variant-plus": 0xF012B,
    "mdi:link-variant-remove": 0xF012C,
    "mdi:linkedin": 0xF33B,
    "mdi:linkedin-box": 0xF33C,
    "mdi:linux": 0xF33D,
    "mdi:linux-mint": 0xF8EC,
    "mdi:litecoin": 0xFA60,
    "mdi:loading": 0xF771,
    "mdi:location-enter": 0xFFE4,
    "mdi:location-exit": 0xFFE5,
    "mdi:lock": 0xF33E,
    "mdi:lock-alert": 0xF8ED,
    "mdi:lock-clock": 0xF97E,
    "mdi:lock-open": 0xF33F,
    "mdi:lock-open-outline": 0xF340,
    "mdi:lock-open-variant": 0xFFE6,
    "mdi:lock-open-variant-outline": 0xFFE7,
    "mdi:lock-outline": 0xF341,
    "mdi:lock-pattern": 0xF6E9,
    "mdi:lock-plus": 0xF5FB,
    "mdi:lock-question": 0xF8EE,
    "mdi:lock-reset": 0xF772,
    "mdi:lock-smart": 0xF8B1,
    "mdi:locker": 0xF7D6,
    "mdi:locker-multiple": 0xF7D7,
    "mdi:login": 0xF342,
    "mdi:login-variant": 0xF5FC,
    "mdi:logout": 0xF343,
    "mdi:logout-variant": 0xF5FD,
    "mdi:longitude": 0xFF77,
    "mdi:looks": 0xF344,
    "mdi:loupe": 0xF345,
    "mdi:lumx": 0xF346,
    "mdi:lungs": 0xF00AF,
    "mdi:lyft": 0xFB1D,
    "mdi:magnet": 0xF347,
    "mdi:magnet-on": 0xF348,
    "mdi:magnify": 0xF349,
    "mdi:magnify-close": 0xF97F,
    "mdi:magnify-minus": 0xF34A,
    "mdi:magnify-minus-cursor": 0xFA61,
    "mdi:magnify-minus-outline": 0xF6EB,
    "mdi:magnify-plus": 0xF34B,
    "mdi:magnify-plus-cursor": 0xFA62,
    "mdi:magnify-plus-outline": 0xF6EC,
    "mdi:mail": 0xFED8,
    "mdi:mail-ru": 0xF34C,
    "mdi:mailbox": 0xF6ED,
    "mdi:mailbox-open": 0xFD64,
    "mdi:mailbox-open-outline": 0xFD65,
    "mdi:mailbox-open-up": 0xFD66,
    "mdi:mailbox-open-up-outline": 0xFD67,
    "mdi:mailbox-outline": 0xFD68,
    "mdi:mailbox-up": 0xFD69,
    "mdi:mailbox-up-outline": 0xFD6A,
    "mdi:map": 0xF34D,
    "mdi:map-check": 0xFED9,
    "mdi:map-check-outline": 0xFEDA,
    "mdi:map-clock": 0xFCFA,
    "mdi:map-clock-outline": 0xFCFB,
    "mdi:map-legend": 0xFA00,
    "mdi:map-marker": 0xF34E,
    "mdi:map-marker-alert": 0xFF22,
    "mdi:map-marker-alert-outline": 0xFF23,
    "mdi:map-marker-check": 0xFC71,
    "mdi:map-marker-circle": 0xF34F,
    "mdi:map-marker-distance": 0xF8EF,
    "mdi:map-marker-down": 0xF012D,
    "mdi:map-marker-minus": 0xF650,
    "mdi:map-marker-multiple": 0xF350,
    "mdi:map-marker-off": 0xF351,
    "mdi:map-marker-outline": 0xF7D8,
    "mdi:map-marker-path": 0xFCFC,
    "mdi:map-marker-plus": 0xF651,
    "mdi:map-marker-question": 0xFF24,
    "mdi:map-marker-question-outline": 0xFF25,
    "mdi:map-marker-radius": 0xF352,
    "mdi:map-marker-remove": 0xFF26,
    "mdi:map-marker-remove-variant": 0xFF27,
    "mdi:map-marker-up": 0xF012E,
    "mdi:map-minus": 0xF980,
    "mdi:map-outline": 0xF981,
    "mdi:map-plus": 0xF982,
    "mdi:map-search": 0xF983,
    "mdi:map-search-outline": 0xF984,
    "mdi:mapbox": 0xFB86,
    "mdi:margin": 0xF353,
    "mdi:markdown": 0xF354,
    "mdi:markdown-outline": 0xFF78,
    "mdi:marker": 0xF652,
    "mdi:marker-cancel": 0xFDB5,
    "mdi:marker-check": 0xF355,
    "mdi:mastodon": 0xFAD0,
    "mdi:mastodon-variant": 0xFAD1,
    "mdi:material-design": 0xF985,
    "mdi:material-ui": 0xF357,
    "mdi:math-compass": 0xF358,
    "mdi:math-cos": 0xFC72,
    "mdi:math-integral": 0xFFE8,
    "mdi:math-integral-box": 0xFFE9,
    "mdi:math-log": 0xF00B0,
    "mdi:math-norm": 0xFFEA,
    "mdi:math-norm-box": 0xFFEB,
    "mdi:math-sin": 0xFC73,
    "mdi:math-tan": 0xFC74,
    "mdi:matrix": 0xF628,
    "mdi:maxcdn": 0xF359,
    "mdi:medal": 0xF986,
    "mdi:medical-bag": 0xF6EE,
    "mdi:meditation": 0xF01A6,
    "mdi:medium": 0xF35A,
    "mdi:meetup": 0xFAD2,
    "mdi:memory": 0xF35B,
    "mdi:menu": 0xF35C,
    "mdi:menu-down": 0xF35D,
    "mdi:menu-down-outline": 0xF6B5,
    "mdi:menu-left": 0xF35E,
    "mdi:menu-left-outline": 0xFA01,
    "mdi:menu-open": 0xFB87,
    "mdi:menu-right": 0xF35F,
    "mdi:menu-right-outline": 0xFA02,
    "mdi:menu-swap": 0xFA63,
    "mdi:menu-swap-outline": 0xFA64,
    "mdi:menu-up": 0xF360,
    "mdi:menu-up-outline": 0xF6B6,
    "mdi:merge": 0xFF79,
    "mdi:message": 0xF361,
    "mdi:message-alert": 0xF362,
    "mdi:message-alert-outline": 0xFA03,
    "mdi:message-bulleted": 0xF6A1,
    "mdi:message-bulleted-off": 0xF6A2,
    "mdi:message-draw": 0xF363,
    "mdi:message-image": 0xF364,
    "mdi:message-image-outline": 0xF0197,
    "mdi:message-lock": 0xFFEC,
    "mdi:message-lock-outline": 0xF0198,
    "mdi:message-minus": 0xF0199,
    "mdi:message-minus-outline": 0xF019A,
    "mdi:message-outline": 0xF365,
    "mdi:message-plus": 0xF653,
    "mdi:message-plus-outline": 0xF00E6,
    "mdi:message-processing": 0xF366,
    "mdi:message-processing-outline": 0xF019B,
    "mdi:message-reply": 0xF367,
    "mdi:message-reply-text": 0xF368,
    "mdi:message-settings": 0xF6EF,
    "mdi:message-settings-outline": 0xF019C,
    "mdi:message-settings-variant": 0xF6F0,
    "mdi:message-settings-variant-outline": 0xF019D,
    "mdi:message-text": 0xF369,
    "mdi:message-text-clock": 0xF019E,
    "mdi:message-text-clock-outline": 0xF019F,
    "mdi:message-text-lock": 0xFFED,
    "mdi:message-text-lock-outline": 0xF01A0,
    "mdi:message-text-outline": 0xF36A,
    "mdi:message-video": 0xF36B,
    "mdi:meteor": 0xF629,
    "mdi:metronome": 0xF7D9,
    "mdi:metronome-tick": 0xF7DA,
    "mdi:micro-sd": 0xF7DB,
    "mdi:microphone": 0xF36C,
    "mdi:microphone-minus": 0xF8B2,
    "mdi:microphone-off": 0xF36D,
    "mdi:microphone-outline": 0xF36E,
    "mdi:microphone-plus": 0xF8B3,
    "mdi:microphone-settings": 0xF36F,
    "mdi:microphone-variant": 0xF370,
    "mdi:microphone-variant-off": 0xF371,
    "mdi:microscope": 0xF654,
    "mdi:microsoft": 0xF372,
    "mdi:microsoft-dynamics": 0xF987,
    "mdi:microwave": 0xFC75,
    "mdi:middleware": 0xFF7A,
    "mdi:middleware-outline": 0xFF7B,
    "mdi:midi": 0xF8F0,
    "mdi:midi-port": 0xF8F1,
    "mdi:mine": 0xFDB6,
    "mdi:minecraft": 0xF373,
    "mdi:mini-sd": 0xFA04,
    "mdi:minidisc": 0xFA05,
    "mdi:minus": 0xF374,
    "mdi:minus-box": 0xF375,
    "mdi:minus-box-multiple": 0xF016C,
    "mdi:minus-box-multiple-outline": 0xF016D,
    "mdi:minus-box-outline": 0xF6F1,
    "mdi:minus-circle": 0xF376,
    "mdi:minus-circle-outline": 0xF377,
    "mdi:minus-network": 0xF378,
    "mdi:minus-network-outline": 0xFC76,
    "mdi:mixcloud": 0xF62A,
    "mdi:mixed-martial-arts": 0xFD6B,
    "mdi:mixed-reality": 0xF87E,
    "mdi:mixer": 0xF7DC,
    "mdi:molecule": 0xFB88,
    "mdi:monitor": 0xF379,
    "mdi:monitor-cellphone": 0xF988,
    "mdi:monitor-cellphone-star": 0xF989,
    "mdi:monitor-clean": 0xF012F,
    "mdi:monitor-dashboard": 0xFA06,
    "mdi:monitor-lock": 0xFDB7,
    "mdi:monitor-multiple": 0xF37A,
    "mdi:monitor-off": 0xFD6C,
    "mdi:monitor-screenshot": 0xFE34,
    "mdi:monitor-speaker": 0xFF7C,
    "mdi:monitor-speaker-off": 0xFF7D,
    "mdi:monitor-star": 0xFDB8,
    "mdi:moon-first-quarter": 0xFF7E,
    "mdi:moon-full": 0xFF7F,
    "mdi:moon-last-quarter": 0xFF80,
    "mdi:moon-new": 0xFF81,
    "mdi:moon-waning-crescent": 0xFF82,
    "mdi:moon-waning-gibbous": 0xFF83,
    "mdi:moon-waxing-crescent": 0xFF84,
    "mdi:moon-waxing-gibbous": 0xFF85,
    "mdi:moped": 0xF00B1,
    "mdi:more": 0xF37B,
    "mdi:mother-nurse": 0xFCFD,
    "mdi:motion-sensor": 0xFD6D,
    "mdi:motorbike": 0xF37C,
    "mdi:mouse": 0xF37D,
    "mdi:mouse-bluetooth": 0xF98A,
    "mdi:mouse-off": 0xF37E,
    "mdi:mouse-variant": 0xF37F,
    "mdi:mouse-variant-off": 0xF380,
    "mdi:move-resize": 0xF655,
    "mdi:move-resize-variant": 0xF656,
    "mdi:movie": 0xF381,
    "mdi:movie-edit": 0xF014D,
    "mdi:movie-edit-outline": 0xF014E,
    "mdi:movie-filter": 0xF014F,
    "mdi:movie-filter-outline": 0xF0150,
    "mdi:movie-open": 0xFFEE,
    "mdi:movie-open-outline": 0xFFEF,
    "mdi:movie-outline": 0xFDB9,
    "mdi:movie-roll": 0xF7DD,
    "mdi:movie-search": 0xF01FD,
    "mdi:movie-search-outline": 0xF01FE,
    "mdi:muffin": 0xF98B,
    "mdi:multiplication": 0xF382,
    "mdi:multiplication-box": 0xF383,
    "mdi:mushroom": 0xF7DE,
    "mdi:mushroom-outline": 0xF7DF,
    "mdi:music": 0xF759,
    "mdi:music-accidental-double-flat": 0xFF86,
    "mdi:music-accidental-double-sharp": 0xFF87,
    "mdi:music-accidental-flat": 0xFF88,
    "mdi:music-accidental-natural": 0xFF89,
    "mdi:music-accidental-sharp": 0xFF8A,
    "mdi:music-box": 0xF384,
    "mdi:music-box-outline": 0xF385,
    "mdi:music-circle": 0xF386,
    "mdi:music-circle-outline": 0xFAD3,
    "mdi:music-clef-alto": 0xFF8B,
    "mdi:music-clef-bass": 0xFF8C,
    "mdi:music-clef-treble": 0xFF8D,
    "mdi:music-note": 0xF387,
    "mdi:music-note-bluetooth": 0xF5FE,
    "mdi:music-note-bluetooth-off": 0xF5FF,
    "mdi:music-note-eighth": 0xF388,
    "mdi:music-note-eighth-dotted": 0xFF8E,
    "mdi:music-note-half": 0xF389,
    "mdi:music-note-half-dotted": 0xFF8F,
    "mdi:music-note-off": 0xF38A,
    "mdi:music-note-off-outline": 0xFF90,
    "mdi:music-note-outline": 0xFF91,
    "mdi:music-note-plus": 0xFDBA,
    "mdi:music-note-quarter": 0xF38B,
    "mdi:music-note-quarter-dotted": 0xFF92,
    "mdi:music-note-sixteenth": 0xF38C,
    "mdi:music-note-sixteenth-dotted": 0xFF93,
    "mdi:music-note-whole": 0xF38D,
    "mdi:music-note-whole-dotted": 0xFF94,
    "mdi:music-off": 0xF75A,
    "mdi:music-rest-eighth": 0xFF95,
    "mdi:music-rest-half": 0xFF96,
    "mdi:music-rest-quarter": 0xFF97,
    "mdi:music-rest-sixteenth": 0xFF98,
    "mdi:music-rest-whole": 0xFF99,
    "mdi:nail": 0xFDBB,
    "mdi:nas": 0xF8F2,
    "mdi:nativescript": 0xF87F,
    "mdi:nature": 0xF38E,
    "mdi:nature-people": 0xF38F,
    "mdi:navigation": 0xF390,
    "mdi:near-me": 0xF5CD,
    "mdi:necklace": 0xFF28,
    "mdi:needle": 0xF391,
    "mdi:netflix": 0xF745,
    "mdi:network": 0xF6F2,
    "mdi:network-off": 0xFC77,
    "mdi:network-off-outline": 0xFC78,
    "mdi:network-outline": 0xFC79,
    "mdi:network-router": 0xF00B2,
    "mdi:network-strength-1": 0xF8F3,
    "mdi:network-strength-1-alert": 0xF8F4,
    "mdi:network-strength-2": 0xF8F5,
    "mdi:network-strength-2-alert": 0xF8F6,
    "mdi:network-strength-3": 0xF8F7,
    "mdi:network-strength-3-alert": 0xF8F8,
    "mdi:network-strength-4": 0xF8F9,
    "mdi:network-strength-4-alert": 0xF8FA,
    "mdi:network-strength-off": 0xF8FB,
    "mdi:network-strength-off-outline": 0xF8FC,
    "mdi:network-strength-outline": 0xF8FD,
    "mdi:new-box": 0xF394,
    "mdi:newspaper": 0xF395,
    "mdi:newspaper-minus": 0xFF29,
    "mdi:newspaper-plus": 0xFF2A,
    "mdi:newspaper-variant": 0xF0023,
    "mdi:newspaper-variant-multiple": 0xF0024,
    "mdi:newspaper-variant-multiple-outline": 0xF0025,
    "mdi:newspaper-variant-outline": 0xF0026,
    "mdi:nfc": 0xF396,
    "mdi:nfc-off": 0xFE35,
    "mdi:nfc-search-variant": 0xFE36,
    "mdi:nfc-tap": 0xF397,
    "mdi:nfc-variant": 0xF398,
    "mdi:nfc-variant-off": 0xFE37,
    "mdi:ninja": 0xF773,
    "mdi:nintendo-switch": 0xF7E0,
    "mdi:nix": 0xF0130,
    "mdi:nodejs": 0xF399,
    "mdi:noodles": 0xF01A9,
    "mdi:not-equal": 0xF98C,
    "mdi:not-equal-variant": 0xF98D,
    "mdi:note": 0xF39A,
    "mdi:note-multiple": 0xF6B7,
    "mdi:note-multiple-outline": 0xF6B8,
    "mdi:note-outline": 0xF39B,
    "mdi:note-plus": 0xF39C,
    "mdi:note-plus-outline": 0xF39D,
    "mdi:note-text": 0xF39E,
    "mdi:note-text-outline": 0xF0202,
    "mdi:notebook": 0xF82D,
    "mdi:notebook-multiple": 0xFE38,
    "mdi:notebook-outline": 0xFEDC,
    "mdi:notification-clear-all": 0xF39F,
    "mdi:npm": 0xF6F6,
    "mdi:npm-variant": 0xF98E,
    "mdi:npm-variant-outline": 0xF98F,
    "mdi:nuke": 0xF6A3,
    "mdi:null": 0xF7E1,
    "mdi:numeric": 0xF3A0,
    "mdi:numeric-0": 0x0030,
    "mdi:numeric-0-box": 0xF3A1,
    "mdi:numeric-0-box-multiple": 0xFF2B,
    "mdi:numeric-0-box-multiple-outline": 0xF3A2,
    "mdi:numeric-0-box-outline": 0xF3A3,
    "mdi:numeric-0-circle": 0xFC7A,
    "mdi:numeric-0-circle-outline": 0xFC7B,
    "mdi:numeric-1": 0x0031,
    "mdi:numeric-1-box": 0xF3A4,
    "mdi:numeric-1-box-multiple": 0xFF2C,
    "mdi:numeric-1-box-multiple-outline": 0xF3A5,
    "mdi:numeric-1-box-outline": 0xF3A6,
    "mdi:numeric-1-circle": 0xFC7C,
    "mdi:numeric-1-circle-outline": 0xFC7D,
    "mdi:numeric-10": 0xF000A,
    "mdi:numeric-10-box": 0xFF9A,
    "mdi:numeric-10-box-multiple": 0xF000B,
    "mdi:numeric-10-box-multiple-outline": 0xF000C,
    "mdi:numeric-10-box-outline": 0xFF9B,
    "mdi:numeric-10-circle": 0xF000D,
    "mdi:numeric-10-circle-outline": 0xF000E,
    "mdi:numeric-2": 0x0032,
    "mdi:numeric-2-box": 0xF3A7,
    "mdi:numeric-2-box-multiple": 0xFF2D,
    "mdi:numeric-2-box-multiple-outline": 0xF3A8,
    "mdi:numeric-2-box-outline": 0xF3A9,
    "mdi:numeric-2-circle": 0xFC7E,
    "mdi:numeric-2-circle-outline": 0xFC7F,
    "mdi:numeric-3": 0x0033,
    "mdi:numeric-3-box": 0xF3AA,
    "mdi:numeric-3-box-multiple": 0xFF2E,
    "mdi:numeric-3-box-multiple-outline": 0xF3AB,
    "mdi:numeric-3-box-outline": 0xF3AC,
    "mdi:numeric-3-circle": 0xFC80,
    "mdi:numeric-3-circle-outline": 0xFC81,
    "mdi:numeric-4": 0x0034,
    "mdi:numeric-4-box": 0xF3AD,
    "mdi:numeric-4-box-multiple": 0xFF2F,
    "mdi:numeric-4-box-multiple-outline": 0xF3AE,
    "mdi:numeric-4-box-outline": 0xF3AF,
    "mdi:numeric-4-circle": 0xFC82,
    "mdi:numeric-4-circle-outline": 0xFC83,
    "mdi:numeric-5": 0x0035,
    "mdi:numeric-5-box": 0xF3B0,
    "mdi:numeric-5-box-multiple": 0xFF30,
    "mdi:numeric-5-box-multiple-outline": 0xF3B1,
    "mdi:numeric-5-box-outline": 0xF3B2,
    "mdi:numeric-5-circle": 0xFC84,
    "mdi:numeric-5-circle-outline": 0xFC85,
    "mdi:numeric-6": 0x0036,
    "mdi:numeric-6-box": 0xF3B3,
    "mdi:numeric-6-box-multiple": 0xFF31,
    "mdi:numeric-6-box-multiple-outline": 0xF3B4,
    "mdi:numeric-6-box-outline": 0xF3B5,
    "mdi:numeric-6-circle": 0xFC86,
    "mdi:numeric-6-circle-outline": 0xFC87,
    "mdi:numeric-7": 0x0037,
    "mdi:numeric-7-box": 0xF3B6,
    "mdi:numeric-7-box-multiple": 0xFF32,
    "mdi:numeric-7-box-multiple-outline": 0xF3B7,
    "mdi:numeric-7-box-outline": 0xF3B8,
    "mdi:numeric-7-circle": 0xFC88,
    "mdi:numeric-7-circle-outline": 0xFC89,
    "mdi:numeric-8": 0x0038,
    "mdi:numeric-8-box": 0xF3B9,
    "mdi:numeric-8-box-multiple": 0xFF33,
    "mdi:numeric-8-box-multiple-outline": 0xF3BA,
    "mdi:numeric-8-box-outline": 0xF3BB,
    "mdi:numeric-8-circle": 0xFC8A,
    "mdi:numeric-8-circle-outline": 0xFC8B,
    "mdi:numeric-9": 0x0039,
    "mdi:numeric-9-box": 0xF3BC,
    "mdi:numeric-9-box-multiple": 0xFF34,
    "mdi:numeric-9-box-multiple-outline": 0xF3BD,
    "mdi:numeric-9-box-outline": 0xF3BE,
    "mdi:numeric-9-circle": 0xFC8C,
    "mdi:numeric-9-circle-outline": 0xFC8D,
    "mdi:numeric-9-plus": 0xF000F,
    "mdi:numeric-9-plus-box": 0xF3BF,
    "mdi:numeric-9-plus-box-multiple": 0xFF35,
    "mdi:numeric-9-plus-box-multiple-outline": 0xF3C0,
    "mdi:numeric-9-plus-box-outline": 0xF3C1,
    "mdi:numeric-9-plus-circle": 0xFC8E,
    "mdi:numeric-9-plus-circle-outline": 0xFC8F,
    "mdi:numeric-negative-1": 0xF0074,
    "mdi:nut": 0xF6F7,
    "mdi:nutrition": 0xF3C2,
    "mdi:nuxt": 0xF0131,
    "mdi:oar": 0xF67B,
    "mdi:ocarina": 0xFDBC,
    "mdi:ocr": 0xF0165,
    "mdi:octagon": 0xF3C3,
    "mdi:octagon-outline": 0xF3C4,
    "mdi:octagram": 0xF6F8,
    "mdi:octagram-outline": 0xF774,
    "mdi:odnoklassniki": 0xF3C5,
    "mdi:office": 0xF3C6,
    "mdi:office-building": 0xF990,
    "mdi:oil": 0xF3C7,
    "mdi:oil-lamp": 0xFF36,
    "mdi:oil-level": 0xF0075,
    "mdi:oil-temperature": 0xF0019,
    "mdi:omega": 0xF3C9,
    "mdi:one-up": 0xFB89,
    "mdi:onedrive": 0xF3CA,
    "mdi:onenote": 0xF746,
    "mdi:onepassword": 0xF880,
    "mdi:opacity": 0xF5CC,
    "mdi:open-in-app": 0xF3CB,
    "mdi:open-in-new": 0xF3CC,
    "mdi:open-source-initiative": 0xFB8A,
    "mdi:openid": 0xF3CD,
    "mdi:opera": 0xF3CE,
    "mdi:orbit": 0xF018,
    "mdi:origin": 0xFB2B,
    "mdi:ornament": 0xF3CF,
    "mdi:ornament-variant": 0xF3D0,
    "mdi:outdoor-lamp": 0xF0076,
    "mdi:outlook": 0xFCFE,
    "mdi:overscan": 0xF0027,
    "mdi:owl": 0xF3D2,
    "mdi:pac-man": 0xFB8B,
    "mdi:package": 0xF3D3,
    "mdi:package-down": 0xF3D4,
    "mdi:package-up": 0xF3D5,
    "mdi:package-variant": 0xF3D6,
    "mdi:package-variant-closed": 0xF3D7,
    "mdi:page-first": 0xF600,
    "mdi:page-last": 0xF601,
    "mdi:page-layout-body": 0xF6F9,
    "mdi:page-layout-footer": 0xF6FA,
    "mdi:page-layout-header": 0xF6FB,
    "mdi:page-layout-header-footer": 0xFF9C,
    "mdi:page-layout-sidebar-left": 0xF6FC,
    "mdi:page-layout-sidebar-right": 0xF6FD,
    "mdi:page-next": 0xFB8C,
    "mdi:page-next-outline": 0xFB8D,
    "mdi:page-previous": 0xFB8E,
    "mdi:page-previous-outline": 0xFB8F,
    "mdi:palette": 0xF3D8,
    "mdi:palette-advanced": 0xF3D9,
    "mdi:palette-outline": 0xFE6C,
    "mdi:palette-swatch": 0xF8B4,
    "mdi:palm-tree": 0xF0077,
    "mdi:pan": 0xFB90,
    "mdi:pan-bottom-left": 0xFB91,
    "mdi:pan-bottom-right": 0xFB92,
    "mdi:pan-down": 0xFB93,
    "mdi:pan-horizontal": 0xFB94,
    "mdi:pan-left": 0xFB95,
    "mdi:pan-right": 0xFB96,
    "mdi:pan-top-left": 0xFB97,
    "mdi:pan-top-right": 0xFB98,
    "mdi:pan-up": 0xFB99,
    "mdi:pan-vertical": 0xFB9A,
    "mdi:panda": 0xF3DA,
    "mdi:pandora": 0xF3DB,
    "mdi:panorama": 0xF3DC,
    "mdi:panorama-fisheye": 0xF3DD,
    "mdi:panorama-horizontal": 0xF3DE,
    "mdi:panorama-vertical": 0xF3DF,
    "mdi:panorama-wide-angle": 0xF3E0,
    "mdi:paper-cut-vertical": 0xF3E1,
    "mdi:paper-roll": 0xF0182,
    "mdi:paper-roll-outline": 0xF0183,
    "mdi:paperclip": 0xF3E2,
    "mdi:parachute": 0xFC90,
    "mdi:parachute-outline": 0xFC91,
    "mdi:parking": 0xF3E3,
    "mdi:party-popper": 0xF0078,
    "mdi:passport": 0xF7E2,
    "mdi:passport-biometric": 0xFDBD,
    "mdi:pasta": 0xF018B,
    "mdi:patio-heater": 0xFF9D,
    "mdi:patreon": 0xF881,
    "mdi:pause": 0xF3E4,
    "mdi:pause-circle": 0xF3E5,
    "mdi:pause-circle-outline": 0xF3E6,
    "mdi:pause-octagon": 0xF3E7,
    "mdi:pause-octagon-outline": 0xF3E8,
    "mdi:paw": 0xF3E9,
    "mdi:paw-off": 0xF657,
    "mdi:paypal": 0xF882,
    "mdi:pdf-box": 0xFE39,
    "mdi:peace": 0xF883,
    "mdi:peanut": 0xF001E,
    "mdi:peanut-off": 0xF001F,
    "mdi:peanut-off-outline": 0xF0021,
    "mdi:peanut-outline": 0xF0020,
    "mdi:pen": 0xF3EA,
    "mdi:pen-lock": 0xFDBE,
    "mdi:pen-minus": 0xFDBF,
    "mdi:pen-off": 0xFDC0,
    "mdi:pen-plus": 0xFDC1,
    "mdi:pen-remove": 0xFDC2,
    "mdi:pencil": 0xF3EB,
    "mdi:pencil-box": 0xF3EC,
    "mdi:pencil-box-multiple": 0xF016F,
    "mdi:pencil-box-multiple-outline": 0xF0170,
    "mdi:pencil-box-outline": 0xF3ED,
    "mdi:pencil-circle": 0xF6FE,
    "mdi:pencil-circle-outline": 0xF775,
    "mdi:pencil-lock": 0xF3EE,
    "mdi:pencil-lock-outline": 0xFDC3,
    "mdi:pencil-minus": 0xFDC4,
    "mdi:pencil-minus-outline": 0xFDC5,
    "mdi:pencil-off": 0xF3EF,
    "mdi:pencil-off-outline": 0xFDC6,
    "mdi:pencil-outline": 0xFC92,
    "mdi:pencil-plus": 0xFDC7,
    "mdi:pencil-plus-outline": 0xFDC8,
    "mdi:pencil-remove": 0xFDC9,
    "mdi:pencil-remove-outline": 0xFDCA,
    "mdi:penguin": 0xFEDD,
    "mdi:pentagon": 0xF6FF,
    "mdi:pentagon-outline": 0xF700,
    "mdi:percent": 0xF3F0,
    "mdi:periodic-table": 0xF8B5,
    "mdi:periodic-table-co2": 0xF7E3,
    "mdi:periscope": 0xF747,
    "mdi:perspective-less": 0xFCFF,
    "mdi:perspective-more": 0xFD00,
    "mdi:pharmacy": 0xF3F1,
    "mdi:phone": 0xF3F2,
    "mdi:phone-alert": 0xFF37,
    "mdi:phone-alert-outline": 0xF01B9,
    "mdi:phone-bluetooth": 0xF3F3,
    "mdi:phone-bluetooth-outline": 0xF01BA,
    "mdi:phone-cancel": 0xF00E7,
    "mdi:phone-cancel-outline": 0xF01BB,
    "mdi:phone-check": 0xF01D4,
    "mdi:phone-check-outline": 0xF01D5,
    "mdi:phone-classic": 0xF602,
    "mdi:phone-forward": 0xF3F4,
    "mdi:phone-forward-outline": 0xF01BC,
    "mdi:phone-hangup": 0xF3F5,
    "mdi:phone-hangup-outline": 0xF01BD,
    "mdi:phone-in-talk": 0xF3F6,
    "mdi:phone-in-talk-outline": 0xF01AD,
    "mdi:phone-incoming": 0xF3F7,
    "mdi:phone-incoming-outline": 0xF01BE,
    "mdi:phone-lock": 0xF3F8,
    "mdi:phone-lock-outline": 0xF01BF,
    "mdi:phone-log": 0xF3F9,
    "mdi:phone-log-outline": 0xF01C0,
    "mdi:phone-message": 0xF01C1,
    "mdi:phone-message-outline": 0xF01C2,
    "mdi:phone-minus": 0xF658,
    "mdi:phone-minus-outline": 0xF01C3,
    "mdi:phone-missed": 0xF3FA,
    "mdi:phone-missed-outline": 0xF01D0,
    "mdi:phone-off": 0xFDCB,
    "mdi:phone-off-outline": 0xF01D1,
    "mdi:phone-outgoing": 0xF3FB,
    "mdi:phone-outgoing-outline": 0xF01C4,
    "mdi:phone-outline": 0xFDCC,
    "mdi:phone-paused": 0xF3FC,
    "mdi:phone-paused-outline": 0xF01C5,
    "mdi:phone-plus": 0xF659,
    "mdi:phone-plus-outline": 0xF01C6,
    "mdi:phone-return": 0xF82E,
    "mdi:phone-return-outline": 0xF01C7,
    "mdi:phone-ring": 0xF01D6,
    "mdi:phone-ring-outline": 0xF01D7,
    "mdi:phone-rotate-landscape": 0xF884,
    "mdi:phone-rotate-portrait": 0xF885,
    "mdi:phone-settings": 0xF3FD,
    "mdi:phone-settings-outline": 0xF01C8,
    "mdi:phone-voip": 0xF3FE,
    "mdi:pi": 0xF3FF,
    "mdi:pi-box": 0xF400,
    "mdi:pi-hole": 0xFDCD,
    "mdi:piano": 0xF67C,
    "mdi:pickaxe": 0xF8B6,
    "mdi:picture-in-picture-bottom-right": 0xFE3A,
    "mdi:picture-in-picture-bottom-right-outline": 0xFE3B,
    "mdi:picture-in-picture-top-right": 0xFE3C,
    "mdi:picture-in-picture-top-right-outline": 0xFE3D,
    "mdi:pier": 0xF886,
    "mdi:pier-crane": 0xF887,
    "mdi:pig": 0xF401,
    "mdi:pig-variant": 0xF0028,
    "mdi:piggy-bank": 0xF0029,
    "mdi:pill": 0xF402,
    "mdi:pillar": 0xF701,
    "mdi:pin": 0xF403,
    "mdi:pin-off": 0xF404,
    "mdi:pin-off-outline": 0xF92F,
    "mdi:pin-outline": 0xF930,
    "mdi:pine-tree": 0xF405,
    "mdi:pine-tree-box": 0xF406,
    "mdi:pinterest": 0xF407,
    "mdi:pinterest-box": 0xF408,
    "mdi:pinwheel": 0xFAD4,
    "mdi:pinwheel-outline": 0xFAD5,
    "mdi:pipe": 0xF7E4,
    "mdi:pipe-disconnected": 0xF7E5,
    "mdi:pipe-leak": 0xF888,
    "mdi:pirate": 0xFA07,
    "mdi:pistol": 0xF702,
    "mdi:piston": 0xF889,
    "mdi:pizza": 0xF409,
    "mdi:play": 0xF40A,
    "mdi:play-box-outline": 0xF40B,
    "mdi:play-circle": 0xF40C,
    "mdi:play-circle-outline": 0xF40D,
    "mdi:play-network": 0xF88A,
    "mdi:play-network-outline": 0xFC93,
    "mdi:play-outline": 0xFF38,
    "mdi:play-pause": 0xF40E,
    "mdi:play-protected-content": 0xF40F,
    "mdi:play-speed": 0xF8FE,
    "mdi:playlist-check": 0xF5C7,
    "mdi:playlist-edit": 0xF8FF,
    "mdi:playlist-minus": 0xF410,
    "mdi:playlist-music": 0xFC94,
    "mdi:playlist-music-outline": 0xFC95,
    "mdi:playlist-play": 0xF411,
    "mdi:playlist-plus": 0xF412,
    "mdi:playlist-remove": 0xF413,
    "mdi:playlist-star": 0xFDCE,
    "mdi:playstation": 0xF414,
    "mdi:plex": 0xF6B9,
    "mdi:plus": 0xF415,
    "mdi:plus-box": 0xF416,
    "mdi:plus-box-multiple": 0xF334,
    "mdi:plus-box-multiple-outline": 0xF016E,
    "mdi:plus-box-outline": 0xF703,
    "mdi:plus-circle": 0xF417,
    "mdi:plus-circle-multiple-outline": 0xF418,
    "mdi:plus-circle-outline": 0xF419,
    "mdi:plus-minus": 0xF991,
    "mdi:plus-minus-box": 0xF992,
    "mdi:plus-network": 0xF41A,
    "mdi:plus-network-outline": 0xFC96,
    "mdi:plus-one": 0xF41B,
    "mdi:plus-outline": 0xF704,
    "mdi:plus-thick": 0xF0217,
    "mdi:pocket": 0xF41C,
    "mdi:podcast": 0xF993,
    "mdi:podium": 0xFD01,
    "mdi:podium-bronze": 0xFD02,
    "mdi:podium-gold": 0xFD03,
    "mdi:podium-silver": 0xFD04,
    "mdi:point-of-sale": 0xFD6E,
    "mdi:pokeball": 0xF41D,
    "mdi:pokemon-go": 0xFA08,
    "mdi:poker-chip": 0xF82F,
    "mdi:polaroid": 0xF41E,
    "mdi:police-badge": 0xF0192,
    "mdi:police-badge-outline": 0xF0193,
    "mdi:poll": 0xF41F,
    "mdi:poll-box": 0xF420,
    "mdi:polymer": 0xF421,
    "mdi:pool": 0xF606,
    "mdi:popcorn": 0xF422,
    "mdi:post": 0xF002A,
    "mdi:post-outline": 0xF002B,
    "mdi:postage-stamp": 0xFC97,
    "mdi:pot": 0xF65A,
    "mdi:pot-mix": 0xF65B,
    "mdi:pound": 0xF423,
    "mdi:pound-box": 0xF424,
    "mdi:pound-box-outline": 0xF01AA,
    "mdi:power": 0xF425,
    "mdi:power-cycle": 0xF900,
    "mdi:power-off": 0xF901,
    "mdi:power-on": 0xF902,
    "mdi:power-plug": 0xF6A4,
    "mdi:power-plug-off": 0xF6A5,
    "mdi:power-settings": 0xF426,
    "mdi:power-sleep": 0xF903,
    "mdi:power-socket": 0xF427,
    "mdi:power-socket-au": 0xF904,
    "mdi:power-socket-de": 0xF0132,
    "mdi:power-socket-eu": 0xF7E6,
    "mdi:power-socket-fr": 0xF0133,
    "mdi:power-socket-jp": 0xF0134,
    "mdi:power-socket-uk": 0xF7E7,
    "mdi:power-socket-us": 0xF7E8,
    "mdi:power-standby": 0xF905,
    "mdi:powershell": 0xFA09,
    "mdi:prescription": 0xF705,
    "mdi:presentation": 0xF428,
    "mdi:presentation-play": 0xF429,
    "mdi:printer": 0xF42A,
    "mdi:printer-3d": 0xF42B,
    "mdi:printer-3d-nozzle": 0xFE3E,
    "mdi:printer-3d-nozzle-alert": 0xF01EB,
    "mdi:printer-3d-nozzle-alert-outline": 0xF01EC,
    "mdi:printer-3d-nozzle-outline": 0xFE3F,
    "mdi:printer-alert": 0xF42C,
    "mdi:printer-check": 0xF0171,
    "mdi:printer-off": 0xFE40,
    "mdi:printer-pos": 0xF0079,
    "mdi:printer-settings": 0xF706,
    "mdi:printer-wireless": 0xFA0A,
    "mdi:priority-high": 0xF603,
    "mdi:priority-low": 0xF604,
    "mdi:professional-hexagon": 0xF42D,
    "mdi:progress-alert": 0xFC98,
    "mdi:progress-check": 0xF994,
    "mdi:progress-clock": 0xF995,
    "mdi:progress-close": 0xF0135,
    "mdi:progress-download": 0xF996,
    "mdi:progress-upload": 0xF997,
    "mdi:progress-wrench": 0xFC99,
    "mdi:projector": 0xF42E,
    "mdi:projector-screen": 0xF42F,
    "mdi:protocol": 0xFFF9,
    "mdi:publish": 0xF6A6,
    "mdi:pulse": 0xF430,
    "mdi:pumpkin": 0xFB9B,
    "mdi:purse": 0xFF39,
    "mdi:purse-outline": 0xFF3A,
    "mdi:puzzle": 0xF431,
    "mdi:puzzle-outline": 0xFA65,
    "mdi:qi": 0xF998,
    "mdi:qqchat": 0xF605,
    "mdi:qrcode": 0xF432,
    "mdi:qrcode-edit": 0xF8B7,
    "mdi:qrcode-minus": 0xF01B7,
    "mdi:qrcode-plus": 0xF01B6,
    "mdi:qrcode-remove": 0xF01B8,
    "mdi:qrcode-scan": 0xF433,
    "mdi:quadcopter": 0xF434,
    "mdi:quality-high": 0xF435,
    "mdi:quality-low": 0xFA0B,
    "mdi:quality-medium": 0xFA0C,
    "mdi:quicktime": 0xF436,
    "mdi:quora": 0xFD05,
    "mdi:rabbit": 0xF906,
    "mdi:racing-helmet": 0xFD6F,
    "mdi:racquetball": 0xFD70,
    "mdi:radar": 0xF437,
    "mdi:radiator": 0xF438,
    "mdi:radiator-disabled": 0xFAD6,
    "mdi:radiator-off": 0xFAD7,
    "mdi:radio": 0xF439,
    "mdi:radio-am": 0xFC9A,
    "mdi:radio-fm": 0xFC9B,
    "mdi:radio-handheld": 0xF43A,
    "mdi:radio-tower": 0xF43B,
    "mdi:radioactive": 0xF43C,
    "mdi:radioactive-off": 0xFEDE,
    "mdi:radiobox-blank": 0xF43D,
    "mdi:radiobox-marked": 0xF43E,
    "mdi:radius": 0xFC9C,
    "mdi:radius-outline": 0xFC9D,
    "mdi:railroad-light": 0xFF3B,
    "mdi:raspberry-pi": 0xF43F,
    "mdi:ray-end": 0xF440,
    "mdi:ray-end-arrow": 0xF441,
    "mdi:ray-start": 0xF442,
    "mdi:ray-start-arrow": 0xF443,
    "mdi:ray-start-end": 0xF444,
    "mdi:ray-vertex": 0xF445,
    "mdi:react": 0xF707,
    "mdi:read": 0xF447,
    "mdi:receipt": 0xF449,
    "mdi:record": 0xF44A,
    "mdi:record-circle": 0xFEDF,
    "mdi:record-circle-outline": 0xFEE0,
    "mdi:record-player": 0xF999,
    "mdi:record-rec": 0xF44B,
    "mdi:rectangle": 0xFE41,
    "mdi:rectangle-outline": 0xFE42,
    "mdi:recycle": 0xF44C,
    "mdi:reddit": 0xF44D,
    "mdi:redhat": 0xF0146,
    "mdi:redo": 0xF44E,
    "mdi:redo-variant": 0xF44F,
    "mdi:reflect-horizontal": 0xFA0D,
    "mdi:reflect-vertical": 0xFA0E,
    "mdi:refresh": 0xF450,
    "mdi:regex": 0xF451,
    "mdi:registered-trademark": 0xFA66,
    "mdi:relative-scale": 0xF452,
    "mdi:reload": 0xF453,
    "mdi:reload-alert": 0xF0136,
    "mdi:reminder": 0xF88B,
    "mdi:remote": 0xF454,
    "mdi:remote-desktop": 0xF8B8,
    "mdi:remote-off": 0xFEE1,
    "mdi:remote-tv": 0xFEE2,
    "mdi:remote-tv-off": 0xFEE3,
    "mdi:rename-box": 0xF455,
    "mdi:reorder-horizontal": 0xF687,
    "mdi:reorder-vertical": 0xF688,
    "mdi:repeat": 0xF456,
    "mdi:repeat-off": 0xF457,
    "mdi:repeat-once": 0xF458,
    "mdi:replay": 0xF459,
    "mdi:reply": 0xF45A,
    "mdi:reply-all": 0xF45B,
    "mdi:reply-all-outline": 0xFF3C,
    "mdi:reply-circle": 0xF01D9,
    "mdi:reply-outline": 0xFF3D,
    "mdi:reproduction": 0xF45C,
    "mdi:resistor": 0xFB1F,
    "mdi:resistor-nodes": 0xFB20,
    "mdi:resize": 0xFA67,
    "mdi:resize-bottom-right": 0xF45D,
    "mdi:responsive": 0xF45E,
    "mdi:restart": 0xF708,
    "mdi:restart-alert": 0xF0137,
    "mdi:restart-off": 0xFD71,
    "mdi:restore": 0xF99A,
    "mdi:restore-alert": 0xF0138,
    "mdi:rewind": 0xF45F,
    "mdi:rewind-10": 0xFD06,
    "mdi:rewind-30": 0xFD72,
    "mdi:rewind-outline": 0xF709,
    "mdi:rhombus": 0xF70A,
    "mdi:rhombus-medium": 0xFA0F,
    "mdi:rhombus-outline": 0xF70B,
    "mdi:rhombus-split": 0xFA10,
    "mdi:ribbon": 0xF460,
    "mdi:rice": 0xF7E9,
    "mdi:ring": 0xF7EA,
    "mdi:rivet": 0xFE43,
    "mdi:road": 0xF461,
    "mdi:road-variant": 0xF462,
    "mdi:robber": 0xF007A,
    "mdi:robot": 0xF6A8,
    "mdi:robot-industrial": 0xFB21,
    "mdi:robot-mower-outline": 0xF021E,
    "mdi:robot-vacuum": 0xF70C,
    "mdi:robot-vacuum-variant": 0xF907,
    "mdi:rocket": 0xF463,
    "mdi:roller-skate": 0xFD07,
    "mdi:rollerblade": 0xFD08,
    "mdi:rollupjs": 0xFB9C,
    "mdi:roman-numeral-1": 0xF00B3,
    "mdi:roman-numeral-10": 0xF00BC,
    "mdi:roman-numeral-2": 0xF00B4,
    "mdi:roman-numeral-3": 0xF00B5,
    "mdi:roman-numeral-4": 0xF00B6,
    "mdi:roman-numeral-5": 0xF00B7,
    "mdi:roman-numeral-6": 0xF00B8,
    "mdi:roman-numeral-7": 0xF00B9,
    "mdi:roman-numeral-8": 0xF00BA,
    "mdi:roman-numeral-9": 0xF00BB,
    "mdi:room-service": 0xF88C,
    "mdi:room-service-outline": 0xFD73,
    "mdi:rotate-3d": 0xFEE4,
    "mdi:rotate-3d-variant": 0xF464,
    "mdi:rotate-left": 0xF465,
    "mdi:rotate-left-variant": 0xF466,
    "mdi:rotate-orbit": 0xFD74,
    "mdi:rotate-right": 0xF467,
    "mdi:rotate-right-variant": 0xF468,
    "mdi:rounded-corner": 0xF607,
    "mdi:router": 0xF020D,
    "mdi:router-wireless": 0xF469,
    "mdi:router-wireless-settings": 0xFA68,
    "mdi:routes": 0xF46A,
    "mdi:routes-clock": 0xF007B,
    "mdi:rowing": 0xF608,
    "mdi:rss": 0xF46B,
    "mdi:rss-box": 0xF46C,
    "mdi:rss-off": 0xFF3E,
    "mdi:ruby": 0xFD09,
    "mdi:rugby": 0xFD75,
    "mdi:ruler": 0xF46D,
    "mdi:ruler-square": 0xFC9E,
    "mdi:ruler-square-compass": 0xFEDB,
    "mdi:run": 0xF70D,
    "mdi:run-fast": 0xF46E,
    "mdi:rv-truck": 0xF01FF,
    "mdi:sack": 0xFD0A,
    "mdi:sack-percent": 0xFD0B,
    "mdi:safe": 0xFA69,
    "mdi:safety-goggles": 0xFD0C,
    "mdi:sailing": 0xFEE5,
    "mdi:sale": 0xF46F,
    "mdi:salesforce": 0xF88D,
    "mdi:sass": 0xF7EB,
    "mdi:satellite": 0xF470,
    "mdi:satellite-uplink": 0xF908,
    "mdi:satellite-variant": 0xF471,
    "mdi:sausage": 0xF8B9,
    "mdi:saw-blade": 0xFE44,
    "mdi:saxophone": 0xF609,
    "mdi:scale": 0xF472,
    "mdi:scale-balance": 0xF5D1,
    "mdi:scale-bathroom": 0xF473,
    "mdi:scale-off": 0xF007C,
    "mdi:scanner": 0xF6AA,
    "mdi:scanner-off": 0xF909,
    "mdi:scatter-plot": 0xFEE6,
    "mdi:scatter-plot-outline": 0xFEE7,
    "mdi:school": 0xF474,
    "mdi:school-outline": 0xF01AB,
    "mdi:scissors-cutting": 0xFA6A,
    "mdi:scooter": 0xF0214,
    "mdi:screen-rotation": 0xF475,
    "mdi:screen-rotation-lock": 0xF476,
    "mdi:screw-flat-top": 0xFDCF,
    "mdi:screw-lag": 0xFE54,
    "mdi:screw-machine-flat-top": 0xFE55,
    "mdi:screw-machine-round-top": 0xFE56,
    "mdi:screw-round-top": 0xFE57,
    "mdi:screwdriver": 0xF477,
    "mdi:script": 0xFB9D,
    "mdi:script-outline": 0xF478,
    "mdi:script-text": 0xFB9E,
    "mdi:script-text-outline": 0xFB9F,
    "mdi:sd": 0xF479,
    "mdi:seal": 0xF47A,
    "mdi:seal-variant": 0xFFFA,
    "mdi:search-web": 0xF70E,
    "mdi:seat": 0xFC9F,
    "mdi:seat-flat": 0xF47B,
    "mdi:seat-flat-angled": 0xF47C,
    "mdi:seat-individual-suite": 0xF47D,
    "mdi:seat-legroom-extra": 0xF47E,
    "mdi:seat-legroom-normal": 0xF47F,
    "mdi:seat-legroom-reduced": 0xF480,
    "mdi:seat-outline": 0xFCA0,
    "mdi:seat-recline-extra": 0xF481,
    "mdi:seat-recline-normal": 0xF482,
    "mdi:seatbelt": 0xFCA1,
    "mdi:security": 0xF483,
    "mdi:security-network": 0xF484,
    "mdi:seed": 0xFE45,
    "mdi:seed-outline": 0xFE46,
    "mdi:segment": 0xFEE8,
    "mdi:select": 0xF485,
    "mdi:select-all": 0xF486,
    "mdi:select-color": 0xFD0D,
    "mdi:select-compare": 0xFAD8,
    "mdi:select-drag": 0xFA6B,
    "mdi:select-group": 0xFF9F,
    "mdi:select-inverse": 0xF487,
    "mdi:select-off": 0xF488,
    "mdi:select-place": 0xFFFB,
    "mdi:selection": 0xF489,
    "mdi:selection-drag": 0xFA6C,
    "mdi:selection-ellipse": 0xFD0E,
    "mdi:selection-ellipse-arrow-inside": 0xFF3F,
    "mdi:selection-off": 0xF776,
    "mdi:send": 0xF48A,
    "mdi:send-check": 0xF018C,
    "mdi:send-check-outline": 0xF018D,
    "mdi:send-circle": 0xFE58,
    "mdi:send-circle-outline": 0xFE59,
    "mdi:send-clock": 0xF018E,
    "mdi:send-clock-outline": 0xF018F,
    "mdi:send-lock": 0xF7EC,
    "mdi:send-lock-outline": 0xF0191,
    "mdi:send-outline": 0xF0190,
    "mdi:serial-port": 0xF65C,
    "mdi:server": 0xF48B,
    "mdi:server-minus": 0xF48C,
    "mdi:server-network": 0xF48D,
    "mdi:server-network-off": 0xF48E,
    "mdi:server-off": 0xF48F,
    "mdi:server-plus": 0xF490,
    "mdi:server-remove": 0xF491,
    "mdi:server-security": 0xF492,
    "mdi:set-all": 0xF777,
    "mdi:set-center": 0xF778,
    "mdi:set-center-right": 0xF779,
    "mdi:set-left": 0xF77A,
    "mdi:set-left-center": 0xF77B,
    "mdi:set-left-right": 0xF77C,
    "mdi:set-none": 0xF77D,
    "mdi:set-right": 0xF77E,
    "mdi:set-top-box": 0xF99E,
    "mdi:settings": 0xF493,
    "mdi:settings-box": 0xF494,
    "mdi:settings-helper": 0xFA6D,
    "mdi:settings-outline": 0xF8BA,
    "mdi:settings-transfer": 0xF007D,
    "mdi:settings-transfer-outline": 0xF007E,
    "mdi:shaker": 0xF0139,
    "mdi:shaker-outline": 0xF013A,
    "mdi:shape": 0xF830,
    "mdi:shape-circle-plus": 0xF65D,
    "mdi:shape-outline": 0xF831,
    "mdi:shape-plus": 0xF495,
    "mdi:shape-polygon-plus": 0xF65E,
    "mdi:shape-rectangle-plus": 0xF65F,
    "mdi:shape-square-plus": 0xF660,
    "mdi:share": 0xF496,
    "mdi:share-circle": 0xF01D8,
    "mdi:share-off": 0xFF40,
    "mdi:share-off-outline": 0xFF41,
    "mdi:share-outline": 0xF931,
    "mdi:share-variant": 0xF497,
    "mdi:sheep": 0xFCA2,
    "mdi:shield": 0xF498,
    "mdi:shield-account": 0xF88E,
    "mdi:shield-account-outline": 0xFA11,
    "mdi:shield-airplane": 0xF6BA,
    "mdi:shield-airplane-outline": 0xFCA3,
    "mdi:shield-alert": 0xFEE9,
    "mdi:shield-alert-outline": 0xFEEA,
    "mdi:shield-car": 0xFFA0,
    "mdi:shield-check": 0xF565,
    "mdi:shield-check-outline": 0xFCA4,
    "mdi:shield-cross": 0xFCA5,
    "mdi:shield-cross-outline": 0xFCA6,
    "mdi:shield-edit": 0xF01CB,
    "mdi:shield-edit-outline": 0xF01CC,
    "mdi:shield-half-full": 0xF77F,
    "mdi:shield-home": 0xF689,
    "mdi:shield-home-outline": 0xFCA7,
    "mdi:shield-key": 0xFBA0,
    "mdi:shield-key-outline": 0xFBA1,
    "mdi:shield-link-variant": 0xFD0F,
    "mdi:shield-link-variant-outline": 0xFD10,
    "mdi:shield-lock": 0xF99C,
    "mdi:shield-lock-outline": 0xFCA8,
    "mdi:shield-off": 0xF99D,
    "mdi:shield-off-outline": 0xF99B,
    "mdi:shield-outline": 0xF499,
    "mdi:shield-plus": 0xFAD9,
    "mdi:shield-plus-outline": 0xFADA,
    "mdi:shield-refresh": 0xF01CD,
    "mdi:shield-refresh-outline": 0xF01CE,
    "mdi:shield-remove": 0xFADB,
    "mdi:shield-remove-outline": 0xFADC,
    "mdi:shield-search": 0xFD76,
    "mdi:shield-star": 0xF0166,
    "mdi:shield-star-outline": 0xF0167,
    "mdi:shield-sun": 0xF007F,
    "mdi:shield-sun-outline": 0xF0080,
    "mdi:ship-wheel": 0xF832,
    "mdi:shoe-formal": 0xFB22,
    "mdi:shoe-heel": 0xFB23,
    "mdi:shoe-print": 0xFE5A,
    "mdi:shopify": 0xFADD,
    "mdi:shopping": 0xF49A,
    "mdi:shopping-music": 0xF49B,
    "mdi:shopping-outline": 0xF0200,
    "mdi:shopping-search": 0xFFA1,
    "mdi:shovel": 0xF70F,
    "mdi:shovel-off": 0xF710,
    "mdi:shower": 0xF99F,
    "mdi:shower-head": 0xF9A0,
    "mdi:shredder": 0xF49C,
    "mdi:shuffle": 0xF49D,
    "mdi:shuffle-disabled": 0xF49E,
    "mdi:shuffle-variant": 0xF49F,
    "mdi:sigma": 0xF4A0,
    "mdi:sigma-lower": 0xF62B,
    "mdi:sign-caution": 0xF4A1,
    "mdi:sign-direction": 0xF780,
    "mdi:sign-direction-minus": 0xF0022,
    "mdi:sign-direction-plus": 0xFFFD,
    "mdi:sign-direction-remove": 0xFFFE,
    "mdi:sign-real-estate": 0xF0143,
    "mdi:sign-text": 0xF781,
    "mdi:signal": 0xF4A2,
    "mdi:signal-2g": 0xF711,
    "mdi:signal-3g": 0xF712,
    "mdi:signal-4g": 0xF713,
    "mdi:signal-5g": 0xFA6E,
    "mdi:signal-cellular-1": 0xF8BB,
    "mdi:signal-cellular-2": 0xF8BC,
    "mdi:signal-cellular-3": 0xF8BD,
    "mdi:signal-cellular-outline": 0xF8BE,
    "mdi:signal-distance-variant": 0xFE47,
    "mdi:signal-hspa": 0xF714,
    "mdi:signal-hspa-plus": 0xF715,
    "mdi:signal-off": 0xF782,
    "mdi:signal-variant": 0xF60A,
    "mdi:signature": 0xFE5B,
    "mdi:signature-freehand": 0xFE5C,
    "mdi:signature-image": 0xFE5D,
    "mdi:signature-text": 0xFE5E,
    "mdi:silo": 0xFB24,
    "mdi:silverware": 0xF4A3,
    "mdi:silverware-clean": 0xFFFF,
    "mdi:silverware-fork": 0xF4A4,
    "mdi:silverware-fork-knife": 0xFA6F,
    "mdi:silverware-spoon": 0xF4A5,
    "mdi:silverware-variant": 0xF4A6,
    "mdi:sim": 0xF4A7,
    "mdi:sim-alert": 0xF4A8,
    "mdi:sim-off": 0xF4A9,
    "mdi:sina-weibo": 0xFADE,
    "mdi:sitemap": 0xF4AA,
    "mdi:skate": 0xFD11,
    "mdi:skew-less": 0xFD12,
    "mdi:skew-more": 0xFD13,
    "mdi:skip-backward": 0xF4AB,
    "mdi:skip-backward-outline": 0xFF42,
    "mdi:skip-forward": 0xF4AC,
    "mdi:skip-forward-outline": 0xFF43,
    "mdi:skip-next": 0xF4AD,
    "mdi:skip-next-circle": 0xF661,
    "mdi:skip-next-circle-outline": 0xF662,
    "mdi:skip-next-outline": 0xFF44,
    "mdi:skip-previous": 0xF4AE,
    "mdi:skip-previous-circle": 0xF663,
    "mdi:skip-previous-circle-outline": 0xF664,
    "mdi:skip-previous-outline": 0xFF45,
    "mdi:skull": 0xF68B,
    "mdi:skull-crossbones": 0xFBA2,
    "mdi:skull-crossbones-outline": 0xFBA3,
    "mdi:skull-outline": 0xFBA4,
    "mdi:skype": 0xF4AF,
    "mdi:skype-business": 0xF4B0,
    "mdi:slack": 0xF4B1,
    "mdi:slackware": 0xF90A,
    "mdi:slash-forward": 0xF0000,
    "mdi:slash-forward-box": 0xF0001,
    "mdi:sleep": 0xF4B2,
    "mdi:sleep-off": 0xF4B3,
    "mdi:slope-downhill": 0xFE5F,
    "mdi:slope-uphill": 0xFE60,
    "mdi:slot-machine": 0xF013F,
    "mdi:slot-machine-outline": 0xF0140,
    "mdi:smart-card": 0xF00E8,
    "mdi:smart-card-outline": 0xF00E9,
    "mdi:smart-card-reader": 0xF00EA,
    "mdi:smart-card-reader-outline": 0xF00EB,
    "mdi:smog": 0xFA70,
    "mdi:smoke-detector": 0xF392,
    "mdi:smoking": 0xF4B4,
    "mdi:smoking-off": 0xF4B5,
    "mdi:snapchat": 0xF4B6,
    "mdi:snowflake": 0xF716,
    "mdi:snowflake-alert": 0xFF46,
    "mdi:snowflake-variant": 0xFF47,
    "mdi:snowman": 0xF4B7,
    "mdi:soccer": 0xF4B8,
    "mdi:soccer-field": 0xF833,
    "mdi:sofa": 0xF4B9,
    "mdi:solar-panel": 0xFD77,
    "mdi:solar-panel-large": 0xFD78,
    "mdi:solar-power": 0xFA71,
    "mdi:soldering-iron": 0xF00BD,
    "mdi:solid": 0xF68C,
    "mdi:sort": 0xF4BA,
    "mdi:sort-alphabetical": 0xF4BB,
    "mdi:sort-alphabetical-ascending": 0xF0173,
    "mdi:sort-alphabetical-descending": 0xF0174,
    "mdi:sort-ascending": 0xF4BC,
    "mdi:sort-descending": 0xF4BD,
    "mdi:sort-numeric": 0xF4BE,
    "mdi:sort-variant": 0xF4BF,
    "mdi:sort-variant-lock": 0xFCA9,
    "mdi:sort-variant-lock-open": 0xFCAA,
    "mdi:sort-variant-remove": 0xF0172,
    "mdi:soundcloud": 0xF4C0,
    "mdi:source-branch": 0xF62C,
    "mdi:source-commit": 0xF717,
    "mdi:source-commit-end": 0xF718,
    "mdi:source-commit-end-local": 0xF719,
    "mdi:source-commit-local": 0xF71A,
    "mdi:source-commit-next-local": 0xF71B,
    "mdi:source-commit-start": 0xF71C,
    "mdi:source-commit-start-next-local": 0xF71D,
    "mdi:source-fork": 0xF4C1,
    "mdi:source-merge": 0xF62D,
    "mdi:source-pull": 0xF4C2,
    "mdi:source-repository": 0xFCAB,
    "mdi:source-repository-multiple": 0xFCAC,
    "mdi:soy-sauce": 0xF7ED,
    "mdi:spa": 0xFCAD,
    "mdi:spa-outline": 0xFCAE,
    "mdi:space-invaders": 0xFBA5,
    "mdi:spade": 0xFE48,
    "mdi:speaker": 0xF4C3,
    "mdi:speaker-bluetooth": 0xF9A1,
    "mdi:speaker-multiple": 0xFD14,
    "mdi:speaker-off": 0xF4C4,
    "mdi:speaker-wireless": 0xF71E,
    "mdi:speedometer": 0xF4C5,
    "mdi:speedometer-medium": 0xFFA2,
    "mdi:speedometer-slow": 0xFFA3,
    "mdi:spellcheck": 0xF4C6,
    "mdi:spider": 0xF0215,
    "mdi:spider-thread": 0xF0216,
    "mdi:spider-web": 0xFBA6,
    "mdi:spotify": 0xF4C7,
    "mdi:spotlight": 0xF4C8,
    "mdi:spotlight-beam": 0xF4C9,
    "mdi:spray": 0xF665,
    "mdi:spray-bottle": 0xFADF,
    "mdi:sprinkler": 0xF0081,
    "mdi:sprinkler-variant": 0xF0082,
    "mdi:sprout": 0xFE49,
    "mdi:sprout-outline": 0xFE4A,
    "mdi:square": 0xF763,
    "mdi:square-edit-outline": 0xF90B,
    "mdi:square-inc": 0xF4CA,
    "mdi:square-inc-cash": 0xF4CB,
    "mdi:square-medium": 0xFA12,
    "mdi:square-medium-outline": 0xFA13,
    "mdi:square-outline": 0xF762,
    "mdi:square-root": 0xF783,
    "mdi:square-root-box": 0xF9A2,
    "mdi:square-small": 0xFA14,
    "mdi:squeegee": 0xFAE0,
    "mdi:ssh": 0xF8BF,
    "mdi:stack-exchange": 0xF60B,
    "mdi:stack-overflow": 0xF4CC,
    "mdi:stadium": 0xF001A,
    "mdi:stadium-variant": 0xF71F,
    "mdi:stairs": 0xF4CD,
    "mdi:stamper": 0xFD15,
    "mdi:standard-definition": 0xF7EE,
    "mdi:star": 0xF4CE,
    "mdi:star-box": 0xFA72,
    "mdi:star-box-outline": 0xFA73,
    "mdi:star-circle": 0xF4CF,
    "mdi:star-circle-outline": 0xF9A3,
    "mdi:star-face": 0xF9A4,
    "mdi:star-four-points": 0xFAE1,
    "mdi:star-four-points-outline": 0xFAE2,
    "mdi:star-half": 0xF4D0,
    "mdi:star-off": 0xF4D1,
    "mdi:star-outline": 0xF4D2,
    "mdi:star-three-points": 0xFAE3,
    "mdi:star-three-points-outline": 0xFAE4,
    "mdi:state-machine": 0xF021A,
    "mdi:steam": 0xF4D3,
    "mdi:steam-box": 0xF90C,
    "mdi:steering": 0xF4D4,
    "mdi:steering-off": 0xF90D,
    "mdi:step-backward": 0xF4D5,
    "mdi:step-backward-2": 0xF4D6,
    "mdi:step-forward": 0xF4D7,
    "mdi:step-forward-2": 0xF4D8,
    "mdi:stethoscope": 0xF4D9,
    "mdi:sticker": 0xF5D0,
    "mdi:sticker-emoji": 0xF784,
    "mdi:stocking": 0xF4DA,
    "mdi:stomach": 0xF00BE,
    "mdi:stop": 0xF4DB,
    "mdi:stop-circle": 0xF666,
    "mdi:stop-circle-outline": 0xF667,
    "mdi:store": 0xF4DC,
    "mdi:store-24-hour": 0xF4DD,
    "mdi:storefront": 0xF00EC,
    "mdi:stove": 0xF4DE,
    "mdi:strategy": 0xF0201,
    "mdi:strava": 0xFB25,
    "mdi:stretch-to-page": 0xFF48,
    "mdi:stretch-to-page-outline": 0xFF49,
    "mdi:subdirectory-arrow-left": 0xF60C,
    "mdi:subdirectory-arrow-right": 0xF60D,
    "mdi:subtitles": 0xFA15,
    "mdi:subtitles-outline": 0xFA16,
    "mdi:subway": 0xF6AB,
    "mdi:subway-alert-variant": 0xFD79,
    "mdi:subway-variant": 0xF4DF,
    "mdi:summit": 0xF785,
    "mdi:sunglasses": 0xF4E0,
    "mdi:surround-sound": 0xF5C5,
    "mdi:surround-sound-2-0": 0xF7EF,
    "mdi:surround-sound-3-1": 0xF7F0,
    "mdi:surround-sound-5-1": 0xF7F1,
    "mdi:surround-sound-7-1": 0xF7F2,
    "mdi:svg": 0xF720,
    "mdi:swap-horizontal": 0xF4E1,
    "mdi:swap-horizontal-bold": 0xFBA9,
    "mdi:swap-horizontal-circle": 0xF0002,
    "mdi:swap-horizontal-circle-outline": 0xF0003,
    "mdi:swap-horizontal-variant": 0xF8C0,
    "mdi:swap-vertical": 0xF4E2,
    "mdi:swap-vertical-bold": 0xFBAA,
    "mdi:swap-vertical-circle": 0xF0004,
    "mdi:swap-vertical-circle-outline": 0xF0005,
    "mdi:swap-vertical-variant": 0xF8C1,
    "mdi:swim": 0xF4E3,
    "mdi:switch": 0xF4E4,
    "mdi:sword": 0xF4E5,
    "mdi:sword-cross": 0xF786,
    "mdi:symfony": 0xFAE5,
    "mdi:sync": 0xF4E6,
    "mdi:sync-alert": 0xF4E7,
    "mdi:sync-off": 0xF4E8,
    "mdi:tab": 0xF4E9,
    "mdi:tab-minus": 0xFB26,
    "mdi:tab-plus": 0xF75B,
    "mdi:tab-remove": 0xFB27,
    "mdi:tab-unselected": 0xF4EA,
    "mdi:table": 0xF4EB,
    "mdi:table-border": 0xFA17,
    "mdi:table-chair": 0xF0083,
    "mdi:table-column": 0xF834,
    "mdi:table-column-plus-after": 0xF4EC,
    "mdi:table-column-plus-before": 0xF4ED,
    "mdi:table-column-remove": 0xF4EE,
    "mdi:table-column-width": 0xF4EF,
    "mdi:table-edit": 0xF4F0,
    "mdi:table-eye": 0xF00BF,
    "mdi:table-large": 0xF4F1,
    "mdi:table-large-plus": 0xFFA4,
    "mdi:table-large-remove": 0xFFA5,
    "mdi:table-merge-cells": 0xF9A5,
    "mdi:table-of-contents": 0xF835,
    "mdi:table-plus": 0xFA74,
    "mdi:table-remove": 0xFA75,
    "mdi:table-row": 0xF836,
    "mdi:table-row-height": 0xF4F2,
    "mdi:table-row-plus-after": 0xF4F3,
    "mdi:table-row-plus-before": 0xF4F4,
    "mdi:table-row-remove": 0xF4F5,
    "mdi:table-search": 0xF90E,
    "mdi:table-settings": 0xF837,
    "mdi:table-tennis": 0xFE4B,
    "mdi:tablet": 0xF4F6,
    "mdi:tablet-android": 0xF4F7,
    "mdi:tablet-cellphone": 0xF9A6,
    "mdi:tablet-dashboard": 0xFEEB,
    "mdi:tablet-ipad": 0xF4F8,
    "mdi:taco": 0xF761,
    "mdi:tag": 0xF4F9,
    "mdi:tag-faces": 0xF4FA,
    "mdi:tag-heart": 0xF68A,
    "mdi:tag-heart-outline": 0xFBAB,
    "mdi:tag-minus": 0xF90F,
    "mdi:tag-multiple": 0xF4FB,
    "mdi:tag-outline": 0xF4FC,
    "mdi:tag-plus": 0xF721,
    "mdi:tag-remove": 0xF722,
    "mdi:tag-text-outline": 0xF4FD,
    "mdi:tank": 0xFD16,
    "mdi:tanker-truck": 0xF0006,
    "mdi:tape-measure": 0xFB28,
    "mdi:target": 0xF4FE,
    "mdi:target-account": 0xFBAC,
    "mdi:target-variant": 0xFA76,
    "mdi:taxi": 0xF4FF,
    "mdi:tea": 0xFD7A,
    "mdi:tea-outline": 0xFD7B,
    "mdi:teach": 0xF88F,
    "mdi:teamviewer": 0xF500,
    "mdi:telegram": 0xF501,
    "mdi:telescope": 0xFB29,
    "mdi:television": 0xF502,
    "mdi:television-box": 0xF838,
    "mdi:television-classic": 0xF7F3,
    "mdi:television-classic-off": 0xF839,
    "mdi:television-clean": 0xF013B,
    "mdi:television-guide": 0xF503,
    "mdi:television-off": 0xF83A,
    "mdi:television-pause": 0xFFA6,
    "mdi:television-play": 0xFEEC,
    "mdi:television-stop": 0xFFA7,
    "mdi:temperature-celsius": 0xF504,
    "mdi:temperature-fahrenheit": 0xF505,
    "mdi:temperature-kelvin": 0xF506,
    "mdi:tennis": 0xFD7C,
    "mdi:tennis-ball": 0xF507,
    "mdi:tent": 0xF508,
    "mdi:terraform": 0xF0084,
    "mdi:terrain": 0xF509,
    "mdi:test-tube": 0xF668,
    "mdi:test-tube-empty": 0xF910,
    "mdi:test-tube-off": 0xF911,
    "mdi:text": 0xF9A7,
    "mdi:text-recognition": 0xF0168,
    "mdi:text-shadow": 0xF669,
    "mdi:text-short": 0xF9A8,
    "mdi:text-subject": 0xF9A9,
    "mdi:text-to-speech": 0xF50A,
    "mdi:text-to-speech-off": 0xF50B,
    "mdi:textarea": 0xF00C0,
    "mdi:textbox": 0xF60E,
    "mdi:textbox-password": 0xF7F4,
    "mdi:texture": 0xF50C,
    "mdi:texture-box": 0xF0007,
    "mdi:theater": 0xF50D,
    "mdi:theme-light-dark": 0xF50E,
    "mdi:thermometer": 0xF50F,
    "mdi:thermometer-alert": 0xFE61,
    "mdi:thermometer-chevron-down": 0xFE62,
    "mdi:thermometer-chevron-up": 0xFE63,
    "mdi:thermometer-high": 0xF00ED,
    "mdi:thermometer-lines": 0xF510,
    "mdi:thermometer-low": 0xF00EE,
    "mdi:thermometer-minus": 0xFE64,
    "mdi:thermometer-plus": 0xFE65,
    "mdi:thermostat": 0xF393,
    "mdi:thermostat-box": 0xF890,
    "mdi:thought-bubble": 0xF7F5,
    "mdi:thought-bubble-outline": 0xF7F6,
    "mdi:thumb-down": 0xF511,
    "mdi:thumb-down-outline": 0xF512,
    "mdi:thumb-up": 0xF513,
    "mdi:thumb-up-outline": 0xF514,
    "mdi:thumbs-up-down": 0xF515,
    "mdi:ticket": 0xF516,
    "mdi:ticket-account": 0xF517,
    "mdi:ticket-confirmation": 0xF518,
    "mdi:ticket-outline": 0xF912,
    "mdi:ticket-percent": 0xF723,
    "mdi:tie": 0xF519,
    "mdi:tilde": 0xF724,
    "mdi:timelapse": 0xF51A,
    "mdi:timeline": 0xFBAD,
    "mdi:timeline-alert": 0xFFB2,
    "mdi:timeline-alert-outline": 0xFFB5,
    "mdi:timeline-help": 0xFFB6,
    "mdi:timeline-help-outline": 0xFFB7,
    "mdi:timeline-outline": 0xFBAE,
    "mdi:timeline-plus": 0xFFB3,
    "mdi:timeline-plus-outline": 0xFFB4,
    "mdi:timeline-text": 0xFBAF,
    "mdi:timeline-text-outline": 0xFBB0,
    "mdi:timer": 0xF51B,
    "mdi:timer-10": 0xF51C,
    "mdi:timer-3": 0xF51D,
    "mdi:timer-off": 0xF51E,
    "mdi:timer-sand": 0xF51F,
    "mdi:timer-sand-empty": 0xF6AC,
    "mdi:timer-sand-full": 0xF78B,
    "mdi:timetable": 0xF520,
    "mdi:toaster": 0xF0085,
    "mdi:toaster-off": 0xF01E2,
    "mdi:toaster-oven": 0xFCAF,
    "mdi:toggle-switch": 0xF521,
    "mdi:toggle-switch-off": 0xF522,
    "mdi:toggle-switch-off-outline": 0xFA18,
    "mdi:toggle-switch-outline": 0xFA19,
    "mdi:toilet": 0xF9AA,
    "mdi:toolbox": 0xF9AB,
    "mdi:toolbox-outline": 0xF9AC,
    "mdi:tools": 0xF0086,
    "mdi:tooltip": 0xF523,
    "mdi:tooltip-account": 0xF00C,
    "mdi:tooltip-edit": 0xF524,
    "mdi:tooltip-image": 0xF525,
    "mdi:tooltip-image-outline": 0xFBB1,
    "mdi:tooltip-outline": 0xF526,
    "mdi:tooltip-plus": 0xFBB2,
    "mdi:tooltip-plus-outline": 0xF527,
    "mdi:tooltip-text": 0xF528,
    "mdi:tooltip-text-outline": 0xFBB3,
    "mdi:tooth": 0xF8C2,
    "mdi:tooth-outline": 0xF529,
    "mdi:toothbrush": 0xF0154,
    "mdi:toothbrush-electric": 0xF0157,
    "mdi:toothbrush-paste": 0xF0155,
    "mdi:tor": 0xF52A,
    "mdi:tortoise": 0xFD17,
    "mdi:tournament": 0xF9AD,
    "mdi:tower-beach": 0xF680,
    "mdi:tower-fire": 0xF681,
    "mdi:towing": 0xF83B,
    "mdi:track-light": 0xF913,
    "mdi:trackpad": 0xF7F7,
    "mdi:trackpad-lock": 0xF932,
    "mdi:tractor": 0xF891,
    "mdi:trademark": 0xFA77,
    "mdi:traffic-light": 0xF52B,
    "mdi:train": 0xF52C,
    "mdi:train-car": 0xFBB4,
    "mdi:train-variant": 0xF8C3,
    "mdi:tram": 0xF52D,
    "mdi:tram-side": 0xF0008,
    "mdi:transcribe": 0xF52E,
    "mdi:transcribe-close": 0xF52F,
    "mdi:transfer": 0xF0087,
    "mdi:transfer-down": 0xFD7D,
    "mdi:transfer-left": 0xFD7E,
    "mdi:transfer-right": 0xF530,
    "mdi:transfer-up": 0xFD7F,
    "mdi:transit-connection": 0xFD18,
    "mdi:transit-connection-variant": 0xFD19,
    "mdi:transit-detour": 0xFFA8,
    "mdi:transit-transfer": 0xF6AD,
    "mdi:transition": 0xF914,
    "mdi:transition-masked": 0xF915,
    "mdi:translate": 0xF5CA,
    "mdi:translate-off": 0xFE66,
    "mdi:transmission-tower": 0xFD1A,
    "mdi:trash-can": 0xFA78,
    "mdi:trash-can-outline": 0xFA79,
    "mdi:treasure-chest": 0xF725,
    "mdi:tree": 0xF531,
    "mdi:tree-outline": 0xFE4C,
    "mdi:trello": 0xF532,
    "mdi:trending-down": 0xF533,
    "mdi:trending-neutral": 0xF534,
    "mdi:trending-up": 0xF535,
    "mdi:triangle": 0xF536,
    "mdi:triangle-outline": 0xF537,
    "mdi:triforce": 0xFBB5,
    "mdi:trophy": 0xF538,
    "mdi:trophy-award": 0xF539,
    "mdi:trophy-broken": 0xFD80,
    "mdi:trophy-outline": 0xF53A,
    "mdi:trophy-variant": 0xF53B,
    "mdi:trophy-variant-outline": 0xF53C,
    "mdi:truck": 0xF53D,
    "mdi:truck-check": 0xFCB0,
    "mdi:truck-delivery": 0xF53E,
    "mdi:truck-fast": 0xF787,
    "mdi:truck-trailer": 0xF726,
    "mdi:trumpet": 0xF00C1,
    "mdi:tshirt-crew": 0xFA7A,
    "mdi:tshirt-crew-outline": 0xF53F,
    "mdi:tshirt-v": 0xFA7B,
    "mdi:tshirt-v-outline": 0xF540,
    "mdi:tumble-dryer": 0xF916,
    "mdi:tumble-dryer-alert": 0xF01E5,
    "mdi:tumble-dryer-off": 0xF01E6,
    "mdi:tumblr": 0xF541,
    "mdi:tumblr-box": 0xF917,
    "mdi:tumblr-reblog": 0xF542,
    "mdi:tune": 0xF62E,
    "mdi:tune-vertical": 0xF66A,
    "mdi:turnstile": 0xFCB1,
    "mdi:turnstile-outline": 0xFCB2,
    "mdi:turtle": 0xFCB3,
    "mdi:twitch": 0xF543,
    "mdi:twitter": 0xF544,
    "mdi:twitter-box": 0xF545,
    "mdi:twitter-circle": 0xF546,
    "mdi:twitter-retweet": 0xF547,
    "mdi:two-factor-authentication": 0xF9AE,
    "mdi:typewriter": 0xFF4A,
    "mdi:uber": 0xF748,
    "mdi:ubisoft": 0xFBB6,
    "mdi:ubuntu": 0xF548,
    "mdi:ufo": 0xF00EF,
    "mdi:ufo-outline": 0xF00F0,
    "mdi:ultra-high-definition": 0xF7F8,
    "mdi:umbraco": 0xF549,
    "mdi:umbrella": 0xF54A,
    "mdi:umbrella-closed": 0xF9AF,
    "mdi:umbrella-outline": 0xF54B,
    "mdi:undo": 0xF54C,
    "mdi:undo-variant": 0xF54D,
    "mdi:unfold-less-horizontal": 0xF54E,
    "mdi:unfold-less-vertical": 0xF75F,
    "mdi:unfold-more-horizontal": 0xF54F,
    "mdi:unfold-more-vertical": 0xF760,
    "mdi:ungroup": 0xF550,
    "mdi:unicode": 0xFEED,
    "mdi:unity": 0xF6AE,
    "mdi:unreal": 0xF9B0,
    "mdi:untappd": 0xF551,
    "mdi:update": 0xF6AF,
    "mdi:upload": 0xF552,
    "mdi:upload-multiple": 0xF83C,
    "mdi:upload-network": 0xF6F5,
    "mdi:upload-network-outline": 0xFCB4,
    "mdi:upload-off": 0xF00F1,
    "mdi:upload-off-outline": 0xF00F2,
    "mdi:upload-outline": 0xFE67,
    "mdi:usb": 0xF553,
    "mdi:usb-port": 0xF021B,
    "mdi:valve": 0xF0088,
    "mdi:valve-closed": 0xF0089,
    "mdi:valve-open": 0xF008A,
    "mdi:van-passenger": 0xF7F9,
    "mdi:van-utility": 0xF7FA,
    "mdi:vanish": 0xF7FB,
    "mdi:vanity-light": 0xF020C,
    "mdi:variable": 0xFAE6,
    "mdi:variable-box": 0xF013C,
    "mdi:vector-arrange-above": 0xF554,
    "mdi:vector-arrange-below": 0xF555,
    "mdi:vector-bezier": 0xFAE7,
    "mdi:vector-circle": 0xF556,
    "mdi:vector-circle-variant": 0xF557,
    "mdi:vector-combine": 0xF558,
    "mdi:vector-curve": 0xF559,
    "mdi:vector-difference": 0xF55A,
    "mdi:vector-difference-ab": 0xF55B,
    "mdi:vector-difference-ba": 0xF55C,
    "mdi:vector-ellipse": 0xF892,
    "mdi:vector-intersection": 0xF55D,
    "mdi:vector-line": 0xF55E,
    "mdi:vector-link": 0xF0009,
    "mdi:vector-point": 0xF55F,
    "mdi:vector-polygon": 0xF560,
    "mdi:vector-polyline": 0xF561,
    "mdi:vector-radius": 0xF749,
    "mdi:vector-rectangle": 0xF5C6,
    "mdi:vector-selection": 0xF562,
    "mdi:vector-square": 0xF001,
    "mdi:vector-triangle": 0xF563,
    "mdi:vector-union": 0xF564,
    "mdi:venmo": 0xF578,
    "mdi:vhs": 0xFA1A,
    "mdi:vibrate": 0xF566,
    "mdi:vibrate-off": 0xFCB5,
    "mdi:video": 0xF567,
    "mdi:video-3d": 0xF7FC,
    "mdi:video-3d-variant": 0xFEEE,
    "mdi:video-4k-box": 0xF83D,
    "mdi:video-account": 0xF918,
    "mdi:video-check": 0xF008B,
    "mdi:video-check-outline": 0xF008C,
    "mdi:video-image": 0xF919,
    "mdi:video-input-antenna": 0xF83E,
    "mdi:video-input-component": 0xF83F,
    "mdi:video-input-hdmi": 0xF840,
    "mdi:video-input-scart": 0xFFA9,
    "mdi:video-input-svideo": 0xF841,
    "mdi:video-minus": 0xF9B1,
    "mdi:video-off": 0xF568,
    "mdi:video-off-outline": 0xFBB7,
    "mdi:video-outline": 0xFBB8,
    "mdi:video-plus": 0xF9B2,
    "mdi:video-stabilization": 0xF91A,
    "mdi:video-switch": 0xF569,
    "mdi:video-vintage": 0xFA1B,
    "mdi:video-wireless": 0xFEEF,
    "mdi:video-wireless-outline": 0xFEF0,
    "mdi:view-agenda": 0xF56A,
    "mdi:view-agenda-outline": 0xF0203,
    "mdi:view-array": 0xF56B,
    "mdi:view-carousel": 0xF56C,
    "mdi:view-column": 0xF56D,
    "mdi:view-comfy": 0xFE4D,
    "mdi:view-compact": 0xFE4E,
    "mdi:view-compact-outline": 0xFE4F,
    "mdi:view-dashboard": 0xF56E,
    "mdi:view-dashboard-outline": 0xFA1C,
    "mdi:view-dashboard-variant": 0xF842,
    "mdi:view-day": 0xF56F,
    "mdi:view-grid": 0xF570,
    "mdi:view-grid-outline": 0xF0204,
    "mdi:view-grid-plus": 0xFFAA,
    "mdi:view-grid-plus-outline": 0xF0205,
    "mdi:view-headline": 0xF571,
    "mdi:view-list": 0xF572,
    "mdi:view-module": 0xF573,
    "mdi:view-parallel": 0xF727,
    "mdi:view-quilt": 0xF574,
    "mdi:view-sequential": 0xF728,
    "mdi:view-split-horizontal": 0xFBA7,
    "mdi:view-split-vertical": 0xFBA8,
    "mdi:view-stream": 0xF575,
    "mdi:view-week": 0xF576,
    "mdi:vimeo": 0xF577,
    "mdi:violin": 0xF60F,
    "mdi:virtual-reality": 0xF893,
    "mdi:visual-studio": 0xF610,
    "mdi:visual-studio-code": 0xFA1D,
    "mdi:vk": 0xF579,
    "mdi:vk-box": 0xF57A,
    "mdi:vk-circle": 0xF57B,
    "mdi:vlc": 0xF57C,
    "mdi:voice": 0xF5CB,
    "mdi:voice-off": 0xFEF1,
    "mdi:voicemail": 0xF57D,
    "mdi:volleyball": 0xF9B3,
    "mdi:volume-high": 0xF57E,
    "mdi:volume-low": 0xF57F,
    "mdi:volume-medium": 0xF580,
    "mdi:volume-minus": 0xF75D,
    "mdi:volume-mute": 0xF75E,
    "mdi:volume-off": 0xF581,
    "mdi:volume-plus": 0xF75C,
    "mdi:volume-source": 0xF014B,
    "mdi:volume-variant-off": 0xFE68,
    "mdi:volume-vibrate": 0xF014C,
    "mdi:vote": 0xFA1E,
    "mdi:vote-outline": 0xFA1F,
    "mdi:vpn": 0xF582,
    "mdi:vuejs": 0xF843,
    "mdi:vuetify": 0xFE50,
    "mdi:walk": 0xF583,
    "mdi:wall": 0xF7FD,
    "mdi:wall-sconce": 0xF91B,
    "mdi:wall-sconce-flat": 0xF91C,
    "mdi:wall-sconce-variant": 0xF91D,
    "mdi:wallet": 0xF584,
    "mdi:wallet-giftcard": 0xF585,
    "mdi:wallet-membership": 0xF586,
    "mdi:wallet-outline": 0xFBB9,
    "mdi:wallet-plus": 0xFFAB,
    "mdi:wallet-plus-outline": 0xFFAC,
    "mdi:wallet-travel": 0xF587,
    "mdi:wallpaper": 0xFE69,
    "mdi:wan": 0xF588,
    "mdi:wardrobe": 0xFFAD,
    "mdi:wardrobe-outline": 0xFFAE,
    "mdi:warehouse": 0xFFBB,
    "mdi:washing-machine": 0xF729,
    "mdi:washing-machine-alert": 0xF01E7,
    "mdi:washing-machine-off": 0xF01E8,
    "mdi:watch": 0xF589,
    "mdi:watch-export": 0xF58A,
    "mdi:watch-export-variant": 0xF894,
    "mdi:watch-import": 0xF58B,
    "mdi:watch-import-variant": 0xF895,
    "mdi:watch-variant": 0xF896,
    "mdi:watch-vibrate": 0xF6B0,
    "mdi:watch-vibrate-off": 0xFCB6,
    "mdi:water": 0xF58C,
    "mdi:water-boiler": 0xFFAF,
    "mdi:water-boiler-alert": 0xF01DE,
    "mdi:water-boiler-off": 0xF01DF,
    "mdi:water-off": 0xF58D,
    "mdi:water-outline": 0xFE6A,
    "mdi:water-percent": 0xF58E,
    "mdi:water-pump": 0xF58F,
    "mdi:water-pump-off": 0xFFB0,
    "mdi:water-well": 0xF008D,
    "mdi:water-well-outline": 0xF008E,
    "mdi:watermark": 0xF612,
    "mdi:wave": 0xFF4B,
    "mdi:waves": 0xF78C,
    "mdi:waze": 0xFBBA,
    "mdi:weather-cloudy": 0xF590,
    "mdi:weather-cloudy-alert": 0xFF4C,
    "mdi:weather-cloudy-arrow-right": 0xFE51,
    "mdi:weather-fog": 0xF591,
    "mdi:weather-hail": 0xF592,
    "mdi:weather-hazy": 0xFF4D,
    "mdi:weather-hurricane": 0xF897,
    "mdi:weather-lightning": 0xF593,
    "mdi:weather-lightning-rainy": 0xF67D,
    "mdi:weather-night": 0xF594,
    "mdi:weather-night-partly-cloudy": 0xFF4E,
    "mdi:weather-partly-cloudy": 0xF595,
    "mdi:weather-partly-lightning": 0xFF4F,
    "mdi:weather-partly-rainy": 0xFF50,
    "mdi:weather-partly-snowy": 0xFF51,
    "mdi:weather-partly-snowy-rainy": 0xFF52,
    "mdi:weather-pouring": 0xF596,
    "mdi:weather-rainy": 0xF597,
    "mdi:weather-snowy": 0xF598,
    "mdi:weather-snowy-heavy": 0xFF53,
    "mdi:weather-snowy-rainy": 0xF67E,
    "mdi:weather-sunny": 0xF599,
    "mdi:weather-sunny-alert": 0xFF54,
    "mdi:weather-sunset": 0xF59A,
    "mdi:weather-sunset-down": 0xF59B,
    "mdi:weather-sunset-up": 0xF59C,
    "mdi:weather-tornado": 0xFF55,
    "mdi:weather-windy": 0xF59D,
    "mdi:weather-windy-variant": 0xF59E,
    "mdi:web": 0xF59F,
    "mdi:web-box": 0xFFB1,
    "mdi:webcam": 0xF5A0,
    "mdi:webhook": 0xF62F,
    "mdi:webpack": 0xF72A,
    "mdi:wechat": 0xF611,
    "mdi:weight": 0xF5A1,
    "mdi:weight-gram": 0xFD1B,
    "mdi:weight-kilogram": 0xF5A2,
    "mdi:weight-lifter": 0xF0188,
    "mdi:weight-pound": 0xF9B4,
    "mdi:whatsapp": 0xF5A3,
    "mdi:wheelchair-accessibility": 0xF5A4,
    "mdi:whistle": 0xF9B5,
    "mdi:white-balance-auto": 0xF5A5,
    "mdi:white-balance-incandescent": 0xF5A6,
    "mdi:white-balance-iridescent": 0xF5A7,
    "mdi:white-balance-sunny": 0xF5A8,
    "mdi:widgets": 0xF72B,
    "mdi:wifi": 0xF5A9,
    "mdi:wifi-off": 0xF5AA,
    "mdi:wifi-star": 0xFE6B,
    "mdi:wifi-strength-1": 0xF91E,
    "mdi:wifi-strength-1-alert": 0xF91F,
    "mdi:wifi-strength-1-lock": 0xF920,
    "mdi:wifi-strength-2": 0xF921,
    "mdi:wifi-strength-2-alert": 0xF922,
    "mdi:wifi-strength-2-lock": 0xF923,
    "mdi:wifi-strength-3": 0xF924,
    "mdi:wifi-strength-3-alert": 0xF925,
    "mdi:wifi-strength-3-lock": 0xF926,
    "mdi:wifi-strength-4": 0xF927,
    "mdi:wifi-strength-4-alert": 0xF928,
    "mdi:wifi-strength-4-lock": 0xF929,
    "mdi:wifi-strength-alert-outline": 0xF92A,
    "mdi:wifi-strength-lock-outline": 0xF92B,
    "mdi:wifi-strength-off": 0xF92C,
    "mdi:wifi-strength-off-outline": 0xF92D,
    "mdi:wifi-strength-outline": 0xF92E,
    "mdi:wii": 0xF5AB,
    "mdi:wiiu": 0xF72C,
    "mdi:wikipedia": 0xF5AC,
    "mdi:wind-turbine": 0xFD81,
    "mdi:window-close": 0xF5AD,
    "mdi:window-closed": 0xF5AE,
    "mdi:window-closed-variant": 0xF0206,
    "mdi:window-maximize": 0xF5AF,
    "mdi:window-minimize": 0xF5B0,
    "mdi:window-open": 0xF5B1,
    "mdi:window-open-variant": 0xF0207,
    "mdi:window-restore": 0xF5B2,
    "mdi:window-shutter": 0xF0147,
    "mdi:window-shutter-alert": 0xF0148,
    "mdi:window-shutter-open": 0xF0149,
    "mdi:windows": 0xF5B3,
    "mdi:windows-classic": 0xFA20,
    "mdi:wiper": 0xFAE8,
    "mdi:wiper-wash": 0xFD82,
    "mdi:wordpress": 0xF5B4,
    "mdi:worker": 0xF5B5,
    "mdi:wrap": 0xF5B6,
    "mdi:wrap-disabled": 0xFBBB,
    "mdi:wrench": 0xF5B7,
    "mdi:wrench-outline": 0xFBBC,
    "mdi:wunderlist": 0xF5B8,
    "mdi:xamarin": 0xF844,
    "mdi:xamarin-outline": 0xF845,
    "mdi:xaml": 0xF673,
    "mdi:xbox": 0xF5B9,
    "mdi:xbox-controller": 0xF5BA,
    "mdi:xbox-controller-battery-alert": 0xF74A,
    "mdi:xbox-controller-battery-charging": 0xFA21,
    "mdi:xbox-controller-battery-empty": 0xF74B,
    "mdi:xbox-controller-battery-full": 0xF74C,
    "mdi:xbox-controller-battery-low": 0xF74D,
    "mdi:xbox-controller-battery-medium": 0xF74E,
    "mdi:xbox-controller-battery-unknown": 0xF74F,
    "mdi:xbox-controller-menu": 0xFE52,
    "mdi:xbox-controller-off": 0xF5BB,
    "mdi:xbox-controller-view": 0xFE53,
    "mdi:xda": 0xF5BC,
    "mdi:xing": 0xF5BD,
    "mdi:xing-box": 0xF5BE,
    "mdi:xing-circle": 0xF5BF,
    "mdi:xml": 0xF5C0,
    "mdi:xmpp": 0xF7FE,
    "mdi:yahoo": 0xFB2A,
    "mdi:yammer": 0xF788,
    "mdi:yeast": 0xF5C1,
    "mdi:yelp": 0xF5C2,
    "mdi:yin-yang": 0xF67F,
    "mdi:yoga": 0xF01A7,
    "mdi:youtube": 0xF5C3,
    "mdi:youtube-creator-studio": 0xF846,
    "mdi:youtube-gaming": 0xF847,
    "mdi:youtube-subscription": 0xFD1C,
    "mdi:youtube-tv": 0xF448,
    "mdi:z-wave": 0xFAE9,
    "mdi:zend": 0xFAEA,
    "mdi:zigbee": 0xFD1D,
    "mdi:zip-box": 0xF5C4,
    "mdi:zip-box-outline": 0xF001B,
    "mdi:zip-disk": 0xFA22,
    "mdi:zodiac-aquarius": 0xFA7C,
    "mdi:zodiac-aries": 0xFA7D,
    "mdi:zodiac-cancer": 0xFA7E,
    "mdi:zodiac-capricorn": 0xFA7F,
    "mdi:zodiac-gemini": 0xFA80,
    "mdi:zodiac-leo": 0xFA81,
    "mdi:zodiac-libra": 0xFA82,
    "mdi:zodiac-pisces": 0xFA83,
    "mdi:zodiac-sagittarius": 0xFA84,
    "mdi:zodiac-scorpio": 0xFA85,
    "mdi:zodiac-taurus": 0xFA86,
    "mdi:zodiac-virgo": 0xFA87,
    "mdi:blank": 0xf68c,
  };

  /*static Widget createIconWidgetFromEntityData(EntityWrapper data, double size, Color color) {
    if (data == null) {
      return null;
    }
    if (data.entity.entityPicture != null) {
      if (homeAssistantWebHost != null) {
        return CircleAvatar(
          radius: size/2,
          backgroundColor: Colors.white,
          backgroundImage: CachedNetworkImageProvider(
            "$homeAssistantWebHost${data.entity.entityPicture}",
          ),
        );
      } else {
        return Container(width: 0.0, height: 0.0);
      }
    } else {
      String iconName = data.icon;
      int iconCode = 0;
      if (iconName.length > 0) {
        iconCode = getIconCodeByIconName(iconName);
      } else {
        iconCode = getDefaultIconByEntityId(data.entity.entityId,
            data.entity.deviceClass, data.entity.state); //
      }
      return Icon(
        IconData(iconCode, fontFamily: 'Material Design Icons'),
        size: size,
        color: color,
      );
    }
  }*/

  static IconData getIconDataFromIconCode(int code) {
    return IconData(code, fontFamily: 'Material Design Icons');
  }

  static IconData getIconDataFromIconName(String name) {
    return IconData(getIconCodeByIconName(name), fontFamily: 'Material Design Icons');
  }

  static int getIconCodeByIconName(String name) {
    return iconsDataMap[name] ?? 0;
  }

  /*static int getDefaultIconByEntityId(String entityId, String deviceClass, String state) {
    String domain = entityId.split(".")[0];
    String iconNameByDomain = _defaultIconsByDomains["$domain.$state"] ?? _defaultIconsByDomains["$domain"];
    String iconNameByDeviceClass;
    if (deviceClass != null) {
      iconNameByDeviceClass = _defaultIconsByDeviceClass["$domain.$deviceClass.$state"] ?? _defaultIconsByDeviceClass["$domain.$deviceClass"];
    }
    String iconName = iconNameByDeviceClass ?? iconNameByDomain;
    if (iconName != null) {
      return _iconsDataMap[iconName] ?? 0;
    } else {
      return 0;
    }
  }*/

}